
!--------------------------------------
!
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!		Compact Modelling Framework	
!			CMF2.0
!
! authors: 
!	2013.08.07 / Kalmykov, Vladimir, IO RAS, Russia, vvk88@mail.ru
!
! reference:
!	Kalmykov V.V., Ibrayev R.A., 2013. 
!		A framework for the ocean-ice-atmosphere-land coupled modeling on massively-parallel architectures. 
!		Vychisl. Metody Programm., 2013, v. 14, iss. 3, 88-95. 
!	Kalmykov V.V., Ibrayev R.A., 2013. 
!		A framework for the ocean-ice-atmosphere-land coupled modeling on massively-parallel architectures. 
!		Certificate of state registration of the computer progam number 2013619320. 
!		Date of state registration in the Registry of the computer programs October 1, 2013
!--------------------------------------


!==========================================================
! This file contains templates for send and recv operations
! in c_gd_module for providing single code for different 
! types of data
!==========================================================

#ifdef SEND
		integer t, numf
		integer cur_kl, cur_ml

		if (numf == 0) return
		call fakeKlMl(t,comp_kl, comp_ml, cur_kl,cur_ml)
				
		do s = 1, c_inf(comp) % wk(me) % slave_count
		
		sr_counter = 1
		do func = 1, numf
			do m = 1, cur_ml
			do k = 1, cur_kl
			do j = j_s_coord(s), j_s_coord(s) + jl_belt(s)-1
			do i = i_s_coord(s), i_s_coord(s) + il_belt(s)-1
				packT(sr_counter,s) = stripeT(length_2D(s)*cur_kl*(m-1) + length_2D(s)*(k-1) + (j-1)*comp_il + i, func)
				sr_counter = sr_counter + 1
			end do
			end do
			end do
			end do
		end do
			
		call MPI_ISSEND(packT(1,s) ,													&
				numf*il_belt(s)*jl_belt(s)*cur_kl*cur_ml, 								&
				mpiType,	 															&
				c_inf(comp) % wk(me) % slave_start + s - 1,							&
				shared_mpi_tags(c_events(c_ev_num) % act, c_events(c_ev_num) % src),	&
				MPI_COMM_WORLD,															&
				c_request_distr(s), ierr)	
		end do
		
		call MPI_WAITALL(c_inf(comp) % wk(me) % slave_count, c_request_distr, c_status_distr, ierr)
#undef SEND
#endif



#ifdef RECV
		integer t, numf
		integer cur_kl, cur_ml

		if (numf == 0) return
		call fakeKlMl(t,comp_kl, comp_ml, cur_kl,cur_ml)

		do s = 1, c_inf(comp) % wk(me) % slave_count			
			call MPI_IRECV(	packT(1,s),													&
				numf*il_belt(s)*jl_belt(s)*cur_kl*cur_ml,								&	
				mpiType,	 															&
				c_inf(comp) % wk(me) % slave_start + s - 1,							&
				shared_mpi_tags(c_events(c_ev_num) % act, c_events(c_ev_num) % dst),	&
				MPI_COMM_WORLD,															&
				c_request_gather(s), ierr)	
		end do
			
		do s = 1, c_inf(comp) % wk(me) % slave_count
			call MPI_WAITALL (1, c_request_gather(s), st, ierr)
			sr_counter = 1
			do func = 1, numf
				do m = 1, cur_ml
				do k = 1, cur_kl
				do j = j_s_coord(s), j_s_coord(s) + jl_belt(s)-1
				do i = i_s_coord(s), i_s_coord(s) + il_belt(s)-1
					stripeT(length_2D(s)*cur_kl*(m-1) + length_2D(s)*(k-1) + (j-1)*comp_il + i, func) = packT(sr_counter,s)
					sr_counter = sr_counter + 1
				end do
				end do
				end do
				end do
			end do
		end do
#undef RECV
#endif