
!--------------------------------------
!
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!		Compact Modelling Framework	
!			CMF2.0
!
! authors: 
!	2013.08.07 / Kalmykov, Vladimir, IO RAS, Russia, vvk88@mail.ru
!
! reference:
!	Kalmykov V.V., Ibrayev R.A., 2013. 
!		A framework for the ocean-ice-atmosphere-land coupled modeling on massively-parallel architectures. 
!		Vychisl. Metody Programm., 2013, v. 14, iss. 3, 88-95. 
!	Kalmykov V.V., Ibrayev R.A., 2013. 
!		A framework for the ocean-ice-atmosphere-land coupled modeling on massively-parallel architectures. 
!		Certificate of state registration of the computer progam number 2013619320. 
!		Date of state registration in the Registry of the computer programs October 1, 2013
!--------------------------------------



!==================================================================
! This template process pack operation for send-recv component data
! Note, that it copies some REAL(8) data to REAL(4) buffers for 
! performance reasons (ASSOCIATED controls it, trying then PTRd)
!==================================================================

	call fakeKlMl(ARR_TYPE,cmp % k_size,cmp % m_size, cur_kl, cur_ml)

! Allow cross type assigns
#ifndef PTRd 
#define PTRd PTR
#endif

#ifdef SEND
	c = 1		
	do f = 1, cmp % inf(cmp % me, send_to, action, ARR_TYPE) % ar_size
		if (ASSOCIATED(cmp % inf(cmp % me, send_to,action, ARR_TYPE) % ar(f) % PTR)) then
			do m = 1, cur_ml
			do k = 1, cur_kl
			do j = 1, cmp % j_loc_size
			do i = 1, cmp % i_loc_size
				BUF(c) = cmp % inf(cmp % me, send_to,action, ARR_TYPE) % ar(f) % PTR(IND)
				c = c + 1
			end do
			end do
			end do
			end do
		else
			do m = 1, cur_ml
			do k = 1, cur_kl
			do j = 1, cmp % j_loc_size
			do i = 1, cmp % i_loc_size
				BUF(c) = cmp % inf(cmp % me, send_to,action, ARR_TYPE) % ar(f) % PTRd(IND)
				c = c + 1
			end do
			end do
			end do
			end do
		end if
		
	end do
#endif

#ifdef RECV
	c = 1
	do f = 1, cmp % inf(recv_from,cmp % me, action, ARR_TYPE) % ar_size
		if (ASSOCIATED(cmp % inf(recv_from,cmp % me,action, ARR_TYPE) % ar(f) % PTR)) then
			do m = 1, cur_ml
			do k = 1, cur_kl
			do j = 1, cmp % j_loc_size
			do i = 1, cmp % i_loc_size
				cmp % inf(recv_from,cmp % me,action, ARR_TYPE) % ar(f) % PTR(IND) = BUF(c)
				c = c + 1
			end do
			end do
			end do
			end do
		else
			do m = 1, cur_ml
			do k = 1, cur_kl
			do j = 1, cmp % j_loc_size
			do i = 1, cmp % i_loc_size
				cmp % inf(recv_from,cmp % me,action, ARR_TYPE) % ar(f) % PTRd(IND) = BUF(c)
				c = c + 1
			end do
			end do
			end do
			end do
		end if
	end do
#endif

#undef ARR_TYPE
#undef BUF
#undef IND
#undef PTR
#undef PTRd
