module CONCRETE_MODULE_FLIBS
    use CONCRETE_MODULE, VECTOR_DATA => CONCRETE_TYPE, &
                         empty_vector_data => EMPTY_DATA
    implicit none    
    include "vectors.f90"
end module

    
module OUTPUT_MODULE

    use CONCRETE_MODULE_FLIBS        
    implicit none

    
    type, public :: VectorStorage
    private
        type(VECTOR) :: vector_

      contains

        procedure, public :: init => init_storage
        procedure, public :: destroy => destroy_storage

        procedure, public :: append
        procedure, public :: put_at
        procedure, public :: delete
        
        procedure, public :: get
        procedure, public :: length => length_storage
    
    end type

 CONTAINS

subroutine init_storage(this)
    class(VectorStorage) :: this
    type(VECTOR_DATA) :: data
    
    call vector_create(this % vector_, 2)    
end subroutine

subroutine destroy_storage(this)
    class(VectorStorage) :: this
    
    call vector_destroy(this % vector_)        
end subroutine

subroutine append(this, node)
    class(VectorStorage) :: this
    type(VECTOR_DATA), intent(in) :: node
    
    call vector_append(this % vector_, node)
end subroutine

subroutine put_at(this, ind, node)
    class(VectorStorage) :: this
    integer, intent(in) :: ind
    type(VECTOR_DATA), intent(in) :: node
    
    call vector_put(this % vector_, ind, node)
end subroutine

subroutine delete(this, ind, num)
    class(VectorStorage) :: this
    integer, intent(in) :: ind, num

    call vector_delete_elements(this % vector_, ind, num)

end subroutine



type(VECTOR_DATA) function get(this, ind)
    class(VectorStorage) :: this
    integer, intent(in) :: ind

    get = vector_at(this % vector_, ind)
end function

integer function length_storage(this)
    class(VectorStorage) :: this
    
    length_storage = vector_size(this % vector_)
end function


end module

#undef CONCRETE_TYPE
#undef CONCRETE_MODULE
#undef CONCRETE_MODULE_FLIBS
#undef OUTPUT_MODULE