program test_datetime
    use test_manager_module
    use clock_module
    implicit none
    
    type(TestManager) :: tm
    type(Clock) :: clock_model
    type(DateTime) :: dat, dat2
    integer :: i
    
    call tm % init("seq")
   
    call clock_model % set(start_dt = DateTime(1980, 1, 1, 0,0,0), &
                           end_dt =   DateTime(1980, 1, 1, 1,10,0), &
                           dh = 0, dm = 10, ds = 0)

    call tm % assert(.NOT. clock_model % is_stopped(), "clock is not stopped")
    
    call tm % assert(clock_model % current_datetime() == DateTime(1980, 1, 1, 0,0,0), "now date is equal start_dt")
    
    do i = 1, 7
        call clock_model % tick()
    end do
    call tm % assert(clock_model % current_datetime() == DateTime(1980, 1, 1, 1,10,0) , "after 7 ticks date is equal to end_dt")   
        
    call tm % assert(clock_model % is_stopped(), "clock is stopped")
        
    call tm % report_tests()
    
end