    
program test_file_handler_nc
    use component_splitter_module
    use test_manager_module
        
    implicit none

    type(TestManager) :: tm
    integer, allocatable :: procs(:)

    call CompSplitter % set_run_phase("SHR")    
    call CompSplitter % init(COMMAND_ARGUMENT_COUNT()/2)
    
    call tm % init("par")
    
    call tm % assert(CompSplitter % comp_launched() == 5, "number of launched components...")
    
    call tm % assert(CompSplitter % comm_local_size("OCN") == 6, "number of processes in OCN...")

    call tm % assert(CompSplitter % comm_local_size("ATM") == 4, "number of processes in ATM...")
    
    call tm % assert(CompSplitter % proc_first("ICE") == 13, "first process of ICE...")
        
    call CompSplitter % proc_list(name = "ATM", list = procs)
    call tm % assert(ALL(procs == (/ 9, 10, 11, 12 /)), "list of ATM processes...")
    deallocate(procs)
    
    call tm % report_tests()
    
    call CompSplitter % destroy()
    
end program