#define GA_IS 8     ! GA Integer Size 8 or 4
   
program test_ga_spd_invert
   
    implicit none
#include "mafdecls.fh"
#include "global.fh"    
    
    integer :: rank1, rank2, group1, ga_id1,ga_id2,ga_id3

    real(8) :: test_matrix(2,2)
    integer :: status
          
!========================================================================================    
    
    ! Init ga, create subgroup (group1), which has only rank 0 
    call GA_INITIALIZE()
    
    if (.NOT. MA_INIT( int(MT_F_REAL, GA_IS), int(30000, GA_IS), int(30000, GA_IS))) then
        write(*,*) "GA: cant init enough memory."
        call exit(1)
    end if
        
    rank1 = 0
    group1 = GA_PGROUP_CREATE( int((/rank1/), GA_IS), int(1, GA_IS) )
  
!========================================================================================  
  
    ! Only rank 0 create GA-array, put some test data to it and try to invert (error there)
    if (GA_NODEID() == 0) then
    
        call GA_PGROUP_SET_DEFAULT( int(group1, GA_IS) )
    
        ga_id1 = int( GA_CREATE_HANDLE(), GA_IS)
        ga_id2 = int( GA_CREATE_HANDLE(), GA_IS)
        ga_id3 = int( GA_CREATE_HANDLE(), GA_IS)
        call GA_SET_ARRAY_NAME(int( ga_id1, GA_IS), "test_dgemm1")
        call GA_SET_ARRAY_NAME(int( ga_id2, GA_IS), "test_dgemm2")
        call GA_SET_ARRAY_NAME(int( ga_id3, GA_IS), "test_dgemm_res")
        call GA_SET_DATA(int( ga_id1, GA_IS), int(2, GA_IS), int( (/ 2, 2 /), GA_IS), int(MT_F_DBL, GA_IS) )
        call GA_SET_DATA(int( ga_id2, GA_IS), int(2, GA_IS), int( (/ 2, 2 /), GA_IS), int(MT_F_DBL, GA_IS) )
        call GA_SET_DATA(int( ga_id3, GA_IS), int(2, GA_IS), int( (/ 2, 2 /), GA_IS), int(MT_F_DBL, GA_IS) )
        status = GA_ALLOCATE( int(ga_id1, GA_IS) )
        status = GA_ALLOCATE( int(ga_id2, GA_IS) )
        status = GA_ALLOCATE( int(ga_id3, GA_IS) )

        test_matrix(1,1) = 3.
        test_matrix(2,2) = 2

        call NGA_PUT(int(ga_id1, GA_IS), int((/ 1, 1 /), GA_IS), int((/ 2, 2 /), GA_IS), test_matrix, int((/ SIZE(test_matrix, 1) /) , GA_IS) )
        test_matrix = 1
        call NGA_PUT(int(ga_id2, GA_IS), int((/ 1, 1 /), GA_IS), int((/ 2, 2 /), GA_IS), test_matrix, int((/ SIZE(test_matrix, 1) /) , GA_IS) )

        call ga_print( int( ga_id1, GA_IS) )
        call ga_print( int( ga_id2, GA_IS) )
        call GA_dgemm(  "n", "n", int(2,GA_IS),int(2,GA_IS),int(2,GA_IS), dble(1.), &
                        int( ga_id1, GA_IS), int( ga_id2, GA_IS), &
                        dble(0.), int( ga_id3, GA_IS)   )
        call ga_print( int( ga_id3, GA_IS) )

        ! Error: stuck here

        write(*,*) "OK"
    end if
    
!========================================================================================  

    ! Set group to global again and terminate GA
     call GA_PGROUP_SET_DEFAULT( int( GA_PGROUP_GET_WORLD(), GA_IS))
     call GA_TERMINATE()      
     
     
end program
