    
program test_file_handler_nc
    use mpi
    implicit none
#include "mafdecls.fh"
#include "global.fh"
    
    integer :: ocn_id, cpl_id, size_world, rank, ierr, ga_2D_id, ga_info_id, status
    integer :: holder_size, subscriber_size, shared_group_id, i
    
    integer, parameter :: DIM_SIZE = 1000
    real(4) :: buffer(DIM_SIZE,  DIM_SIZE)
            
! =======================================
! Initialization and memory allocation
!=======================================
    call MPI_INIT (ierr)
    call MPI_COMM_SIZE(MPI_COMM_WORLD, size_world, ierr)
    call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

    call GA_INITIALIZE()
    if (.NOT. MA_INIT(MT_F_REAL, 10000, 10000)) then
        write(*,*) "Cant init enough memory."
        call exit(1)
    end if

!=======================================
! Create 2D GA
!=======================================
    ga_2D_id = init_2D_array("test")
    if(GA_NODEID() == 0) call GA_SUMMARIZE(.true.)

!=======================================
! Error while putting data proc by proc
!=======================================
    buffer = rank
    do i = 0, size_world-1
        if (rank == i) then
            write(*,*) "Rank ", i, " before put"
            ! Put global buffer by every processor (Error: everything stucks)
            call NGA_PUT(ga_2D_id, (/ 1, 1 /), (/ DIM_SIZE, DIM_SIZE /), buffer, (/ SIZE(buffer, 1) /))
           
            ! Put 1 element by every processor (Error: RMCI DASSERT fail. src/devices/openib/openib.c:armci_vapi_post_send():2554 cond:(rc==0))
            ! call NGA_PUT(ga_2D_id, (/ 1, 1 /), (/ 1, 1 /), buffer(1,1), (/ SIZE(buffer, 1) /))
            
            write(*,*) "Rank ", i, " after put"
        end if
        call MPI_BARRIER(MPI_COMM_WORLD, ierr)
    end do
    
!=======================================
! Finalizing routines
!=======================================
    call GA_TERMINATE()          
    
 contains    
  
    integer function init_2D_array(arr_name)
        character(*), intent(in) :: arr_name
        integer :: ga_id, status
        
        ga_id = GA_CREATE_HANDLE()
        call GA_SET_ARRAY_NAME(ga_id, arr_name)
        call GA_SET_DATA(ga_id, 2, (/ DIM_SIZE, DIM_SIZE /), MT_F_REAL)                    
        status = GA_ALLOCATE(ga_id)   
        init_2D_array = ga_id
        
    end function
!     
    
end program