program test_model_info
    use model_info_module
    use test_manager_module
    use component_splitter_module
    implicit none 
    
    type(TestManager) :: tm   
    type(Decomposition) :: dec

    call CompSplitter % init(COMMAND_ARGUMENT_COUNT()/2)
    
    call tm % init("par")    

    if (CompSplitter % i_am() == "OCN") then    
        dec = Decomposition(180, 90, 50, "2D", proc_count = CompSplitter % comm_local_size(), rank_local = CompSplitter % rank_local())
        ModelsInfo(CompSplitter % i_am_id()) = ModelInfo("OCN", "OCN_INMIO", dec, 0)        
        call tm % assert(ModelsInfo(CompSplitter % i_am_id()) % model_name() == "OCN_INMIO", "initialization")        

    else if (CompSplitter % i_am() == "ATM") then

        dec = Decomposition(80, 40, 10, "2D", proc_count = CompSplitter % comm_local_size(), rank_local = CompSplitter % rank_local())
        ModelsInfo(CompSplitter % i_am_id()) = ModelInfo("ATM", "ATM_NCAR", dec, 0)       
        call tm % assert(ModelsInfo(CompSplitter % i_am_id()) % model_name() == "ATM_NCAR", "initialization")        
    else
        call tm % assert(.TRUE., "initialization")
    end if

    call model_info_synchronize()
    call tm % assert(.TRUE., "synchronize")
    
    call tm % assert(ModelsInfo(CompSplitter % comp_id("OCN")) % model_name() == "OCN_INMIO", "check if everybody know OCN model name")
    call tm % assert(ModelsInfo(CompSplitter % comp_id("ATM")) % comp_name() == "ATM", "check if everybody know ATM comp name")

    dec = ModelsInfo(CompSplitter % comp_id("OCN")) % decomp()
    call tm % assert(dec % i_size() == 180, "check if everybody know OCN decomp")
    
    dec = ModelsInfo(CompSplitter % comp_id("ATM")) % decomp()
    call tm % assert(dec % j_size() == 40, "check if everybody know ATM decomp")
    
    call tm % report_tests()
    call tm % destroy()
    
end program