    
program test_file_handler_nc
    use file_handler_nc_module
    use test_manager_module
    use decomposition_module
    use point_saver_module
    use clock_module
    use statistics_module

    implicit none

    type(FileHandler_NC) :: handler
    type(TestManager) :: tm
    type(Clock) :: clock_model
    type(PointSaver) :: ps
    real(8) :: i
    
    call CompSplitter % init(COMMAND_ARGUMENT_COUNT()/2)
    call tm % init("par")

    !=====================================================
    ! Initialize
    !=====================================================
    
    if (tm % rank() == 0) call SYSTEM("rm -f *.nc")
    call Stats % init()
    
    !=====================================================
    ! Test
    !=====================================================

    call clock_model % set(start_dt = DateTime(1980, 1, 1, 0, 0, 0), &
                           end_dt =   DateTime(1980, 1, 1, 1, 0, 0), &
                           dh = 0, dm = 0, ds = 1)

    call ps % init("var1", 100)
    i = 0           
    
    call Stats % init_time_mark("test", "GLB")    
 
    do while (.NOT. clock_model % is_stopped())
        
        call ps % put(i, clock_model % current_datetime())
        i = i + 1.
        call clock_model % tick()
    end do
    
    call ps % destroy()
    
    call Stats % print_time_dif("test", msg = "Writing 3600 records with time: ")
    
    !=====================================================
    ! Finalize
    !=====================================================    
    call tm % report_tests()
    
    call tm % destroy()    
        
end
