#include "o_defines.f90"


!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	module for basic variables 
!
! authors: 
!	2010.05 / Ibrayev, Rashit, INM RAS, Russia, ibrayev@mail.ru 
!	2015.07 / Ushakov, Konstantin, IO RAS, Russia, ushakovkv@mail.ru
!
!--------------------------------------

!===============================================
! Contains variables used throughout the program
!===============================================

	module o_basic_module
	save
		
	! Solution
	real (kind=main_kind), allocatable:: u_c	(:,:,:)
	real (kind=main_kind), allocatable:: v_c	(:,:,:)
	real (kind=main_kind), allocatable:: w		(:,:,:)
	real (kind=main_kind), allocatable:: t_c	(:,:,:,:)
	real (kind=main_kind), allocatable:: q_c	(:,:,:,:)
	real (kind=main_kind), allocatable:: d_c	(:,:,:)
	real (kind=main_kind), allocatable:: d_potential_c(:,:,:)
	real (kind=8), allocatable:: ssl_c	(:,:)

! Mask of the region
	real (kind=4), allocatable:: cv	(:,:,:)
	real (kind=4), allocatable:: ct3	(:,:,:)

	real (kind=8) seash
	real (kind=main_kind) :: S_ref=0.	!reference value for salt (to calculate S as anomaly)
	end module o_basic_module


	subroutine allocate_o_basic_module
	use o_grid_module
	use o_basic_module
	implicit none

! Solution
	allocate (u_c 	(kl  ,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate (v_c 	(kl  ,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate (w	(kl+1,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate (t_c 	(kl  ,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1, ml))
	allocate (d_c	(kl  ,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate (d_potential_c (kl  ,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))	
	allocate (ssl_c	(iwest (myrank)-2:ieast (myrank)+2, jsouth(myrank)-2:jnorth(myrank)+2)    )
	u_c	= 0.
	v_c	= 0.
	w	= 0.
	t_c	= 0.
	d_c	= 0.
	d_potential_c= 0.
	ssl_c	= 0.
! Mask of the region
	allocate (cv	(kl+1,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1) )
	allocate (ct3	(kl+1,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1) )
	cv	= 0.
	ct3	= 0.

	seash	= 0.

	return
	end
