
!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	diagnostical parameters of solution 
!	Module defining variables needed for Meridional heat transport experiments
!
! authors: 
!	2017.07 / Ushakov, Konstantin, IO RAS, Russia, ushakovkv@mail.ru
! reference:
!	K. V. Ushakov, R. A. Ibraev, Physical Oceanography, 2018.
!--------------------------------------



#include "o_defines.f90"
module o_diagn_mht_module
	use o_grid_module
	use o_diagn_means_module
	save
    
	!declare heat transport arrays
	type(mean_field) :: mht_subgrid_u_mean,mht_subgrid_v_mean
	type(mean_field) :: mht_adv_u_mean,mht_adv_v_mean
	type(mean_field) :: ke_mean
    
	CONTAINS
  
	!subroutine called in o_drinver_ini_allocate
	subroutine o_diagn_mht_init
		call mht_subgrid_u_mean%init(is3d=.TRUE.)
		call mht_subgrid_v_mean%init(is3d=.TRUE.)
		call mht_adv_u_mean%init(is3d=.TRUE.)
		call mht_adv_v_mean%init(is3d=.TRUE.)
		call ke_mean%init(is3d=.TRUE.)
	end subroutine o_diagn_mht_init
	
end module o_diagn_mht_module