
!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	grid
!	area of horizontal face of box
!
! authors: 
!	2010.05 / Ibrayev, Rashit, INM RAS, Russia, ibrayev@mail.ru 
!	2015.07 / Ushakov, Konstantin, IO RAS, Russia, ushakovkv@mail.ru
!--------------------------------------

!===================================
! Areas of horizontal faces of boxes
!===================================

	subroutine o_ini_area_box

	use o_grid_module
    use o_par_module

	implicit none

!====================================
! Areas of horizontal face of v-boxes
!====================================

	area_vbox = 0.
	area_vbox_v = 0.

	do j=jsouth(myrank)	,jnorth(myrank)
	do i=iwest (myrank)	,ieast (myrank)
		if(kv(i,j) > 0) then
			area_vbox (i,j) =				&
     				(dx1_nw_v(i,j)*dx2_en_v(i-1,j)+	&
     				 dx2_es_v(i,j)*dx1_ne_v(i,j-1))+	&
     				(dx1_ne_v(i,j)*dx2_en_v(i,j)+		&
     				 dx2_es_v(i-1,j)*dx1_nw_v(i,j-1))
			area_vbox_v (i,j) = 1./area_vbox (i,j)
		end if
	end do
	end do

!====================================
! Areas of horizontal face of t-boxes
!====================================

	area_tbox = 0.
	area_tbox_v = 0.

	k = 1
	do j=jsouth(myrank)	,jnorth(myrank) + 1
	do i=iwest (myrank)	,ieast (myrank) + 1
		!if(kt(i,j) > 0) then		!tbox areas are needed on land for conservative flux translation
			area_tbox (i,j) =				&
     			(dx1_nw_t(i,j)*dx2_en_t(i-1,j) +    		&	
     			 dx2_es_t(i,j)*dx1_ne_t(i,j-1)) +		&
     			(dx1_ne_t(i,j)*dx2_en_t(i,j) +			&
     			dx2_es_t(i-1,j)*dx1_nw_t(i,j-1))
			area_tbox_v (i,j) = 1./area_tbox (i,j)
		!end if
	end do
	end do
	
#if CMF_VERSION == 2    
    call comp_halo_update_T8(DIM2_t = area_tbox,   update_width = 1, change_sign_on_bipolar = 1)
    call comp_halo_update_T8(DIM2_t = area_tbox_v, update_width = 1, change_sign_on_bipolar = 1)
#elif CMF_VERSION == 3
    call HaloUpdateMaster % update(area_tbox, update_width = 1, grid_type = 'T')
    call HaloUpdateMaster % update(area_tbox_v, update_width = 1, grid_type = 'T')
#endif	
	
	return
	end
