#include "o_defines.f90"


!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	initial conditions
!	T, S
!
! authors: 
!	2010.05 / Ibrayev, Rashit, INM RAS, Russia, ibrayev@mail.ru 
!--------------------------------------


!=========================================================
! Make artificial initial conditions in case of key_ic = 1
!=========================================================

	subroutine o_ini_convert

	use o_grid_module
	use o_basic_module
	use o_d_brcl_module
	use o_td_module

	implicit none

	real(kind=main_kind) press,theta_from_t,zero
!========================
! Calculate vertical grid
!========================
	call o_ini_set_grid_z

!========================
! Define test U, V, T & S
!========================
	u_c = 0.0
	v_c = 0.0

!	if(mltke /= 0) then
!		q_c = 0.
!	end if
		
	
		
	if(myrank==1) print *,'Initial T converting to potential temperature'
	zero=0 !need for correct argument passing to theta_from_t
	do j = jsouth(myrank)-1, jnorth(myrank)+1
	do i = iwest (myrank)-1, ieast (myrank)+1
	do k = 1, kl
		if(k <= kt(i,j)) then
			press=densit*gravit*z(k)*0.0001	
			t_c(k,i,j,1) = theta_from_t(t_c(k,i,j,2),t_c(k,i,j,1),press,zero)
		else
			t_c(k,i,j,:)=0.
		end if
	end do
	end do
	end do
	!stop
	
	return
	end
