
!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	grid
!	compute vertical grid variables
!
! authors: 
!	2010.05 / Ibrayev, Rashit, INM RAS, Russia, ibrayev@mail.ru 
!
!--------------------------------------

!===================================
! Define grid for vertical direction
!===================================

	subroutine o_ini_set_grid_z

	use o_grid_module

	implicit none

	call o_user_grid_z	
	
!============================
! Compute vertical grid steps
!============================

	zw  (1) = 0.
	hz  (1) = 2.*(z(1)-zw(1))
	hzv (1) = 1./hz(1)                                                  
	hzw (1) = 0.
	hzwv(1) = 0.

	do k = 2, kl+1                                                      
	      hz  (k) = z(k)-z(k-1)                                               
	      hzw (k) = (hz(k)+hz(k-1))/2.                                        
	      zw  (k) = (z(k)+z(k-1))/2.                                          
	      hzv (k) = 1./hz(k)
	      hzwv(k) = 1./hzw(k)                                                 
	end do

	do k = 1, kl
	      hkm(k) = hzwv(k+1)*hzv(k)
	      hkp(k) = hzwv(k+1)*hzv(k+1)
	end do

	return                                                            
	end                                                               

