
!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
! authors: 
!	2015.07 / Ushakov, Konstantin, IO RAS, Russia, ushakovkv@mail.ru
!--------------------------------------

		
	real(4) function o_shared_search_nearest(i_c,j_c,field, mis_value)
		use o_grid_module
		implicit none
		
		! Input variables
		integer i_c, j_c
		real(kind=4) field(iwest(myrank):ieast(myrank), jsouth(myrank):jnorth(myrank))
		real(kind=4) mis_value
		
		! Work variables
		integer rad
		integer s,n,w,e
		
		! Search with increasing radius
		do rad = 1, MAX(il,jl)
			s = MAX(j_c-rad, jsouth(myrank))
			n = MIN(j_c+rad, jnorth(myrank))
			w = MAX(i_c-rad, iwest(myrank))
			e = MIN(i_c+rad, ieast(myrank))
			
			! Get mean value of search result
			if(ANY(field(w:e, s:n) /= mis_value)) then
				o_shared_search_nearest = SUM(field(w:e, s:n), field(w:e, s:n) /= mis_value)/COUNT(field(w:e, s:n) /= mis_value)
				return
			end if
		end do
		
		! If we found nothing
		!o_shard_search_nearest = 0
		call ocn_error('Search nearest fail. Stop.', 'LCL')
		
	end function o_shared_search_nearest