#include "o_defines.f90"	


!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	ocean thermodynamic equations
!	govern the solving of eqautions
!
! authors: 
!	2010.05 / Ibrayev, Rashit, INM RAS, Russia, ibrayev@mail.ru 
!	2015.07 / Ushakov, Konstantin, IO RAS, Russia, ushakovkv@mail.ru
!--------------------------------------

!============================================================
! Drive the time integtation of 3d thermodynamics and scalars
!		scalar_scheme_time = 0 euler time-stepping
!		scalar_scheme_time = 1 leapfrog + euler time-stepping
!============================================================

	subroutine o_td_main(ocn_time_l)

	use o_basic_module
	use o_grid_module
	use o_d_brcl_module
	use o_td_module
	use o_diagn_mht_module
	use o_td_adv_cd
	use o_td_adv_fctz
	use o_td_mixing
	
	implicit none
	
	integer, intent(in) :: ocn_time_l

	if(its == 0) then
		t_f = t_c
		return
	end if

	if  (scalar_scheme_time.eq.0 .or. 
     &	(scalar_scheme_time.eq.1.and.mod(ocn_time_l-1,lmats).eq.0) ) then

			if (mixh_t_mode.ge.1)	call o_td_mixh_bh(mht_subgrid_u_mean,mht_subgrid_v_mean)

			if(scalar_scheme_advection.eq.0)	call o_td_scalar_advection_cd(1,u_c,v_c,t_c,mht_adv_u_mean,mht_adv_v_mean)
			if(scalar_scheme_advection.eq.1)	call o_td_scalar_advection_uw
			if(scalar_scheme_advection.eq.2)	call o_td_scalar_advection_fctz(1,t_c,t_c,dx3_t_c,mht_adv_u_mean,mht_adv_v_mean)
			if(scalar_scheme_advection.eq.3)	call o_td_scalar_advection_som(1,t_c,dx3_t_c)
			call o_td_scalar (1.)
	else

			if (mixh_t_mode.ge.1)	call o_td_mixh_bh(mht_subgrid_u_mean,mht_subgrid_v_mean)
			if(scalar_scheme_advection.eq.0)	call o_td_scalar_advection_cd(2,u_c,v_c,t_c,mht_adv_u_mean,mht_adv_v_mean)
			if(scalar_scheme_advection.eq.1)	call o_td_scalar_advection_uw
			if(scalar_scheme_advection.eq.2)	call o_td_scalar_advection_fctz(2,t_c,t_l,dx3_t_l,mht_adv_u_mean,mht_adv_v_mean)
			if(scalar_scheme_advection.eq.3)	call o_td_scalar_advection_som(2,t_l,dx3_t_l)
			call o_td_scalar (2.)
	end if
	return
	end
