
!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	ocean thermodynamic equations
!	atmosphere - ocean artificial fluxes
!
! authors: 
!	2015.07 / Ushakov, Konstantin, IO RAS, Russia, ushakovkv@mail.ru
!--------------------------------------


!~~~~~~~
	subroutine o_tf_flux_art
!~~~~~~~
	
	use o_tf_module
    use o_par_module
 

	implicit none

	call atm_user_fluxes	

#if CMF_VERSION == 2    
    call comp_halo_update_V4(DIM2_u = wind_stress_x_v, DIM2_v = wind_stress_y_v, update_width = 1, change_sign_on_bipolar = -1)
#elif CMF_VERSION == 3
    call HaloUpdateMaster % update(wind_stress_x_v, update_width = 1, grid_type = 'V', change_sign_on_bipolar = .TRUE.)
    call HaloUpdateMaster % update(wind_stress_y_v, update_width = 1, grid_type = 'V', change_sign_on_bipolar = .TRUE.)
#endif      	
	
	return
	end
