
!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	ocean thermodynamic equations
! 	air-sea parameters: artificial conditions for testing the model
!
! authors: 
!	2015.07 / Ushakov, Konstantin, IO RAS, Russia, ushakovkv@mail.ru
!--------------------------------------

	subroutine o_tf_par_art
	use o_grid_module
	use o_tf_module
    use o_par_module

	implicit none

	call atm_user_parameters
	
	if(bsc_flag==1) call ssc_tsc_rotate_t(	wind_speed_x_t,wind_speed_y_t,	wind_speed_x_t,wind_speed_y_t,	iwest(myrank)-1,ieast(myrank)+1,jsouth(myrank)-1,jnorth(myrank)+1)
	
#if CMF_VERSION == 2    
    call comp_halo_update_T4(DIM2_t = wind_speed_x_t, update_width = 1, change_sign_on_bipolar = -1)
    call comp_halo_update_T4(DIM2_t = wind_speed_y_t, update_width = 1, change_sign_on_bipolar = -1)
#elif CMF_VERSION == 3
    call HaloUpdateMaster % update(wind_speed_x_t, update_width = 1, grid_type = 'T', change_sign_on_bipolar = .TRUE.)
    call HaloUpdateMaster % update(wind_speed_y_t, update_width = 1, grid_type = 'T', change_sign_on_bipolar = .TRUE.)
#endif 
	
	do j = jsouth(myrank)-1, jnorth(myrank)+1
	do i = iwest (myrank)-1, ieast (myrank)+1
		if(kt(i,j) > 0) wind_speed_m_t(i,j) = SQRT(wind_speed_x_t(i,j)*wind_speed_x_t(i,j)+wind_speed_y_t(i,j)*wind_speed_y_t(i,j))
	end do
	end do

	patm=100000.

	return
	end

