
!~~~~~~
	subroutine scalar(tc,tf)
!~~~~~~

	use basic
	use grid_arrays
	use mod_dynamics
	use air_forcing
	use external
	use mod_thermodynamics
	use ice_arrays

	double precision dwi_blnc

	real (kind=4)	tc 	(kl  ,	
     &				iwest (myrank)-1:ieast (myrank)+1, 
     &				ml,
     &				jsouth(myrank)-1:jnorth(myrank)+1)
	real (kind=4)	tf 	(kl  ,	
     &				iwest (myrank)-1:ieast (myrank)+1, 
     &				ml,
     &				jsouth(myrank)-1:jnorth(myrank)+1)
	real (kind=4)	source	(kl  ,	
     &				iwest (myrank)-1:ieast (myrank)+1, 
     &				ml,
     &				jsouth(myrank)-1:jnorth(myrank)+1)
	real (kind=8)	r 	(kl  ,	
     &				iwest (myrank)-1:ieast (myrank)+1, 
     &				ml,
     &				jsouth(myrank)-1:jnorth(myrank)+1)


	real (kind=8) arix(kl),brix(kl),crix(kl),rrix(kl),frix(kl)
	real (kind=8) bbrix(kl),rrrix(kl),cc(kl)
	real (kind=8) c_ssh_1,c_ssh_2


*-------
*		compute heat and salt sources under the (1-Aice) part 
*		of the T-cell sea surface
*-------
	source=0.

	c4217d=4217.*densit
	c4217dv=1./c4217d


*-------
c		heat source
*-------
	m=1
	do j=jsouth(myrank)	,jnorth(myrank)
	do i=iwest (myrank)	,ieast (myrank)
	k=1
c	source(k,i,m,j)=c4217dv*t_src(i,j,m)
	source(k,i,m,j)=c4217dv*(t_src(i,j,m)*(1.-aice(0,i,j))+
     &				ice_src(i,1,j))
	do k=2,kl
	if(k.le.kt(i,j)) then
	source(k,i,m,j)=c4217dv*ssr(i,j)*(1.-aice(0,i,j))*
     &		hzwv(k+1)*(efsolar(k,i,j)-efsolar(k+1,i,j))
c     &		hzwv(k+1)*(efsolar(i,j,k)-efsolar(i,j,k+1))
	end if
	end do
	end do
	end do

*-------
c		salt source
*-------
c	if(ifsc.eq.0) then
c	m=2
c	do j=jsouth(myrank)	,jnorth(myrank)
c	do i=iwest (myrank)	,ieast (myrank)
c	k=1
c	if(k.le.kt(i,j)) 
c     &  source(k,i,m,j)=(evap(i,j)/densit-prec(i,j))*tc(k,i,m,j)*hzwv(2)
c	end do
c       end do
c	end if

*-------
c		source of pollution
*-------
c	do n=1,n_sew
c	if(j.eq.j_sew(n)) then
c	i=i_sew(n)
c	k=k_sew(n)
c	source(k,i,3)=sp_sew(n)
c	end if
c	end do
c	do i=2,il-1
c	if(134.le.i.and.i.le.144.and.j.eq.90) then
c	source(kv(i,j),i,3)=1000 000.
c	end if
c	end do


c	i=89
c	j=194
c	write(336,'(i5,6(/7e12.4))') l,
c     &		((tf(k,i,m,j)
c     &		,s_hmix(i,k,m,j)
c     &		,source(k,i,m,j)
c     &		,g_nudge(i,k,j)
c     &		,tc(k,i,m,j)
c     &		,kh(i,k,j)
c     &		,t_ext(k,i,m,j),k=1,3),m=1,2)

	

c-------
c	Compute the right side for implicit equation on 'l+1' timestep
c-------
	do j=jsouth(myrank)	,jnorth(myrank)
	do m=1,ml
	do i=iwest (myrank)	,ieast (myrank)
	do k=1,kl
	if(k.le.kt(i,j)) then

	r(k,i,m,j)= tf(k,i,m,j)
     &		+htsec*(
     &		+s_hmix(k,i,m,j)
     &		+ct3(k,i,j)*source(k,i,m,j)
     &		)
c     &		-g_nudge(k,i,j)*(tc(k,i,m,j)-t_ext(k,i,m,j))

	end if
	end do
	end do
	end do
	end do

c-------
c Part 4.2	Solve the implicit equation for scalar function
c		-A(k)*T(k-1) + C(k)*T(k) - B(k)*t(k+1) = R(k)
c		Cycle on 'i'
c-------
	kk=1
	do j=jsouth(myrank)	,jnorth(myrank)
	do m=1,ml
	do i=iwest (myrank)	,ieast (myrank)
	if( kt(i,j).gt.0 ) then
c-------
c Part 4.3.	Compute the matrix terms
c-------
chflux	experiments with prescribed heat flux from Samoilenko
c	flx=tsrf(i,j,m)	!experiments with prescribed heat flux (from Samoilenko)
c	if(tf(1,i,1,j).le.0..and.m.eq.1)flx=0.	!experiments with prescribed heat flux (from Samoilenko)

	k=1
	kz1=1
	kz2=kt(i,j)
c	write(*,*) '0',i,j,k,kt(i,j),kz2
c
c		Dirichlet (1st boundary) condition
c
c	arix(k)=kh(i,k)*ct(i,k)*2.*hzv(1)*hzwv(k+1)
c	R(i,k)=R(i,k) + arix(k)*Tsrf(i,j,m)
c
c		Neumann (2nd boundary) condition
c
	r(k,i,m,j)=r(k,i,m,j) + 0.	!for experiments with heat source
c				 (ice formation, erdemli), continued in June 99
c	R(i,k)=R(i,k) + hzwv(k+1)*tsrf(i,j,m)*ct(i,k)	!experiments with prescribed heat flux (from Samoilenko)
c	R(i,k)=R(i,k) + hzwv(k+1)*flx*ct(i,k)	!experiments with prescribed heat flux (from Samoilenko)
c
c		Haney (3rd boundary) condition
c
cc	arix(k)=gamma*hzwv(k+1)*ct(i,k)
cc	R(i,k)=R(i,k) + arix(k)*Tsrf(i,j,m)


	arix(1)=0.0
	do k=2,kz2
	arix(k)=kh(k,i,j)*ct3(k,i,j)*hkm(k)
	end do

	do k=1,kz2-1
	brix(k)=kh(k+1,i,j)*ct3(k+1,i,j)*hkp(k)
	end do
	brix(kz2)=0.

	if(kz2.ge.2) then
c-------
c	This part is valid for the Crunk-Nicholson scheme for vertical diffusion 
c	here we add an 1/2 of vertical diffusion for explicit time-step
c	if you want to use completely implicit time scheme then
c	comment the following '**' operators before the net comments
c-------
	do k=1,kz2
	arix(k)=htsec*0.5*arix(k)
	brix(k)=htsec*0.5*brix(k)
	crix(k)=arix(k)+brix(k)
	end do

	k=1
	cc(k)=
     &		+crix(k)*tc(k  ,i,m,j)
     &		-brix(k)*tc(k+1,i,m,j)
	do k=2,kz2-1
	cc(k)=
     &		-arix(k)*tc(k-1,i,m,j)
     &		+crix(k)*tc(k  ,i,m,j)
     &		-brix(k)*tc(k+1,i,m,j)
	end do
	k=kz2
	cc(k)=	-arix(k)*tc(k-1,i,m,j)
     &		+crix(k)*tc(k  ,i,m,j)

	do k=1,kz2
	r(k,i,m,j)=r(k,i,m,j)-cc(k)
	end do
c	end of terms for explicit scheme
	end if	!	if(kz2.ge.2) then
c-------
c		The end of part concerning to the Crunk-Nickolson scheme
c-------
	do k=1,kz2
			c_ssh_1=1.
c	if(k.eq.1.and.ifsc.eq.1)
	if(k.eq.1)	c_ssh_1=1.+(ssl_f(i,j)-seash)/dble(hzw(2))

	crix(k)=arix(k)+brix(k)+ct3(k,i,j)*c_ssh_1
c	tf(k,i,m,j)=R(i,k) /(ct3(k,i,j)*c_ssh_1)
	end do
c-------
c Part 4.4.	Solve the Matrix Equation by factorising Method
c-------
	if(kz2.eq.1) then
	k=1
	tf(k,i,m,j)=r(k,i,m,j) / crix(k)
	end if
		
	if(kz2.ge.2) then
	do k=1,kz2
	rrix(k)=r(k,i,m,j)
	end do
	call factordp(kz1,kz2,arix,brix,crix,rrix,frix,bbrix,rrrix)
	do k=1,kz2
	tf(k,i,m,j)=real(frix(k))
	end do
	end if

	end if
	end do	!do i=2,il-1
	end do	!do m=1,ml
	end do	!do j=jsouth(myrank)	,jnorth(myrank)

	return
	end
