
!~~~~~~
	subroutine scalar(tc,tf)
!~~~~~~

	use basic
	use grid_arrays
	use mod_dynamics
	use air_forcing
	use external
	use mod_thermodynamics
	use ice_arrays

	double precision dwi_blnc

	real (kind=4)	tc 	(kl  ,	
     &				iwest (myrank)-1:ieast (myrank)+1, 
     &				ml,
     &				jsouth(myrank)-1:jnorth(myrank)+1)
	real (kind=4)	tf 	(kl  ,	
     &				iwest (myrank)-1:ieast (myrank)+1, 
     &				ml,
     &				jsouth(myrank)-1:jnorth(myrank)+1)
	real (kind=8)	r 	(kl  ,	
     &				iwest (myrank)-1:ieast (myrank)+1, 
     &				ml,
     &				jsouth(myrank)-1:jnorth(myrank)+1)


	real (kind=8) arix(kl),brix(kl),crix(kl),rrix(kl),frix(kl)
	real (kind=8) bbrix(kl),rrrix(kl),cc(kl)
	real (kind=8) c_ssh_1,c_ssh_2


!-------
!		compute heat and salt sources under the (1-Aice) part 
!		of the T-cell sea surface
!-------

c	c4217d=4217.*densit
c	c4217dv=1./c4217d

c	write(*,'(a)') 	   'aice'
c	write(*,'   (i3,66i9  )') (j, (i,i=2,il-1), j=1,1,-1)
c	write(*,'(128(i3,66e9.2/))')(j,(aice(0,i,j),i=2,il-1),j=jl-1,2,-1)

c	write(*,'(a)') 	   'ice_src'
c	write(*,'   (i3,66i9  )') (j, (i,i=2,il-1), j=1,1,-1)
c	write(*,'(128(i3,66e9.2/))')(j,(ice_src(i,1,j),i=2,il-1),j=jl-1,2,-1)


!-------
!	Compute the right side for implicit equation on 'l+1' timestep
!-------
	do j=jsouth(myrank)	,jnorth(myrank)
	do m=1,ml
	do i=iwest (myrank)	,ieast (myrank)
	do k=1,kl
	if(k.le.kt(i,j)) then

	r(k,i,m,j)= tf(k,i,m,j)
     &		+htsec*(
     &		+s_hmix(k,i,m,j)
     &		+ t_source(k,i,m,j)
c     &		+ct3(k,i,j)*t_source(k,i,m,j)
     &		)
c     &		-g_nudge(k,i,j)*(tc(k,i,m,j)-t_ext(k,i,m,j))

	if(k.eq.1.and.m.eq.2) r(k,i,m,j)= r(k,i,m,j)
     &		-g_nudge(k,i,j)*(tc(k,i,m,j)-s_ext(i,j))

	end if
	end do
	end do
	end do
	end do

!-------
c Part 4.2	Solve the implicit equation for scalar function
c		-A(k)*T(k-1) + C(k)*T(k) - B(k)*t(k+1) = R(k)
c		Cycle on 'i'
!-------
	kk=1
	do j=jsouth(myrank)	,jnorth(myrank)
	do m=1,ml
	do i=iwest (myrank)	,ieast (myrank)
	if( kt(i,j).gt.0 ) then
!-------
! Part 4.3.	Compute the matrix terms
!-------
chflux	experiments with prescribed heat flux from Samoilenko
c	flx=tsrf(i,j,m)	!experiments with prescribed heat flux (from Samoilenko)
c	if(tf(1,i,1,j).le.0..and.m.eq.1)flx=0.	!experiments with prescribed heat flux (from Samoilenko)

	k=1
	kz1=1
	kz2=kt(i,j)
c	write(*,*) '0',i,j,k,kt(i,j),kz2
c
c		Dirichlet (1st boundary) condition
c
c	arix(k)=kh(i,k)*ct(i,k)*2.*hzv(1)*hzwv(k+1)
c	R(i,k)=R(i,k) + arix(k)*Tsrf(i,j,m)
c
c		Neumann (2nd boundary) condition
c
	r(k,i,m,j)=r(k,i,m,j) + 0.	!for experiments with heat source
c				 (ice formation, erdemli), continued in June 99
c	R(i,k)=R(i,k) + hzwv(k+1)*tsrf(i,j,m)*ct(i,k)	!experiments with prescribed heat flux (from Samoilenko)
c	R(i,k)=R(i,k) + hzwv(k+1)*flx*ct(i,k)	!experiments with prescribed heat flux (from Samoilenko)
c
c		Haney (3rd boundary) condition
c
cc	arix(k)=gamma*hzwv(k+1)*ct(i,k)
cc	R(i,k)=R(i,k) + arix(k)*Tsrf(i,j,m)


	arix(1)=0.0
	do k=2,kz2
	arix(k)=kh(k,i,j)*ct3(k,i,j)*hkm(k)
	end do

	do k=1,kz2-1
	brix(k)=kh(k+1,i,j)*ct3(k+1,i,j)*hkp(k)
	end do
	brix(kz2)=0.

	if(kz2.ge.2) then
!-------
!	This part is valid for the Crunk-Nicholson scheme for vertical diffusion 
!	here we add an 1/2 of vertical diffusion for explicit time-step
!	if you want to use completely implicit time scheme then
!	comment the following '**' operators before the net comments
!-------
	do k=1,kz2
	arix(k)=htsec*0.5*arix(k)
	brix(k)=htsec*0.5*brix(k)
	crix(k)=arix(k)+brix(k)
	end do

	k=1
	cc(k)=
     &		+crix(k)*tc(k  ,i,m,j)
     &		-brix(k)*tc(k+1,i,m,j)
	do k=2,kz2-1
	cc(k)=
     &		-arix(k)*tc(k-1,i,m,j)
     &		+crix(k)*tc(k  ,i,m,j)
     &		-brix(k)*tc(k+1,i,m,j)
	end do
	k=kz2
	cc(k)=	-arix(k)*tc(k-1,i,m,j)
     &		+crix(k)*tc(k  ,i,m,j)

	do k=1,kz2
	r(k,i,m,j)=r(k,i,m,j)-cc(k)
	end do
c	end of terms for explicit scheme
	end if	!	if(kz2.ge.2) then
!-------
!		The end of part concerning to the Crunk-Nickolson scheme
!-------
	do k=1,kz2
			c_ssh_1=1.
c	if(k.eq.1.and.ifsc.eq.1)
	if(k.eq.1)	c_ssh_1=1.+(ssl_f(i,j)-seash)/dble(hzw(2))

	crix(k)=arix(k)+brix(k)+ct3(k,i,j)*c_ssh_1
c	tf(k,i,m,j)=R(i,k) /(ct3(k,i,j)*c_ssh_1)
	end do
!-------
! Part 4.4.	Solve the Matrix Equation by factorising Method
!-------
	if(kz2.eq.1) then
	k=1
	tf(k,i,m,j)=r(k,i,m,j) / crix(k)
	end if
		
	if(kz2.ge.2) then
	do k=1,kz2
	rrix(k)=r(k,i,m,j)
	end do
	call factordp(kz1,kz2,arix,brix,crix,rrix,frix,bbrix,rrrix)
	do k=1,kz2
	tf(k,i,m,j)=real(frix(k))
	end do
	end if

	end if
	end do	!do i=2,il-1
	end do	!do m=1,ml
	end do	!do j=jsouth(myrank)	,jnorth(myrank)

	return
	end
