#include "o_defines.f90"


!--------------------------------------
!		
!	Institute of Numerical Mathematics, Russian Academy of Sciences (INM RAS)
!	Shirshov Institute of Oceanology, Russian Academy of Sciences (IO RAS) 
!		Ocean General Circulation Model	
!			INMIO
!
!	Some procedures for model solution analysis
!
! authors: 
!	2015.07 / Ushakov, Konstantin, IO RAS, Russia, ushakovkv@mail.ru
!
!--------------------------------------


	module test_ocean_module

	implicit none
	save

	
	!z real (kind=4), allocatable :: from_atm1(:,:), from_atm2(:,:), from_atm3(:,:), from_atm4(:,:), from_atm5(:,:), from_atm6(:,:), from_atm7(:,:)
	!z real (kind=4), allocatable :: to_atm1(:,:), to_atm2(:,:), to_atm3(:,:)
	!z real, allocatable ::from_file_data(:,:)
	real (kind=4), allocatable :: T_10_MOD_atm(:,:), Q_10_MOD_atm(:,:), U_10_MOD_atm(:,:), V_10_MOD_atm(:,:), RAIN_atm(:,:), SNOW_atm(:,:)
	real (kind=4), allocatable :: LWDN_MOD_atm(:,:), SWDN_MOD_atm(:,:), aice_atm(:,:)
	!z real(kind=4), allocatable :: global_src(:,:,:)
	real(kind=4), allocatable :: temp1(:,:),temp2(:,:) !,temp3(:,:)  !for diagnoxtic output only
	real(kind=4), allocatable :: ocn_ice_test(:,:),ice_ocn_test(:,:),test3d(:,:,:)
	end module test_ocean_module




	subroutine allocate_test_ocean_module

	!use comp_module
	use test_ocean_module
	use o_grid_module

	implicit none

	!allocate(from_atm1(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(from_atm2(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(from_atm3(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(from_atm4(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(from_atm5(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(from_atm6(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(from_atm7(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))

	!allocate(to_atm1(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(to_atm2(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(to_atm3(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))

	!allocate(from_file_data(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))

	allocate(T_10_MOD_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(Q_10_MOD_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(U_10_MOD_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(V_10_MOD_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(RAIN_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(SNOW_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(LWDN_MOD_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(SWDN_MOD_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(aice_atm(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(temp1(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(temp2(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	!allocate(temp3(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(ocn_ice_test(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(ice_ocn_test(iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	allocate(test3d(kl,iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1))
	
	T_10_MOD_atm = 0
	Q_10_MOD_atm = 0
	U_10_MOD_atm = 0
	V_10_MOD_atm = 0
	RAIN_atm = 0
	SNOW_atm = 0	
	LWDN_MOD_atm = 0
	SWDN_MOD_atm = 0
	aice_atm = 0
!	temp1=0.
!	temp2=0.
!	temp3=0.
	
	return
	end

!--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
!Diagnostics for CORE experiments	
!----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	module o_core_diagnostics_module
	use o_par_module
	implicit none
	save
!	
!	real (kind=8), allocatable :: t_annualmean(:,:,:,:),u_annualmean(:,:,:),v_annualmean(:,:,:)
!	real (kind=8), allocatable :: gridbox_volume_t(:,:,:),gridbox_volume_v(:,:,:)
!	real (kind=8), allocatable :: tem_global_mean(:,:),ke_global_mean(:)
!	real (kind=4), allocatable :: t_c_for_DG_and_CP(:,:,:,:)
!	real (kind=4), allocatable :: u_dg(:,:,:),v_dg(:,:,:),temp_array1(:,:,:),temp_array2(:,:,:)
!	real (kind=4), allocatable :: aice_march(:,:), aice_september(:,:)
!	real (kind=4), allocatable :: flux_n_dg_adv(:,:), flux_e_dg_adv(:,:)
!	real (kind=4), allocatable :: flux_n_dg_lapl(:,:), flux_e_dg_lapl(:,:)
!	real (kind=4), allocatable :: flux_n_dg_bh(:,:), flux_e_dg_bh(:,:)
!	real (kind=4), allocatable :: mld(:,:),mld_max(:,:)					!current mixed layer depth, maximum mixed layer depth
!	real (kind=4), allocatable :: moc(:,:,:)
!	real (kind=8), allocatable :: moc_core2_annualmean(:,:,:)
!	real (kind=8), allocatable :: aice_marchmean(:,:)
!	real (kind=8), allocatable :: hice_marchmean(:,:)
!	real (kind=8), allocatable :: mld_marchmean(:,:)
!	real (kind=8), allocatable :: heatflux_annualmean(:,:)
!	real counter_marchmean
!	
!	
!	character(NAME_LEN),allocatable :: T_names(:,:),KE_names(:)
!	real (kind=8) ssl_global_mean
!	integer i1,i2,j1,j2
!	integer :: ave_adding_period_hours=6   	!period of adding t_c to t_annualmean (hours)
!	integer :: ave_finishing_period_days=365 	!period of calculating averaged fields of T,S,U,V (days)
!	
	real(4) freeze_solution		!>0 means freezing solution in case of explosion (for saving in CP)
	real(4) s_max,t_max		!maximum proval of ssl, erroneous temperature
	integer cp_counter		!to count cp-savings after freezing solution
	integer skip_ocean_calculations	!key for such skipping in case of freezing solution
	integer T_error_flag		!flag saying that blow up is due to temperature
	end module o_core_diagnostics_module
!	
!	
!	!allocation and names initialization
!	subroutine allocate_o_core_diagnostics_module
!	use o_core_diagnostics_module
!	use o_grid_module
!	use o_basic_module
!	implicit none
!	
!	i1=iwest(myrank)
!	i2=ieast(myrank)
!	j1=jsouth(myrank)
!	j2=jnorth(myrank)
!	
!	allocate (t_annualmean (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1, ml	))
!	allocate (u_annualmean (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (v_annualmean (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (moc_core2_annualmean (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (gridbox_volume_t (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (gridbox_volume_v (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (tem_global_mean(kl+1,ml))
!	allocate ( ke_global_mean(kl+1   ))
!	allocate (T_names(kl+1,ml),KE_names(kl+1))
!	allocate(t_c_for_DG_and_CP(kl,iwest(myrank)-1:ieast(myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1,ml))
!	allocate (u_dg (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (v_dg (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (temp_array1 (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (temp_array2 (kl,	iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (aice_march (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (aice_september (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	
!	allocate (flux_n_dg_adv (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (flux_e_dg_adv (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (flux_n_dg_lapl (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (flux_e_dg_lapl (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (flux_n_dg_bh (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (flux_e_dg_bh (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	
!	allocate (mld 	(iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (mld_max (iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1	))
!	allocate (aice_marchmean 	(iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (hice_marchmean 	(iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (mld_marchmean 	(iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	allocate (heatflux_annualmean 	(iwest (myrank)-1:ieast (myrank)+1, jsouth(myrank)-1:jnorth(myrank)+1		))
!	
!	do k=1,kl+1
!		write( T_names(k,1),'(A, i2.2)')  'T_horizon_', k
!		write( T_names(k,2),'(A, i2.2)')  'S_horizon_', k
!		write(KE_names(k  ),'(A, i2.2)')  'KE_horizon_', k
!	end do
!	t_annualmean=0.d0
!	u_annualmean=0.d0
!	v_annualmean=0.d0
!	gridbox_volume_t=0.
!	gridbox_volume_v=0.
!	tem_global_mean=0.d0
!	ke_global_mean=0.d0
!	freeze_solution=0.
!	s_max=0.
!	t_max=0.
!	T_error_flag=0
!	cp_counter=0
!	skip_ocean_calculations=0
!	u_dg=0.
!	v_dg=0.
!
!	flux_n_dg_adv=0.
!	flux_e_dg_adv=0.
!	flux_n_dg_lapl=0.
!	flux_e_dg_lapl=0.
!	flux_n_dg_bh=0.
!	flux_e_dg_bh=0.
!	
!	mld=0.
!	mld_max=0.
!	end
	
!--------------------------------------------------------------------------------
!	Online tests for ocean solution integrity
!--------------------------------------------------------------------------------	
	
	subroutine o_online_tests
	use o_grid_module
	use o_basic_module
	use o_core_diagnostics_module
	use test_ocean_module
	use o_tf_module
	use ice_module
	use o_d_brcl_module
	use o_par_module
	
	implicit none
	
	integer, save :: ii,jj
	integer, save :: ii_T,jj_T,kk_T
	integer :: ssl_cutoff=-5.    !if ssl is less than this value then stop the model
	
#if CMF_VERSION == 2    
	!----------------solution freezing in case of hard noise--------------------------------------------
	!freeze_solution is the flag, saying that something is wrong and we must stop. It is mpi_allreduced at the end of o_main_step.
	if(freeze_solution .gt. 0.001 .or. skip_ocean_calculations==1) then
		skip_ocean_calculations=1	!1 means that we start skipping ocean calculations (see o_main_step)	
		if(time_l_save_cp /= 0 .AND. MOD(time_l,time_l_save_cp) == 1) cp_counter=cp_counter+1  !we stop on the second cp-writing event after crash
		if(cp_counter==2) then
			if(s_max.lt.ssl_cutoff) print *,'Solution frozen due to upper cell drying in point',ii,jj,s_max,ocn_rank_local
			if(T_error_flag==1) 	print *,'Solution frozen due to temperature beyond limits: ',ii_T,jj_T,kk_T,t_max
			call ocn_error('Solution has blown up! Stop.', 'IND')
		end if
		return
	end if
#endif
	
	!=========TESTS=========
	!-----------looking whether the solution is going to crash (ssl becoming too negative)--------------
	s_max=0.
	ii=0
	jj=0
	do j=jsouth(myrank)	,jnorth(myrank)
	do i=iwest (myrank)	,ieast (myrank)
		if(ssl_c(i,j).le.s_max) then
			ii=i
			jj=j
			s_max=ssl_c(i,j)
		end if
	end do
	end do
	if(s_max.lt.ssl_cutoff) freeze_solution=1.e20		
	
	!-----------Testing temperatures--------------
	if(mod(time_l,5)==0) then
		ii_T=0
		jj_T=0
		do j=jsouth(myrank)-1	,jnorth(myrank)+1
		do i=iwest (myrank)-1	,ieast (myrank)+1
		do k=1,kt(i,j)
			if(t_c(k,i,j,1).lt.-5.) then
				!ii_T=i
				!jj_T=j
				!kk_T=k
				!t_max=t_c(k,i,j,1)
				!freeze_solution=1.e20	
				!T_error_flag=1
				print *,'WARNING, temperature beyond lower limit: ',i,j,k,t_c(k,i,j,1)
				t_c(k,i,j,1)=-2.
			end if
			if(t_c(k,i,j,2).lt.0.0) then
				print *,'WARNING, salinity beyond lower limit: ',i,j,k,t_c(k,i,j,2)
				t_c(k,i,j,2)=0.
			end if
		end do
		end do
		end do
	end if
	!--------testing arrays for NAN------------
	
!	do j=jsouth(myrank)	,jnorth(myrank)
!	do i=iwest (myrank)	,ieast (myrank)
!		if(evap(i,j)/=evap(i,j)) then
!			print *,'NAN in evap caught',i,j
!			freeze_solution=1.e20
!		end if
!		
!		if(aice(1,i,j)/=aice(1,i,j)) then 
!			print *,'NAN in AICE caught',i,j 
!			freeze_solution=1.e20
!		end if
!		
!		if(water_ssf(i,j)/=water_ssf(i,j)) 	then; print *,'NAN in SSWF caught'; freeze_solution=1.e20; end if
!		if(ssl_c(i,j)/=ssl_c(i,j)) 		then; print *,'NAN in SSL  caught'; freeze_solution=1.e20; end if
!		
!		do m=1,ml
!		do k=1,kl
!			if(t_c(k,i,j,m)/=t_c(k,i,j,m))	then; print *,'NAN in T_c  caught'; freeze_solution=1.e20; end if
!		end do
!		end do
!		
!		do k=1,kl
!			if(u_c(k,i,j)/=u_c(k,i,j))	then; print *,'NAN in u_c  caught'; freeze_solution=1.e20; end if
!			if(v_c(k,i,j)/=v_c(k,i,j))	then; print *,'NAN in v_c  caught'; freeze_solution=1.e20; end if
!		end do
!		
!	end do
!	end do
	
	!---------testing continuity (w must be almost zero on bottom)----------------------------------------
	!do j=jsouth(myrank)	,jnorth(myrank)
	!do i=iwest (myrank)	,ieast (myrank)
	!	temp1(i,j)=w(kt(i,j)+1,i,j)
	!end do
	!end do
	!!print *,'Maximum W_bottom:',maxval(abs(temp1(iwest(myrank):ieast(myrank),jsouth(myrank):jnorth(myrank)))),10.**(6-main_kind*3)
	!if(time_l_in_run.gt.2 .and. maxval(abs(temp1(iwest(myrank):ieast(myrank),jsouth(myrank):jnorth(myrank)))).gt.10.**(6-main_kind*3+3)) call shared_error('Possible continuity error: too big bottom W')
	
	
	end
	
!--------------------------------------------------------------------------------
!	CORE diagnostics, working online in the OCN component
!--------------------------------------------------------------------------------	
	
!	subroutine o_core_diagnostics
!	use o_grid_module
!	use o_basic_module
!	use o_core_diagnostics_module
!	use ice_module
!	implicit none
!	
!	real(8) sigma_0,sigma_h,rho_from_theta
!	
!	!-----rotating heat fluxes (for MHT) to spherical grid------
!	call tsc_ssc_rotate_v(flux_e_dg_adv(:,:),flux_n_dg_adv(:,:),flux_e_dg_adv(:,:),flux_n_dg_adv(:,:),iwest(myrank)-1,ieast(myrank)+1,jsouth(myrank)-1,jnorth(myrank)+1)	
!	call tsc_ssc_rotate_v(flux_e_dg_lapl(:,:),flux_n_dg_lapl(:,:),flux_e_dg_lapl(:,:),flux_n_dg_lapl(:,:),iwest(myrank)-1,ieast(myrank)+1,jsouth(myrank)-1,jnorth(myrank)+1)	
!	call tsc_ssc_rotate_v(flux_e_dg_bh(:,:),flux_n_dg_bh(:,:),flux_e_dg_bh(:,:),flux_n_dg_bh(:,:),iwest(myrank)-1,ieast(myrank)+1,jsouth(myrank)-1,jnorth(myrank)+1)	
!	
!	!------fixing March and September ice extent
!#if CMF_VERSION == 2    
!	call shared_timer
!	if(time_day_in_year==74) aice_march=aice(:,:)
!	if(time_day_in_year==258) aice_september=aice(:,:)
!#endif
!
!	!-------------------preparing U,V to mapping to the DIA grid. Check kind of these arrays in o_d_tsc_ssc_rotate_v!---------------
!	u_dg=u_annualmean
!	v_dg=v_annualmean
!	
!	do k=1,kl
!		call tsc_ssc_rotate_v(u_dg(k,:,:),v_dg(k,:,:),u_dg(k,:,:),v_dg(k,:,:),iwest(myrank)-1,ieast(myrank)+1,jsouth(myrank)-1,jnorth(myrank)+1)	!rotating to spherical grid directions
!	end do
!	temp_array1=0.
!	temp_array2=0.
!	do j=jsouth(myrank),jnorth(myrank)
!	do i=iwest (myrank),ieast (myrank)
!	do k=1,kt(i,j)
!		temp_array1(k,i,j)=0.25*(u_dg(k,i,j)+u_dg(k,i-1,j)+u_dg(k,i,j-1)+u_dg(k,i-1,j-1))								!interpolating to T-points
!		temp_array2(k,i,j)=0.25*(v_dg(k,i,j)+v_dg(k,i-1,j)+v_dg(k,i,j-1)+v_dg(k,i-1,j-1))
!	end do
!	end do
!	end do
!	u_dg=temp_array1
!	v_dg=temp_array2
!		
!	!-------------------------------calculating mixed layer depth (mld)------------------------
!	do j=jsouth(myrank),jnorth(myrank)
!	do i=iwest (myrank),ieast (myrank)
!		if(kt(i,j)>0) then
!			sigma_0=rho_from_theta(dble(t_c(1,i,j,2)),dble(t_c(1,i,j,1)),0.d0)  		!sigma_0 - potential density at the surface
!			do k=2,kt(i,j)
!				sigma_h=rho_from_theta(dble(t_c(k,i,j,2)),dble(t_c(k,i,j,1)),0.d0)  	!sigma_h - potential density at the k level				
!				if(abs(sigma_h-sigma_0).ge.0.125) then
!					mld(i,j)=zw(k)
!					goto 1
!				end if
!			end do
!			mld(i,j)=zw(kt(i,j)+1)
!1			continue			
!		end if
!	end do
!	end do
!	mld_max=max(mld_max,mld)
!	
!	end

	