!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module atm_gfs_cpl_adapter_module

use component_module
use decomposition_module
implicit none

type, extends(Component) :: atm_gfs_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
end type

    integer atm_i_size, atm_j_size, atm_k_size, atm_m_size, atm_steps_in_day
    integer atm_forcing_type
    logical atm_read_cp
    integer :: atm_dg_period = 360
   
    real (kind=4), allocatable :: t_2(:,:), q_2(:,:), u_10(:,:), v_10(:,:)
    real (kind=4), allocatable :: swdn(:,:), lwdn(:,:), rain(:,:), snow(:,:), runoff(:,:)
    type(Decomposition) :: dec
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to register your model in the system.
! Here you should (probably) read or define necessary information and 
! must call this % register_model()
!----------------------------------------------------------------------------------------

subroutine ini_reg_comp(this)
	class(atm_gfs_cpl_adapter) :: this
    
	namelist /ATM_MAIN/ atm_i_size, atm_j_size, atm_k_size, atm_m_size, atm_steps_in_day, atm_read_cp
	namelist /ATM_PHYSICS/ atm_forcing_type
	
	open(9, file= "./comp_atm_gfs/atm_list.in")
	read(9, nml = ATM_MAIN)
	close(9)

	dec = Decomposition(atm_i_size, atm_j_size, atm_k_size, "1D", CompSplitter % comm_local_size(), CompSplitter % rank_local())
    
	! Call registration routine of CMF (it needs only size of grid and timestep in whole(!) seconds)
	call this % register_model(decomp = dec, timestep_sec = 24*3600/atm_steps_in_day) 
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data() use adresses of your arrays and 
! they should be allocated at time of registration.
! Here you should do all array allocations.
!----------------------------------------------------------------------------------------

subroutine ini_allocate(this)
    class(atm_gfs_cpl_adapter) :: this

    allocate(t_2(dec % i_size_loc(), dec % j_size_loc())); t_2 = 0
    allocate(q_2(dec % i_size_loc(), dec % j_size_loc())); q_2 = 0
    allocate(u_10(dec % i_size_loc(), dec % j_size_loc())); u_10 = 0
    allocate(v_10(dec % i_size_loc(), dec % j_size_loc())); v_10 = 0
    allocate(lwdn(dec % i_size_loc(), dec % j_size_loc())); lwdn = 0
    allocate(swdn(dec % i_size_loc(), dec % j_size_loc())); swdn = 0
    allocate(rain(dec % i_size_loc(), dec % j_size_loc())); rain = 0
    allocate(snow(dec % i_size_loc(), dec % j_size_loc())); snow = 0
    !allocate(runoff(dec % i_size_loc(), dec % j_size_loc())); runoff = 0
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to register all data you want to interact with system.
! Here you should call this % register_array(), this % register_*_event() or
! this % raise_event() to get result immediately.
!----------------------------------------------------------------------------------------

subroutine ini_reg_data(this)
    class(atm_gfs_cpl_adapter) :: this

    ! Register required arrays
    call this % register_array(arr_name = "t2m",   arr = t_2)
    call this % register_array(arr_name = "q2m",   arr = q_2)
    call this % register_array(arr_name = "u10",   arr = u_10)
    call this % register_array(arr_name = "v10",   arr = v_10)
    call this % register_array(arr_name = "trdi",  arr = lwdn)
    call this % register_array(arr_name = "srdi",  arr = swdn)
    call this % register_array(arr_name = "tprr",  arr = rain)
    call this % register_array(arr_name = "tprs",  arr = snow)    
    !call this % register_array(arr_name = "ro",    arr = runoff)
    
    call this % register_array(arr_name = "t2m_AI",   arr = t_2)
    call this % register_array(arr_name = "q2m_AI",   arr = q_2)
    call this % register_array(arr_name = "u10_AI",   arr = u_10)
    call this % register_array(arr_name = "v10_AI",   arr = v_10)
    call this % register_array(arr_name = "trdi_AI",  arr = lwdn)
    call this % register_array(arr_name = "srdi_AI",  arr = swdn)
    call this % register_array(arr_name = "tprr_AI",  arr = rain)
    call this % register_array(arr_name = "tprs_AI",  arr = snow)
    
    !Create SyncedGenerators to sync with GFS files
	call this % register_synced_event(arr_name = "t2m",    src = "./data/GFS/t2m.nc")    
	call this % register_synced_event(arr_name = "q2m",    src = "./data/GFS/q2m.nc")    
	call this % register_synced_event(arr_name = "u10",    src = "./data/GFS/u10.nc")    
	call this % register_synced_event(arr_name = "v10",    src = "./data/GFS/v10.nc")
	call this % register_synced_event(arr_name = "trdi",   src = "./data/GFS/trdi.nc")    
	call this % register_synced_event(arr_name = "srdi",   src = "./data/GFS/srdi.nc")    
	call this % register_synced_event(arr_name = "tprr",   src = "./data/GFS/tprr.nc")    
	call this % register_synced_event(arr_name = "tprs",   src = "./data/GFS/tprs.nc")    

    ! Create PeriodicGenerators to send it to OCN
    call this % register_periodic_event(arr_name = "t2m",  act = "SEND_MP", dst = "OCN", dh = 3)
    call this % register_periodic_event(arr_name = "q2m",  act = "SEND_MP", dst = "OCN", dh = 3)
    call this % register_periodic_event(arr_name = "u10",  act = "SEND_MP", dst = "OCN", dh = 3)
    call this % register_periodic_event(arr_name = "v10",  act = "SEND_MP", dst = "OCN", dh = 3)
    call this % register_periodic_event(arr_name = "trdi", act = "SEND_MP", dst = "OCN", dh = 3)
    call this % register_periodic_event(arr_name = "srdi", act = "SEND_MP", dst = "OCN", dh = 3)
    call this % register_periodic_event(arr_name = "tprr", act = "SEND_MP", dst = "OCN", dh = 3)
    call this % register_periodic_event(arr_name = "tprs", act = "SEND_MP", dst = "OCN", dh = 3)
    
    ! Create PeriodicGenerators to send it to ICE
    if(TRIM(ModelsInfo(CompSplitter % comp_id("ICE")) % model_name())=='ICE_CICE') then
	call this % register_periodic_event(arr_name = "t2m_AI",  act = "SEND_MP", dst = "ICE", dh = 3)
	call this % register_periodic_event(arr_name = "q2m_AI",  act = "SEND_MP", dst = "ICE", dh = 3)
	call this % register_periodic_event(arr_name = "u10_AI",  act = "SEND_MP", dst = "ICE", dh = 3)
	call this % register_periodic_event(arr_name = "v10_AI",  act = "SEND_MP", dst = "ICE", dh = 3)
	call this % register_periodic_event(arr_name = "trdi_AI", act = "SEND_MP", dst = "ICE", dh = 3)
	call this % register_periodic_event(arr_name = "srdi_AI", act = "SEND_MP", dst = "ICE", dh = 3)
	call this % register_periodic_event(arr_name = "tprr_AI", act = "SEND_MP", dst = "ICE", dh = 3)
	call this % register_periodic_event(arr_name = "tprs_AI", act = "SEND_MP", dst = "ICE", dh = 3)
    end if
    
    !----Surprisingly, these DG outputs make inmio-gfs-cice model crash on subroutine model_cycle start
    !call this % register_periodic_event(arr_name = "t2m",	act = "SAVE_DG", dm = atm_dg_period)
    !call this % register_periodic_event(arr_name = "q2m",	act = "SAVE_DG", dm = atm_dg_period)
    !call this % register_periodic_event(arr_name = "srdi",	act = "SAVE_DG", dm = atm_dg_period)
    !call this % register_periodic_event(arr_name = "trdi",	act = "SAVE_DG", dm = atm_dg_period)
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program before main time cycle.
! Here you should do all model preparation actions.
!----------------------------------------------------------------------------------------

subroutine ini_main(this)
    class(atm_gfs_cpl_adapter) :: this

end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at every step of time cycle. 
! Here you should represent one time step of your model with all physics and internal 
! exhanges (like halo MPI-updates).
!----------------------------------------------------------------------------------------

subroutine make_step(this)
    class(atm_gfs_cpl_adapter) :: this
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at the end.
! Here you should do all postprocesing actions and memory deallocations.
!----------------------------------------------------------------------------------------

subroutine finalize(this)        
    class(atm_gfs_cpl_adapter) :: this        

    deallocate(t_2, q_2, u_10, v_10)
    deallocate(swdn, lwdn, rain, snow)
    !deallocate(runoff)
    
end subroutine

end module
    