!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module atm_interim_cpl_adapter_module

use component_module
use decomposition_module
implicit none

type, extends(Component) :: atm_interim_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
end type

    integer atm_i_size, atm_j_size, atm_k_size, atm_m_size, atm_steps_in_day
    integer atm_forcing_type
    logical atm_read_cp
    integer :: atm_dg_period = 28800
   
    real (kind=4), allocatable :: t_2(:,:), q_2(:,:), u_10(:,:), v_10(:,:)
    real (kind=4), allocatable :: swdn(:,:), lwdn(:,:), prec(:,:), runoff(:,:), sst(:,:),aice(:,:),temp(:,:)
    type(Decomposition) :: dec
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to register your model in the system.
! Here you should (probably) read or define necessary information and 
! must call this % register_model()
!----------------------------------------------------------------------------------------

subroutine ini_reg_comp(this)
	class(atm_interim_cpl_adapter) :: this
    
	namelist /ATM_MAIN/ atm_i_size, atm_j_size, atm_k_size, atm_m_size, atm_steps_in_day, atm_read_cp
	namelist /ATM_PHYSICS/ atm_forcing_type
	
	open(9, file= "./configure/atm_interim_list.in")
	read(9, nml = ATM_MAIN)
	close(9)

	dec = Decomposition(atm_i_size, atm_j_size, atm_k_size, "1D", CompSplitter % comm_local_size(), CompSplitter % rank_local())
    
	! Call registration routine of CMF (it needs only size of grid and timestep in whole(!) seconds)
	call this % register_model(decomp = dec, timestep_sec = 60*60) 
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data() use adresses of your arrays and 
! they should be allocated at time of registration.
! Here you should do all array allocations.
!----------------------------------------------------------------------------------------

subroutine ini_allocate(this)
    class(atm_interim_cpl_adapter) :: this

    allocate(t_2(dec % i_size_loc(), dec % j_size_loc())); t_2 = 0
    allocate(q_2(dec % i_size_loc(), dec % j_size_loc())); q_2 = 0
    allocate(u_10(dec % i_size_loc(), dec % j_size_loc())); u_10 = 0
    allocate(v_10(dec % i_size_loc(), dec % j_size_loc())); v_10 = 0
    allocate(lwdn(dec % i_size_loc(), dec % j_size_loc())); lwdn = 0
    allocate(swdn(dec % i_size_loc(), dec % j_size_loc())); swdn = 0
    allocate(prec(dec % i_size_loc(), dec % j_size_loc())); prec = 0
    allocate(runoff(dec % i_size_loc(), dec % j_size_loc())); runoff = 0
    allocate(sst(dec % i_size_loc(), dec % j_size_loc())); sst = 0
    allocate(aice(dec % i_size_loc(), dec % j_size_loc())); aice = 0
    allocate(temp(dec % i_size_loc(), dec % j_size_loc())); temp = 0
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to register all data you want to interact with system.
! Here you should call this % register_array(), this % register_*_event() or
! this % raise_event() to get result immediately.
!----------------------------------------------------------------------------------------

subroutine ini_reg_data(this)
    class(atm_interim_cpl_adapter) :: this

    !==================================================================
    !------------corrected normal year forcing-------------------------    
    !==================================================================
    
    ! Register required arrays
    call this % register_array(arr_name = "t2m",   arr = t_2)
    call this % register_array(arr_name = "d2m",   arr = q_2)
    call this % register_array(arr_name = "u10",   arr = u_10)
    call this % register_array(arr_name = "v10",   arr = v_10)
    call this % register_array(arr_name = "sst",   arr = sst)
    call this % register_array(arr_name = "strd",  arr = lwdn)
    call this % register_array(arr_name = "ssrd",  arr = swdn)
    call this % register_array(arr_name = "tp",    arr = prec)
    call this % register_array(arr_name = "ci",    arr = aice)
    call this % register_array(arr_name = "ro",    arr = runoff)
    
    if(TRIM(ModelsInfo(CompSplitter % comp_id("ICE")) % model_name())=='ICE_CICE') then
	call this % register_array(arr_name = "t2m_AI",   arr = t_2)
	call this % register_array(arr_name = "d2m_AI",   arr = q_2)
	call this % register_array(arr_name = "u10_AI",   arr = u_10)
	call this % register_array(arr_name = "v10_AI",   arr = v_10)
	call this % register_array(arr_name = "strd_AI",  arr = lwdn)
	call this % register_array(arr_name = "ssrd_AI",  arr = swdn)
	call this % register_array(arr_name = "tp_AI",    arr = prec)
    end if
    
    !Create SyncedGenerators to sync with INTERIM files
	call this % register_synced_event(arr_name = "t2m",    src = "./data/Interim/T2.nc")    
	call this % register_synced_event(arr_name = "d2m",    src = "./data/Interim/dew.nc")    
	call this % register_synced_event(arr_name = "u10",    src = "./data/Interim/U.nc")    
	call this % register_synced_event(arr_name = "v10",    src = "./data/Interim/V.nc")
	call this % register_synced_event(arr_name = "sst",    src = "./data/Interim/sst.nc")    
	call this % register_synced_event(arr_name = "strd",   src = "./data/Interim/lwdn-step12.nc")    
	call this % register_synced_event(arr_name = "ssrd",   src = "./data/Interim/swdn-step12.nc")    
	call this % register_synced_event(arr_name = "tp",     src = "./data/Interim/prec-step12.nc")    
	call this % register_synced_event(arr_name = "ci",     src = "./data/Interim/aice-fillmiss.nc")    
	!call this % register_synced_event(arr_name = "ro",    src = "./data/Interim/runoff-step12.nc")    

!    call this % register_periodic_event(arr_name = "t2m", act = "SAVE_DG", dh = 6)

    ! Create PeriodicGenerators to send it to OCN
    call this % register_periodic_event(arr_name = "t2m",  act = "SEND_MP", dst = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "d2m",  act = "SEND_MP", dst = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "u10",  act = "SEND_MP", dst = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "v10",  act = "SEND_MP", dst = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "sst",  act = "SEND_MP", dst = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "strd", act = "SEND_MP", dst = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "ssrd", act = "SEND_MP", dst = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "tp",   act = "SEND_MP", dst = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "ci",   act = "SEND_MP", dst = "OCN", dh = 6)
    !call this % register_periodic_event(arr_name = "ro",   act = "SEND_MP", dst = "OCN", dh = 6)
    
    ! Create PeriodicGenerators to send it to ICE
    if(TRIM(ModelsInfo(CompSplitter % comp_id("ICE")) % model_name())=='ICE_CICE') then
	call this % register_periodic_event(arr_name = "t2m_AI",  act = "SEND_MP", dst = "ICE", dh = 6)
	call this % register_periodic_event(arr_name = "d2m_AI",  act = "SEND_MP", dst = "ICE", dh = 6)
	call this % register_periodic_event(arr_name = "u10_AI",  act = "SEND_MP", dst = "ICE", dh = 6)
	call this % register_periodic_event(arr_name = "v10_AI",  act = "SEND_MP", dst = "ICE", dh = 6)
	call this % register_periodic_event(arr_name = "strd_AI", act = "SEND_MP", dst = "ICE", dh = 6)
	call this % register_periodic_event(arr_name = "ssrd_AI", act = "SEND_MP", dst = "ICE", dh = 6)
	call this % register_periodic_event(arr_name = "tp_AI",   act = "SEND_MP", dst = "ICE", dh = 6)
    end if
    
    !call this % register_periodic_event(arr_name = "t2m",	act = "SAVE_DG", dm = atm_dg_period)
    !call this % register_periodic_event(arr_name = "d2m",	act = "SAVE_DG", dm = atm_dg_period)
    !call this % register_periodic_event(arr_name = "ssrd",	act = "SAVE_DG", dm = atm_dg_period)
    !call this % register_periodic_event(arr_name = "strd",	act = "SAVE_DG", dm = atm_dg_period)
    !call this % register_periodic_event(arr_name = "sst",	act = "SAVE_DG", dm = atm_dg_period)
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program before main time cycle.
! Here you should do all model preparation actions.
!----------------------------------------------------------------------------------------

subroutine ini_main(this)
    class(atm_interim_cpl_adapter) :: this

end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at every step of time cycle. 
! Here you should represent one time step of your model with all physics and internal 
! exhanges (like halo MPI-updates).
!----------------------------------------------------------------------------------------

subroutine make_step(this)
    class(atm_interim_cpl_adapter) :: this
    
	!integer i,j
	!temp=sst
	!do j=1,dec % j_size_loc()
	!do i=1,dec % i_size_loc()
	!	if(temp(i,j).lt.-32766.) temp(i,j)=interim_search_nearest(i,j,sst,-32766.)
	!end do
	!end do
	!sst=temp
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at the end.
! Here you should do all postprocesing actions and memory deallocations.
!----------------------------------------------------------------------------------------

subroutine finalize(this)        
    class(atm_interim_cpl_adapter) :: this        

    deallocate(t_2, q_2, u_10, v_10)
    deallocate(swdn, lwdn, prec, runoff, sst)
    
end subroutine

!========================================================================================
	
	real(kind=4) function interim_search_nearest(i_c,j_c,field, misVal)
	
	! Input variables
	integer i_c, j_c
	real(kind=4) field(dec % i_size_loc(), dec % j_size_loc())
	real(kind=4) misVal
	
	! Work variables
	integer rad
	integer s,n,w,e
	
	! Search with increasing radius
	do rad = 1, MAX(dec % i_size_loc(),dec % j_size_loc())
		s = MAX(j_c-rad, 1)
		n = MIN(j_c+rad, dec % j_size_loc())
		w = MAX(i_c-rad, 1)
		e = MIN(i_c+rad, dec % i_size_loc())
		
		! Get mean value of search result
		if(ANY(field(w:e, s:n) .ge. misVal)) then
			interim_search_nearest = SUM(field(w:e, s:n), field(w:e, s:n) .ge. misVal)/COUNT(field(w:e, s:n) .ge. misVal)
			return
		end if
	end do
	
	! If we found nothing
	Stop 'Interim search nearest error'
	
	end function interim_search_nearest

end module
    