!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by off_main program. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================
!-------
!	Generate grid for CICE model
!	Generating sea-land mask for CICE
!	author Bayburin, Ruslan 2015
!	2016.05.10	editted by Ibrayev, Rashit
!	2018.02		translated to CMF3 framework bu Konstantin Ushakov
!-------

module ice_cice_off_adapter_module
use offline_module
implicit none
    
type, extends(Offline) :: ice_cice_off_adapter
 contains
    procedure, public :: make_grid
    procedure, public :: make_ic
end type
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by off_main program to get information about model grid.
! Here you should build your grid and then call this % register_grid(grid).
!----------------------------------------------------------------------------------------

subroutine make_grid(this, name, dims, grid_type)
	class(ice_cice_off_adapter) :: this
	
	integer i,j,il,jl
	real(kind=8), parameter :: deg_to_rad = 3.1415926535d0 / 180d0
	real(kind=8), parameter :: radius = 0.64d9, m_to_cm = 1d2
	
	type(FileHandler_NC) :: fh

	!space grid and coordinate parameters
	real (kind=8), allocatable:: x1_v	(:,:)
	real (kind=8), allocatable:: x2_v	(:,:)
	real (kind=8), allocatable:: x1_t	(:,:)
	real (kind=8), allocatable:: x2_t	(:,:)
	real (kind=8), allocatable:: dx1_nw_v	(:,:)
	real (kind=8), allocatable:: dx1_ne_v	(:,:)
	real (kind=8), allocatable:: dx2_en_v	(:,:)
	real (kind=8), allocatable:: dx2_es_v	(:,:)
	real (kind=8), allocatable:: dx1_nw_t	(:,:)
	real (kind=8), allocatable:: dx1_ne_t	(:,:)
	real (kind=8), allocatable:: dx2_en_t	(:,:)
	real (kind=8), allocatable:: dx2_es_t	(:,:)
	real (kind=8), allocatable:: work	(:,:)
	real (kind=8), allocatable:: ulat	(:,:)
	real (kind=8), allocatable:: ulon	(:,:)
	real (kind=8), allocatable:: htn	(:,:)
	real (kind=8), allocatable:: hte	(:,:)
	real (kind=8), allocatable:: angle	(:,:)
	logical exists
	
	! These parameters are passed from main program - you can use it
	character(*), intent(in) :: name, grid_type
	integer, intent(in) :: dims(3)

	! This object you should fill
	type(ModelGrid) :: grid
	
	! Initialize grid object and allocate arrays
	call grid % init(name, dims, grid_type) 
	
	!-------
	!	Set grid size. here (il,jl) (inmio) = (nx,ny) + (2,2)
	!	example
	!		inmio il=42, jl=42
	!		cice  dims(1)=40, dims(2)=40
	!-------
	il = dims(1) + 2
	jl = dims(2) + 2
	!write(*, *) "cice_make_grid: il,jl,dims(1), dims(2)",il,jl,dims(1), dims(2)
	
	!-------
	!	Initiate parameters by calling ini_params of cpl_module.f90
	!	Reading namelist for grid type (tripole or spherical rectangular)
	!-------
	!call ice_cice_driver_ini_params
	
	! Allocate grid arrays
	allocate (x1_v		(1:il, 1:jl))
	allocate (x2_v		(1:il, 1:jl))
	allocate (x1_t		(1:il, 1:jl))
	allocate (x2_t		(1:il, 1:jl))
	allocate (dx1_nw_v	(1:il, 1:jl) )
	allocate (dx1_ne_v	(1:il, 1:jl) )
	allocate (dx2_en_v	(1:il, 1:jl) )
	allocate (dx2_es_v	(1:il, 1:jl) )
	allocate (dx1_nw_t	(1:il, 1:jl) )
	allocate (dx1_ne_t	(1:il, 1:jl) )
	allocate (dx2_en_t	(1:il, 1:jl) )
	allocate (dx2_es_t	(1:il, 1:jl) )
	allocate (work		(1:il, 1:jl) )
	x1_v	 = 0.
	x2_v	 = 0.
	x1_t	 = 0.
	x2_t	 = 0.
	dx1_ne_v = 0
	dx1_nw_v = 0
	dx2_en_v = 0
	dx2_es_v = 0
	dx1_ne_t = 0
	dx1_nw_t = 0
	dx2_en_t = 0
	dx2_es_t = 0
	work	 = 0
	allocate( ulat		(dims(1),dims(2)) )
	allocate( ulon		(dims(1),dims(2)) )
	allocate( htn		(dims(1),dims(2)) )
	allocate( hte		(dims(1),dims(2)) )
	allocate( angle		(dims(1),dims(2)) )
	ulat	= 0
	ulon	= 0
	htn	= 0
	hte	= 0
	angle	= 0
	
	! Check for file with additional grid info
	inquire(file = add_grid_info_filename(), exist = exists)
	if(.not. exists) then
		write(*, '(A)') "Error: no additional grid info from ocean grid generation file is present"
		write(*, '(A)') add_grid_info_filename() // " does not exist"
		stop 91
	endif
	
	
	!-------
	!	read grid from file made by inmio. all 'inmio' grid arrays are equal to inmio
	!-------
	call fh % open_file(add_grid_info_filename())
	
	call fh % open_var("x1_v")
	call fh % get(x1_v(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	call fh % open_var("x2_v")
	call fh % get(x2_v(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	
	call fh % open_var("x1_t")
	call fh % get(x1_t(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	call fh % open_var("x2_t")
	call fh % get(x2_t(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	
	call fh % open_var("dx1_nw_v")
	call fh % get(dx1_nw_v(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	call fh % open_var("dx1_ne_v")
	call fh % get(dx1_ne_v(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	call fh % open_var("dx2_en_v")
	call fh % get(dx2_en_v(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	call fh % open_var("dx2_es_v")
	call fh % get(dx2_es_v(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	
	call fh % open_var("dx1_nw_t")
	call fh % get(dx1_nw_t(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	call fh % open_var("dx1_ne_t")
	call fh % get(dx1_ne_t(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	call fh % open_var("dx2_en_t")
	call fh % get(dx2_en_t(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	call fh % open_var("dx2_es_t")
	call fh % get(dx2_es_t(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	
	call fh % open_var("angle")
	call fh % get(work(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
	
	call fh % close_file()
		
	!-------
	!	make T-cell of inmio coincide with T-cell of cice
	!	T-cell(i+1,j+1)(inmio) => T-cell(i,j)(cice) for i = 1,nx
	!	variable distribution in T-cell of CICE, POP
	!	ref. The Parallel Ocean Program (POP) Reference Manual LAUR-10-01853 23 March 2010
	!	by definition of CICE & POP the T-point is placed at center of the T-cell
	!-------
	!-------
	!
	!
	!		   INMIO				  CICE
	!				FOR inmio (i,j)
	!
	!      V(i,j+1)                V(i+1,j+1)      V(i-1,j)               V(i,j)
	!       *-----------+-----------*		*-----------+-----------*
	!       !           !           !		!           !           !
	!       !                       !		!                       !
	!       !           !           !		!           !           !
	!       !         T(i+1,j+1)    !		!         T(i,j)        !
	!       + - - - - - + - - - - - +	==>	+ - - - - - + - - - - - +	
	!       !                       !		!                       !
	!       !           !           !		!           !           !
	!       !                       !		!                       !
	!       !           !           !		!           !           !
	!       *-----------+-----------*		*-----------+-----------*
	!      V(i,j)                 V(i+1,j)        V(i-1,j-1)              V(i,j-1)
	!


	!--------------------------INSERTION: shifting the grid halfstep right-----------------------------
	!Interpolating ANGLE from INMIO T-points to shifted CICE V-points
	do j = 1, dims(2)
	do i = 1, dims(1)
		angle(i,j) = (work(i+2,j+2)+work(i+2,j+1))*0.5d0
	end do
	end do

	do i=1,il-1
		work(i,:)=(x1_t(i,:)+x1_t(i+1,:))*0.5d0
	end do
	x1_t=work
	x1_t(1 ,:)=x1_t(il-1,:)
	x1_t(il,:)=x1_t(2   ,:)

	do i=1,il-1
		work(i,:)=(x1_v(i,:)+x1_v(i+1,:))*0.5d0
	end do
	x1_v=work
	x1_v(1 ,:)=x1_v(il-1,:)
	x1_v(il,:)=x1_v(2   ,:)
	!----------------------------------------------------------------------------------------------------


	!------------------------------------------------------------------------------
	!	compute CICE grid parameters for interpolating weights
	!------------------------------------------------------------------------------
	!-------
	!	define (lon,lat) coordinates of corner points of T-cell
	!-------
	!	corner(1 - ne
	!	corner(2 - nw
	!	corner(3 - sw
	!	corner(4 - se
	!-------
	do j = 1, dims(2)
	do i = 1, dims(1)
		grid % center_lon(  i,j) = x1_t(i+1,j+1)
		grid % corner_lon(1,i,j) = x1_v(i+1,j+1)
		grid % corner_lon(2,i,j) = x1_v(i  ,j+1)
		grid % corner_lon(3,i,j) = x1_v(i  ,j  )
		grid % corner_lon(4,i,j) = x1_v(i+1,j  )

		grid % center_lat(  i,j) = x2_t(i+1,j+1)
		grid % corner_lat(1,i,j) = x2_v(i+1,j+1)
		grid % corner_lat(2,i,j) = x2_v(i  ,j+1)
		grid % corner_lat(3,i,j) = x2_v(i  ,j  )
		grid % corner_lat(4,i,j) = x2_v(i+1,j  )
	end do
	end do

	!------------------------------------------------------------------------------
	!	compile grid for CICE
	!------------------------------------------------------------------------------
	!-------
	!	define (lon,lat) coordinates of V-cell
	!-------
	do j = 1, dims(2)
	do i = 1, dims(1)
		ulon		 (  i,j) = x1_v(i+1,j+1)
		ulat		 (  i,j) = x2_v(i+1,j+1)
	end do
	end do

	!-------
	!	define grid spacings [m] (rightshifted grid)
	!-------
	do j = 1, dims(2)
	do i = 1, dims(1)
		htn(i,j) = dx1_nw_t(i+2,j+1) + dx1_ne_t(i+1,j+1)	!dx1_nw_t(i+1,j+1) + dx1_ne_t(i+1,j+1)
		hte(i,j) = dx2_en_v(i+1,j  ) + dx2_es_v(i+1,j+1)	!dx2_en_t(i+1,j+1) + dx2_es_t(i+1,j+1)
	end do
	end do
		
	!HUS and HUW are not used. These are not shifted!
	!do j = 1, this % ny
	!do i = 1, this % nx
	!	hus(i,j) = dx1_nw_v(i+1,j  ) + dx1_ne_v(i+1,j  )
	!	huw(i,j) = dx2_en_v(i  ,j+1) + dx2_es_v(i  ,j+1)
	!end do
	!end do

	!-------
	!	transfer to units used in CICE [cm], [rad]
	!-------
	ulat = ulat * deg_to_rad
	ulon = ulon * deg_to_rad
	htn = htn * m_to_cm
	hte = hte * m_to_cm
	!hus = hus * m_to_cm
	!huw = huw * m_to_cm

	!htn(il,:) = htn(il-1,:)
	!htn(:,jl) = htn(:,jl-1)
	!hte(il,:) = hte(il-1,:)
	!hte(:,jl) = hte(:,jl-1)
			
	call fh % create_file("./data/cice.grid.nc")
	call fh % create_dim('i', dims(1))
	call fh % create_dim('j', dims(2))
	call fh % create_dim('k', dims(3))
					
	call fh % create_var("ulat", "real8", "i", "j")
	call fh % put(ulat, (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
	call fh % put_att("units", "rad")        
	call fh % put_att("long_name", "U-node latitude") 
		
	call fh % create_var("ulon", "real8", "i", "j")
	call fh % put(ulon, (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
	call fh % put_att("units", "rad")        
	call fh % put_att("long_name", "U-node longitude") 
		
	call fh % create_var("htn", "real8", "i", "j")
	call fh % put(htn, (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
	call fh % put_att("units", "cm")        
	call fh % put_att("long_name", "Height of north edge of T-node")
	
	call fh % create_var("hte", "real8", "i", "j")
	call fh % put(hte, (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
	call fh % put_att("units", "cm")        
	call fh % put_att("long_name", "Height of east edge of T-node")
		
	call fh % create_var("angle", "real8", "i", "j")
	call fh % put(angle, (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
	call fh % put_att("units", "rad")        
	call fh % put_att("long_name", "angle FROM true east TO grid east")
	
	call fh % close_file()
	
	call cice_make_mask()

	grid % level = 0

	! Register grid if Offline block
	call this % register_model_grid(grid)
        
	contains

		subroutine cice_make_mask()

			!botom topography arrays
			real (kind=8), allocatable:: kv (:,:)
			real (kind=8), allocatable:: kt (:,:)
			real (kind=8), allocatable:: kmt	(:,:)

			allocate (kv(1:il, 1:jl))
			allocate (kt(1:il, 1:jl))
			kv =0
			kt =0
			allocate( kmt(dims(1), dims(2) ))
			kmt=0
		
			!read mask of the region from file made by inmio. all 'inmio' arrays are equal to inmio
			call fh % open_file(add_grid_info_filename())
	
			call fh % open_var("kv")
			call fh % get(kv(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
			call fh % open_var("kt")
			call fh % get(kt(1:il, 1:jl), lo = (/ 1, 1 /), hi = (/ il, jl /))
			
			
			!-------
			!start==>	test mapping with mask
			!-------
			!-------
			!	make island in CICE region (only in 160x80 configuration)
			!-------
			!if(dims(1) == 160 .and. dims(2) == 80) then
			!	do j = 1, dims(2)
			!	do i = 1, dims(1)
			!		!if(i >= 20.and.i<=60.and.j>=30.and.j<=60) kv (i,j) = 0
			!		if((i-40)**2+1.5*(j-45)**2<400 ) kv (i,j) = 0
			!	end do
			!	end do
			!end if
			!-------
			!<==end	test mapping with mask 
			!-------

			!make kmt - '~mask' for CICE
			do j = 1, dims(2)
			do i = 1, dims(1)
				if (kv(i+1, j+1) > 0 .or. kv(i+1, j) > 0) kmt (i,j) = max(kv(i+1,j+1),kv(i+1,j))
			end do
			end do

		
			!make mask2D - mask for interpolating weights
			!grid % mask2D = misValInt
			!grid % mask2D = missval
			grid % mask2D = 0

			do j = 1, dims(2)
			do i = 1, dims(1)
				if (kv(i+1, j+1) > 0 .or. kv(i+1, j) > 0) grid % mask2D (i,j) = 1
			end do
			end do

			call fh % create_file("./data/cice.kmt.nc")
			call fh % create_dim('i', dims(1))
			call fh % create_dim('j', dims(2))
			call fh % create_dim('k', dims(3))							
							
			call fh % create_var("kmt", "real8", "i", "j")
			call fh % put(kmt, (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
			call fh % put_att("units", "metres")        
			call fh % put_att("long_name", "kmt") 
			
			call fh % close_file()
			
			write(*,*), "MASK for WTS Remaping"
			call fh % create_file("./data/ICE.mask.nc")
				call fh % create_dim('i', dims(1))
				call fh % create_dim('j', dims(2))
				call fh % create_dim('k', dims(3))
								
				call fh % create_var("center_lat", "real4", "i", "j")
				call fh % put(real(grid % center_lat), (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
				call fh % put_att("units", "degrees_north")        
				call fh % put_att("long_name", "latitude") 
				call fh % put_att("axis", "Y") 
				
				call fh % create_var("center_lon", "real4", "i", "j")
				call fh % put(real(grid % center_lon), (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
				call fh % put_att("units", "degrees_east")        
				call fh % put_att("long_name", "longitude") 
				call fh % put_att("axis", "X") 
			
				call fh % create_var("mask2D", "real4", "i", "j")
				call fh % put(real(grid % mask2D), (/ 1, 1 /), hi = (/ dims(1), dims(2) /))
				call fh % put_att("units", "unitless")        
				call fh % put_att("long_name", "mask") 
			
			call fh % close_file()
		end subroutine cice_make_mask
		
		function add_grid_info_filename
			character(len=256) add_grid_info_filename
			add_grid_info_filename = "./data/ADD_GRID_INFO_OCN_"//TRIM(n2s(il-2))//'x'//TRIM(n2s(jl-2))//".nc"
		end function add_grid_info_filename    
	!end contains
end subroutine make_grid

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to add to IC-file all data you want.
! Here you should (probably) create FileHandler_NC object and put data.
!----------------------------------------------------------------------------------------

subroutine make_ic(this, name, dims, grid_type)
    class(ice_cice_off_adapter) :: this
    
    ! These parameters are passed from main program - you can use it
    character(*), intent(in) :: name, grid_type
    integer, intent(in) :: dims(3)
        
end subroutine

!========================================================================================

end module