!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module lnd_core_cpl_adapter_module

use component_module
use decomposition_module
implicit none

type, extends(Component) :: lnd_core_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
end type

    integer lnd_i_size, lnd_j_size, lnd_k_size, lnd_m_size, lnd_steps_in_day
    integer lnd_rivers_type
    logical lnd_read_cp
    
    real (kind=4), allocatable :: runoff(:,:),salt_shifted(:,:)
    type(Decomposition) :: dec
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to register your model in the system.
! Here you should (probably) read or define necessary information and 
! must call this % register_model()
!----------------------------------------------------------------------------------------

subroutine ini_reg_comp(this)
    class(lnd_core_cpl_adapter) :: this
    
	namelist /LND_MAIN/ lnd_i_size, lnd_j_size, lnd_k_size, lnd_m_size, lnd_steps_in_day, lnd_read_cp
	namelist /LND_PHYSICS/ lnd_rivers_type
	
	open(9, file= "./configure/lnd_list.in")
	read(9, nml = LND_MAIN)
	read(9, nml = LND_PHYSICS)
	close(9)
    
    dec = Decomposition(lnd_i_size, lnd_j_size, lnd_k_size, "1D", CompSplitter % comm_local_size(), CompSplitter % rank_local())
    
    ! Call registration routine of CMF (it needs only size of grid and timestep in whole(!) seconds)
    call this % register_model(decomp = dec, timestep_sec = 60*60) 
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data() use adresses of your arrays and 
! they should be allocated at time of registration.
! Here you should do all array allocations.
!----------------------------------------------------------------------------------------

subroutine ini_allocate(this)
    class(lnd_core_cpl_adapter) :: this
    
    allocate(runoff(        dec % i_size_loc(), dec % j_size_loc())); runoff = 0
    allocate(salt_shifted(  dec % i_size_loc(), dec % j_size_loc())); salt_shifted = 0

end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program to register all data you want to interact with system.
! Here you should call this % register_array(), this % register_*_event() or
! this % raise_event() to get result immediately.
!----------------------------------------------------------------------------------------

subroutine ini_reg_data(this)
    class(lnd_core_cpl_adapter) :: this
    
    !==================================================================
    !------------corrected normal year forcing-------------------------    
    !==================================================================
    
    ! Register required arrays  
    call this % register_array(arr_name = "runoff",   arr = runoff)
!     call this % register_array(arr_name = "salt",     arr = salt_shifted)
    
    ! Create SyncedGenerators to sync with NCAR files
	if(lnd_rivers_type==2)  call this % register_synced_event(arr_name = "runoff",  src = "./data/IAFv2/runoff.daitren.iaf.snapo-2010-2018.nc")    
	if(lnd_rivers_type==1)  call this % register_synced_event(arr_name = "runoff",  src = "./data/CNYFv2/runoff.1948-2007.cmf3.nc")
    !     call this % register_synced_event(arr_name = "salt",    src = "./data/CNYFv2/salt_shifted.nc")    
    
    ! Create PeriodicGenerators to send it to OCN
    call this % register_periodic_event(arr_name = "runoff",  act = "SEND_MP", dst = "OCN", dh = 24)
!     call this % register_periodic_event(arr_name = "salt",    act = "SEND_MP", dst = "OCN", dh = 24)
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program before main time cycle.
! Here you should do all model preparation actions.
!----------------------------------------------------------------------------------------

subroutine ini_main(this)
    class(lnd_core_cpl_adapter) :: this

end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at every step of time cycle. 
! Here you should represent one time step of your model with all physics and internal 
! exhanges (like halo MPI-updates).
!----------------------------------------------------------------------------------------

subroutine make_step(this)
    class(lnd_core_cpl_adapter) :: this
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at the end.
! Here you should do all postprocesing actions and memory deallocations.
!----------------------------------------------------------------------------------------

subroutine finalize(this)        
    class(lnd_core_cpl_adapter) :: this        

    deallocate(runoff, salt_shifted)
    
end subroutine

!========================================================================================

end module
    