!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by off_main program. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module lnd_core_off_adapter_module
use offline_module
implicit none
    
type, extends(Offline) :: lnd_core_off_adapter
 contains
    procedure, public :: make_grid
    procedure, public :: make_ic
end type
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by off_main program to get information about model grid.
! Here you should build your grid and then call this % register_grid(grid).
!----------------------------------------------------------------------------------------

subroutine make_grid(this, name, dims, grid_type)
    class(lnd_core_off_adapter) :: this
    
    ! These parameters are passed from main program - you can use it
    character(*), intent(in) :: name, grid_type
    integer, intent(in) :: dims(3)

    ! This object you should fill
    type(ModelGrid) :: grid
    
    ! Input file
    character(*), parameter :: filename = "../data/CNYFv2/runoff.daitren.clim.10FEB2011.nc"
    type(FileHandler_NC) :: fh
    
    ! netCDF variables
    integer ncid
    integer nx_dimid, ny_dimid
    integer lon_id, lat_id
    integer nc_err
    
    ! Work variables
    integer i, j, counter, il, jl

    ! Temporary grid variables
    real(kind = 8), dimension(dims(1), dims(2)) :: input_lat, input_lon
    real(kind = 8), dimension(dims(1), dims(2), 4) :: input_corner_lat,input_corner_lon

!===================================
! Inquire grid from CORE netCDF-file
!===================================

    ! Open file and get dims
    call fh % open_file(filename)
    il = fh % get_dim_size("ni")
    jl = fh % get_dim_size("nj")
    
    if(il /= dims(1) .OR. jl /= dims(2)) then
        write(*,*) 'Error in LND_CORE function: wrong grid sizes of input netCDF.'
        stop
    end if
            
    ! Inquire coordinate variables
    call fh % open_var("xc")
    call fh % get(input_lon, [1, 1], [il, jl])

    call fh % open_var("yc")
    call fh % get(input_lat, [1, 1], [il, jl])
            
    call fh % open_var("xv")
    call fh % get(input_corner_lon, [1, 1, 1], [il, jl, 4])
            
    call fh % open_var("yv")
    call fh % get(input_corner_lat, [1, 1, 1], [il, jl, 4]) 
         
    call fh % close_file()
    
!=====================================================
! Fill ouput 'ModelGrid' structure with our information 
!=====================================================

    ! Initialize grid object and allocate arrays
    call grid % init(name, dims, grid_type) 

    do j = 1, jl
    do i = 1, il
        grid % center_lat(i,j  ) = input_lat(i,j) 
        grid % corner_lat(1,i,j) = input_corner_lat(i,j,1)
        grid % corner_lat(2,i,j) = input_corner_lat(i,j,2)
        grid % corner_lat(3,i,j) = input_corner_lat(i,j,3)
        grid % corner_lat(4,i,j) = input_corner_lat(i,j,4)
 
        grid % center_lon(i,j  ) = input_lon(i,j)
        grid % corner_lon(1,i,j) = input_corner_lon(i,j,1)
        grid % corner_lon(2,i,j) = input_corner_lon(i,j,2)
        grid % corner_lon(3,i,j) = input_corner_lon(i,j,3)
        grid % corner_lon(4,i,j) = input_corner_lon(i,j,4)
    end do
    end do
        
    grid % mask2D = 1
    grid % level(:) = 0.    
    
    ! Register grid if Offline block
    call this % register_model_grid(grid)
        
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to add to IC-file all data you want.
! Here you should (probably) create FileHandler_NC object and put data.
!----------------------------------------------------------------------------------------

subroutine make_ic(this, name, dims, grid_type)
    class(lnd_core_off_adapter) :: this
    
    ! These parameters are passed from main program - you can use it
    character(*), intent(in) :: name, grid_type
    integer, intent(in) :: dims(3)
        
end subroutine

!========================================================================================

end module