!===============================================================
!	The hv array contains raw topography data (meters). 
!	By default it is interpolated to model grid from ETOPO5 database.   
!	You may redefine it here.
!===============================================================

subroutine o_user_redefine_topo

	use o_grid_module, only: hv,i,j,il,jl
	implicit none
	
	!--- test pool ---
	!hv=0.
	!do j = jl/4, jl/4*3
	!do i = il/4, il/4*3
	!	hv(i,j)=1000.
	!end do
	!end do

end


!===============================================================
!	You may finally tune bottom topography array manually 
!===============================================================

subroutine o_user_bottom_tuning

	use o_grid_module, only: kv
	implicit none
	
	kv(925,685:695)=0. !eliminating Gibraltar and all Mediterranean
end

!===============================================================
!	By default initial T,S fields are interpolated to model grid from WOA2009 database.   
!	You may redefine them here. 
!===============================================================

subroutine o_user_redefine_T (initial_T)

	use o_grid_module, only: i,j,il, jl, kl, z, k, kt
	implicit none
	real(kind=4), dimension(2:il-1, 2:jl-1, kl) :: initial_T
	
	!--- stable test initial field ---
	!call o_user_grid_z
	!initial_T=0.
	!do j = 2, jl-1
	!do i = 2, il-1
	!do k = 1, kt(i,j)
	!	initial_T(i,j,k) = 4. + 20. * exp(-z(k)/500.)
	!end do
	!end do
	!end do

end

subroutine o_user_redefine_S (initial_S)

	use o_grid_module, only: i,j,il, jl, kl, z, k, kt
	implicit none
	real(kind=4), dimension(2:il-1, 2:jl-1, kl) :: initial_S
	
	!--- stable test initial field ---
	!call o_user_grid_z
	!initial_S=0.
	!do j = 2, jl-1
	!do i = 2, il-1
	!do k = 1, kt(i,j)
	!	initial_S(i,j,k) = 35. -  5. * exp(-z(k)/500.)
	!end do
	!end do
	!end do

end