!===============================================================
!	The hv array contains raw topography data (meters). 
!	By default it is interpolated to model grid from ETOPO5 database.   
!	You may redefine it here.
!===============================================================

	subroutine o_user_redefine_topo
!-------
!	make topography for test pool
!-------
	use o_grid_module, only: hv,i,j,il,jl,i_cycle,j_cycle
	implicit none
!-------
!	make 'zero' frame
!-------
	if(i_cycle.eq.0) then
		do j=1,jl 
		hv(1   ,j)=0.
		hv(2   ,j)=0.	!	this 'zero' frame (land frame) made for coupling with cice. 
		end do

		do j=1,jl 
		hv(il-1,j)=0.
		hv(il  ,j)=0.
		end do
!	else
!		do j=1,jl 
!		hv(2,j)=min(hv(2,j),hv(il-1,j))
!		hv(2,j)=min(hv(2,j),hv(il  ,j))
!		
!		hv(il-1,j)=hv(1,j)
!		hv(il  ,j)=hv(2,j)
!		end do
	end if

	
	if(j_cycle.eq.0) then
		do i=1,il
		hv(i,1   )=0.
		hv(i,2   )=0.	!	this 'zero' frame (land frame) made for coupling with cice. 
		end do

		do i=1,il
		hv(i,jl-1)=0.
		hv(i,jl  )=0.
		end do
	end if


end


!===============================================================
!	You may finally tune bottom topography array manually 
!===============================================================

subroutine o_user_bottom_tuning

	use o_grid_module, only: kv
	implicit none
	
end

!===============================================================
!	By default initial T,S fields are interpolated to model grid from WOA2009 database.   
!	You may redefine them here. 
!===============================================================

subroutine o_user_redefine_T (initial_T)

	use o_grid_module, only: i,j,il, jl, kl, z, k, kt
	implicit none
	real(kind=4), dimension(2:il-1, 2:jl-1, kl) :: initial_T

end

subroutine o_user_redefine_S (initial_S)

	use o_grid_module, only: i,j,il, jl, kl, z, k, kt
	implicit none
	real(kind=4), dimension(2:il-1, 2:jl-1, kl) :: initial_S
end
