#!/bin/bash
#PBS -N inmio-slav
#PBS -l nodes=74
#PBS -l walltime=00:60:00
#PBS -q x12core
WDIR=/data4t/ushakov/VITIM3.1/vitim3.1/coupling

if [[ "X" != "X${PBS_JOBID}" ]]; then
    I_MPI_NODEFILE=$WDIR${PBS_JOBID}.hosts
    uniq ${PBS_NODEFILE} > ${I_MPI_NODEFILE}
else
   I_MPI_NODEFILE=machines.txt
   cp ${I_MPI_NODEFILE} $WDIR
fi


export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/data4t/rrd/libs13

#export LD_LIBRARY_PATH=/data4t/rrd/libs14:$LD_LIBRARY_PATH
#ls /data4t/rrd/libs14

echo $LD_LIBRARY_PATH

. /$HOME/.bashrc
export OMP_NUM_THREADS=1
# export I_MPI_DEBUG=4
cd $WDIR
  
  
  # ATM optimal number of cores: 32, 36, 42, 52, 64
  
  # mpiexec ./cpl CPL 2 ATM 42 p01 4 0 0
  
  # mpiexec ./cpl CPL 2 OCN 30 p01 4 0 0
  
   mpiexec ./model.exe CPL 2 OCN 30 ATM 42 tst 4 0 0 > output_inmio-slav.txt
  
  # mpiexec ./cpl CPL 2 OCN 30 ATM 36 p01 4 0 0
  
  # mpiexec ./cpl CPL 2 OCN 18 ATM 32 p01 4 0 0
  
  #124
  #mpiexec ./cpl CPL 1 OCN 60 ATM 63 09n 4 0 0
  
  #252 NOT WORKS!
  #mpiexec ./cpl CPL 1 OCN 126 ATM 125 09b 4 0 0
  
  #258
  #mpiexec ./cpl CPL 1 OCN 132 ATM 125 09m 4 0 0
  
  #288
  #mpiexec ./model.exe CPL 1 OCN 162 ATM 125 11q 4 0 0 > output_inmio-slav.txt
  
  #138
  #mpiexec ./cpl CPL 3 OCN 72 ATM 63 09b 4 0 0
  
  #mpiexec ./cpl CPL 2 OCN 60 ATM 50 09a 4 0 0
  
  
  #  63 
  #mpiexec ./cpl CPL 1 OCN 34 ATM 28 08e 4 0 0
  
  #  72 e5core (10+12): 1 min - 6.5 hour, 22 hour - 1 year
  #mpiexec ./cpl CPL 2 OCN 28 ATM 42 02c 4 0 0
  
  #  85 
  #mpiexec ./cpl CPL 1 OCN 48 ATM 36 08b 4 0 0
  
  #  96 e5core (10+12): 1 min - 16 hour, 12 hour - 1 year        3min-2jan13.40  4min-3jan01.20
  #mpiexec ./cpl CPL 2 OCN 52 ATM 42 08e 4 0 0
  
  #mpiexec ./cpl CPL 3 OCN 90 ATM 63 07c 4 0 0
  
  # 100 e5core (10+12): 1 min - 16 (14) hour, 12 hour - 1 year,  3min-2jan20.40  4min-3jan01.20
  # mpiexec ./cpl CPL 2 OCN 56 ATM 42 02c 4 0 0
  
  # 104 e5core (10+12): 1 min - 16 (12) hour, 12 hour - 1 year,  3min-2jan12.20
  # mpiexec ./cpl CPL 2 OCN 52 ATM 50 02c 4 0 0
  
  # 112 e5core (10+12): 1 min - xx (16) hour, 9.2 hour - 1 year, 3min-3jan01.20  4min-3jan13.40
  # mpiexec ./cpl CPL 2 OCN 60 ATM 50 02c 4 0 0
  
  
  # 78 ATM_NCAR
  #mpiexec ./cpl CPL 2 OCN 52 ATM 24 1nc 4 0 0
  
  #  106
  #mpiexec ./cpl CPL 2 OCN 64 ATM 42 p01 4 0 0
  
  # 108 e5core (10+12): 1 min - 17 hour, 12 hour - 1 year
   
  # mpiexec ./cpl CPL 1 OCN 30 ATM 36 p01 4 0 0
  
  # 106 e5core (10+12): NOT WORKS (coupler)
  
  
  
  
  # mpiexec ./cpl CPL 2 OCN 62 ATM 52 p01 4 0 0
  
  #> output.txt

  #mpiexec ./cpl CPL 4 ATM 16 test 30 0 0
  
  #mpiexec ./cpl CPL 4 OCN 36 ATM 36 test 30 0 0
  
  #mpiexec ./cpl 2014 01 02 12
  
#  mpiexec ./slm072L28 2014 01 02 12

#  mpiexec ./slm072L28 /data4t/rrd/NWPlab/data/slav/init/400x250/slmstv_02012012_all.nc zz_ctrp_06.nc zz_diag_06.nc
#  mpiexec ./slm072L28 zz_ctrp_06_1.nc zz_ctrp_12.nc zz_diag_12.nc
#  mpiexec ./slm072L28 zz_ctrp_12_2.nc zz_ctrp_18.nc zz_diag_18.nc
#  mpiexec ./slm072L28 zz_ctrp_18_2.nc zz_ctrp_24.nc zz_diag_24.nc

#  mpiexec ./slm072L28 /data4t/rrd/NWPlab/data/slav/init/400x250/slmstv_02012012_all.nc zz_ctrp_12.nc zz_diag_12.nc
#  mpiexec ./slm072L28 zz_ctrp_12_1.nc zz_ctrp_24.nc zz_diag_24.nc
#  mpiexec ./slm072L28 zz_ctrp_24_1.nc zz_ctrp_36.nc zz_diag_36.nc
#  mpiexec ./slm072L28 zz_ctrp_36_1.nc zz_ctrp_48.nc zz_diag_48.nc



mpicleanup -t -f ${I_MPI_NODEFILE}



# dat          6.50  0.84
# netcdf m0h2  6.50  0.80



# LPHYS=false

# 36 FI0.984968E+05 VR0.121190E-07 KE0.183306E+08 DV-.904821E-11 0.7399516E+05  0.1942961E+05  0.5629241E+08  0.4990093E-02  0.2556256E+04 
# 36 FI0.984968E+05 VR0.121191E-07 KE0.183306E+08 DV-.906021E-11 0.7399516E+05  0.1942961E+05  0.5629241E+08  0.4990093E-02  0.2556257E+04

# 37 FI0.984968E+05 VR0.120804E-07 KE0.183550E+08 DV-.863026E-11 0.7409233E+05  0.1945661E+05  0.5629193E+08  0.4989334E-02  0.2557540E+04
#  1 FI0.984968E+05 VR0.155809E-10 KE0.183550E+08 DV-.864226E-11 0.7409233E+05  0.1945662E+05  0.5629193E+08  0.4989334E-02  0.2557542E+04

# 72 FI0.984968E+05 VR0.958474E-08 KE0.186904E+08 DV-.904683E-11 0.7511519E+05  0.2014331E+05  0.5628206E+08  0.4958266E-02  0.2566786E+04
# 36 FI0.984968E+05 VR-.320141E-08 KE0.186825E+08 DV-.916284E-11 0.7508343E+05  0.2013468E+05  0.5628209E+08  0.4958314E-02  0.2565209E+04

# 73 FI0.984968E+05 VR-.229496E-09 KE0.187069E+08 DV-.879421E-11 0.7517837E+05  0.2016390E+05  0.5628174E+08  0.4957191E-02  0.2567992E+04
#  1 FI0.984968E+05 VR-.229250E-09 KE0.186990E+08 DV-.887131E-11 0.7514719E+05  0.2015504E+05  0.5628177E+08  0.4957239E-02  0.2566409E+04

#108 FI0.984968E+05 VR-.159316E-09 KE0.192304E+08 DV-.872107E-11 0.7672456E+05  0.2128596E+05  0.5627081E+08  0.4911160E-02  0.2562857E+04
# 36 FI0.984968E+05 VR-.167117E-09 KE0.192275E+08 DV-.889117E-11 0.7671856E+05  0.2127703E+05  0.5627089E+08  0.4911308E-02  0.2561428E+04

#109 FI0.984968E+05 VR-.929227E-10 KE0.192471E+08 DV-.828074E-11 0.7676855E+05  0.2132718E+05  0.5627042E+08  0.4909573E-02  0.2563708E+04
#  1 FI0.984968E+05 VR-.129657E-09 KE0.192442E+08 DV-.839011E-11 0.7676314E+05  0.2131793E+05  0.5627050E+08  0.4909721E-02  0.2562287E+04

#144 FI0.984968E+05 VR-.256912E-08 KE0.197084E+08 DV-.728326E-11 0.7777003E+05  0.2267678E+05  0.5625979E+08  0.4844270E-02  0.2539885E+04
# 36 FI0.984968E+05 VR-.334420E-08 KE0.197010E+08 DV-.726269E-11 0.7775191E+05  0.2265707E+05  0.5625990E+08  0.4844511E-02  0.2537351E+04

# LPHYS=true

#  1 FI0.984968E+05 VR0.168903E-09 KE0.177861E+08 DV-.662388E-11 0.7161361E+05  0.1903612E+05  0.5630752E+08  0.5012775E-02  0.2553653E+04
#  1 FI0.984968E+05 VR0.168903E-09 KE0.177861E+08 DV-.662388E-11 0.7161361E+05  0.1903612E+05  0.5630752E+08  0.5012775E-02  0.2553653E+04

# 36 FI0.984968E+05 VR0.146843E-07 KE0.174854E+08 DV-.678205E-11 0.7080622E+05  0.1831088E+05  0.5629594E+08  0.5088976E-02  0.2581280E+04
# 36 FI0.984968E+05 VR0.146745E-07 KE0.174854E+08 DV-.710699E-11 0.7080589E+05  0.1831097E+05  0.5629591E+08  0.5089148E-02  0.2581297E+04

# 37 FI0.984968E+05 VR0.148257E-07 KE0.174867E+08 DV-.654911E-11 0.7081400E+05  0.1830945E+05  0.5629539E+08  0.5089924E-02  0.2581677E+04
#  1 FI0.984968E+05 VR0.301842E-10 KE0.174867E+08 DV-.669686E-11 0.7081383E+05  0.1830950E+05  0.5629536E+08  0.5090113E-02  0.2581703E+04

# 72 FI0.984968E+05 VR0.178960E-07 KE0.173138E+08 DV-.713149E-11 0.7009570E+05  0.1814680E+05  0.5630249E+08  0.5129464E-02  0.2585801E+04
# 36 FI0.984968E+05 VR0.265683E-08 KE0.173170E+08 DV-.743676E-11 0.7010201E+05  0.1815650E+05  0.5630279E+08  0.5128819E-02  0.2585030E+04

# 73 FI0.984968E+05 VR-.211116E-09 KE0.173092E+08 DV-.758424E-11 0.7007253E+05  0.1814636E+05  0.5630350E+08  0.5129847E-02  0.2586764E+04
#  1 FI0.984968E+05 VR-.210052E-09 KE0.173122E+08 DV-.767255E-11 0.7007817E+05  0.1815580E+05  0.5630382E+08  0.5129122E-02  0.2585978E+04

#108 FI0.984968E+05 VR0.852006E-08 KE0.173092E+08 DV-.699030E-11 0.6992687E+05  0.1829220E+05  0.5632121E+08  0.5135236E-02  0.2581505E+04
# 36 FI0.984968E+05 VR0.844197E-08 KE0.173263E+08 DV-.720707E-11 0.6998500E+05  0.1832093E+05  0.5632161E+08  0.5135162E-02  0.2582194E+04
 
#109 FI0.984968E+05 VR0.876646E-08 KE0.173132E+08 DV-.676845E-11 0.6993921E+05  0.1830020E+05  0.5632096E+08  0.5134904E-02  0.2581798E+04
#  1 FI0.984968E+05 VR-.188326E-09 KE0.173301E+08 DV-.697619E-11 0.6999644E+05  0.1832900E+05  0.5632138E+08  0.5135009E-02  0.2582465E+04

#144 FI0.984968E+05 VR0.197564E-07 KE0.173505E+08 DV-.477017E-11 0.6991043E+05  0.1851904E+05  0.5633763E+08  0.5124659E-02  0.2571360E+04
# 36 FI0.984968E+05 VR0.108719E-07 KE0.173688E+08 DV-.472304E-11 0.6995311E+05  0.1856937E+05  0.5633804E+08  0.5123921E-02  0.2570132E+04



