&OCN_MAIN
il = 1442,			!computational domain width in zonal (X) direction, including haloes (boxes)
jl = 722,			!computational domain width in meridional (Y) direction, including haloes (boxes)
kl = 49,			!computational domain depth (boxes)
ml = 2,				!numer of scalar fields (>= 2)
ocn_steps_in_day = 144,		!number of steps in day for ocean component
ocn_read_cp = .FALSE.		!.TRUE.=read control point, .FALSE.=start from initial conditions
dg_period	= 360,		!diagnostics writing period (min.)
cp_period	= 1440		!control point writing period (min.) - used in CMF3 only
ocn_das_on	= DAS_SED	! ON/OFF data assimilation on OCN (send/recv data to DAS)
/

&OCN_PHYSICS
am_lapl_mode	= 0		!horisontal viscosity mode:	0 - constant (=am_lapl globally), 1 - scaling according to gridsteps (=am_lapl on the equator), 2 - Smagorinsky with scaling background
am_bh_mode	= 2		!horisontal bh viscosity mode:	0 - constant (=am_bh   globally), 1 - scaling according to gridsteps (=am_bh   on the equator), 2 - Smagorinsky with scaling background
am_lapl 	= 0.		!horizontal viscosity (m**2/s) 
am_bh		= -1.5e11	!horizontal bh viscosity (m**4/s)
c_smag_lapl	= 0.		!Smagorinsky coefficient for Laplace (usually 0-4, unitless) 
c_smag_bh	= 1.		!Smagorinsky coefficient for biharmonics (usually 2-4, unitless)
am_lapl_2d	= 0.		!horizontal barotropic viscosity (m**2/s ?)
ah_mode		= 1		!horisontal diffusivity:	0 - constant (=ah    globally), 1 - time-constant but scaling according to gridsteps (=ah    on the equator)
ah_bh_mode	= 0		!horisontal bh diffusivity:	0 - constant (=ah_bh globally), 1 - time-constant but scaling according to gridsteps (=ah_bh on the equator)
ah		= 300.		!horizontal diffusivity (m**2/s)
ah_bh		= 0.		!horizontal biharmonic diffusivity (m**4/s)
sweq_pl 	= 30		!number of barotropic steps per 1 baroclinic
omega		= 0.729e-4	!Earth rotation angular velocity
gravit		= 9.80		!gravitational acceleratiom (m**2/s)
densit 		= 1025.0	!Average density of water (kg/m**3)
gsolar1 	= 0.42		!fraction of short waves in solar radiation
zsolar1 	= 23.		!short-wave radiation penetration depth (m)
v_mix_mod	= 1		!vertical mixing parameterization (0 - constant coefficients (c1Amv,c1Ahv), 1 - Munk-Anderson, 4 - Gent-McWilliams skew formulation)
c1Amv 		= 100.e-4	!maximum (or global constant in case v_mix_mod=0) vertical viscosity (m**2/s)
c2Amv_all	= 1.e-4		!background vertical viscosity (m**2/s)
c1Ahv 		= 10.e-4	!maximum (or global constant in case v_mix_mod=0) vertical diffusivity (m**2/s)
c2Ahv_all	= 0.1e-4	!background vertical diffusivity (m**2/s)
albedo_ocean	= 0.06		!albedo of water
albedo_ice	= 0.8		!albedo of ice
atm_model	= 1		!which atmospheric data we use when atmospheric component is not run: 1 - user-defined parameters, 2 - user-defined fluxes
t_potential_convert=1		!convert initial temperature from in-situ to potential: 1 - yes, 0 - no
/

&OCN_ICE
q_ice 		= 3.36e5	!latent heat of fusion of ice (j/kg) 
d_ice 		= 930.		!density of sea ice (kg/m**3) 
k_ice 		= 2.033		!thermal conductivity of ice (j/(m s k)) 
epsice 		= 1.e-7		!minimum ice-thickness (to distinguish ice-covered and free water)
h0_ice		= 0.2		!normal thickness of new ice (to calculate change of compactness) (m)
hice0		= 0.05		!minimum value of ice thickness (to calculate change of compactness) (m)
/

&OCN_GRID
i_cycle 	= 1		!switch for x-periodic boundary (1 - periodic, 0 - nonperiodic)
j_cycle 	= 1		!switch for y-bipolar periodicity
ssc_flag	= 1		!switch for spherical grid
bsc_flag	= 1		!switch for northern bipolar grid
x1_ssc_size 	= 360.		!x-size of model domain (deg.)
x2_ssc_size 	= 137.5		!y-size of model domain (deg.)
x1_ssc_west_south =  -115.125  	!longitude of the beginning of the model grid (good to be a nice number minus half of gridstep)
x2_ssc_west_south =  -77.625   	!latitude  of the beginning of the model grid
x2_ssc_step = 0.25		!grid y-step in spherical part of the coordinate system (deg.)
pool_min_number	= 1000		!separate pools having less than pool_min_number points will be eliminated during topography creation
i_solution_control = 348
j_solution_control = 321
k_solution_control = 1		!point for inspecting solution in text output
/

&OCN_SCHEMES
scalar_scheme_time	= 1	!time-stepping scheme: 0 for euler, 1 for leapfrog + euler
scalar_scheme_advection	= 2	!scalar transport scheme: 0 - central differences, 1 - upwind, 2 - FCT Zalesak-1979, 3 - SOM Prather-1986
its 			= 1	!1 - integrate thermodynamics, 0 - "frozen" thermodynamics
mixh_m_mode 		= 2	!turbulence parameterization for momentum transport: 0 - Laplace, 1 - Laplace + biharmonics, 2 - biharmonics only
mixh_t_mode 		= 0	!turbulence parameterization for scalar transport:   0 - Laplace, 1 - Laplace + biharmonics, 2 - biharmonics only
coriolis_alfa		= 0.	!Explicit or implicit Coriolis term: 	coriolis_alfa*U('l+1')+
coriolis_gamma		= 1.	!					coriolis_gamma*U('l') + 
coriolis_betta		= 0.	!					coriolis_betta*U('l-1')
/

&OCN_SWEQ
gamma_sweq	= 0.0		!time staggerring parameter for sweq
/
