&setup_nml
    days_per_year  = 365
  , use_leap_years = .false.
  , year_init      = 2019
  , istep0         = 41472
  , dt             = 600.0
  , npt            = 87600
  , ndtd           = 1
  , runtype        = 'initial'
  , ice_ic         = './restart/iced.SED_DATE-00000.nc'
  , restart        = .true.
  , restart_ext    = .false.
  , use_restart_time = .true.
  , restart_format = 'nc'
  , lcdf64         = .false.
  , restart_dir    = './restart/'
  , restart_file   = 'iced'
  , pointer_file   = './restart/ice.restart_file'
  , dumpfreq       = 'd'
  , dumpfreq_n     = 1
  , dump_last      = .false.
  , bfbflag        = .false.
  , diagfreq       = 5
  , diag_type      = 'file'
  , diag_file      = 'ice_diag.d'
  , print_global   = .false.
  , print_points   = .false.
  , latpnt(1)      =  90.
  , lonpnt(1)      =   0.
  , latpnt(2)      = -65
  , lonpnt(2)      = -45.
  , dbug           = .false.
  , histfreq       = 'm','x','x','x','x'
  , histfreq_n     =  1 , 1 , 1 , 1 , 1
  , hist_avg       = .true.
  , history_dir    = './history/'
  , history_file   = 'iceh'
  , write_ic       = .true.
  , incond_dir     = './history/'
  , incond_file    = 'iceh_ic'
/

&grid_nml
    grid_format  = 'nc'
  , grid_type    = 'tripole'
  , grid_file    = 'grid'
  , kmt_file     = 'kmt'
  , gridcpl_file = 'unknown_gridcpl_file'
  , kcatbound    = 0
/

&domain_nml
    nprocs = 40
  , processor_shape   = 'square-ice'
  , distribution_type = 'cartesian'
  , distribution_wght = 'latitude'
  , ew_boundary_type  = 'cyclic'
  , ns_boundary_type  = 'tripole'
  , maskhalo_dyn      = .false.
  , maskhalo_remap    = .false.
  , maskhalo_bound    = .false.
/

&tracer_nml
    tr_iage      = .true.
  , restart_age  = .false.
  , tr_FY        = .true.
  , restart_FY   = .false.
  , tr_lvl       = .true.
  , restart_lvl  = .false.
  , tr_pond_cesm = .false.
  , restart_pond_cesm = .false.
  , tr_pond_topo = .false.
  , restart_pond_topo = .false.
  , tr_pond_lvl  = .true.
  , restart_pond_lvl  = .false.
  , tr_aero      = .false.
  , restart_aero = .false.
/

&thermo_nml
    kitd              = 1
  , ktherm            = 0
  , conduct           = 'bubbly'
  , a_rapid_mode      =  0.5e-3
  , Rac_rapid_mode    =    10.0
  , aspect_rapid_mode =     1.0
  , dSdt_slow_mode    = -5.0e-8
  , phi_c_slow_mode   =    0.05
  , phi_i_mushy       =    0.85
/

&dynamics_nml
    kdyn            = 1
  , ndte            = 120
  , revised_evp     = .false.
  , advection       = 'upwind'
  , kstrength       = 1
  , krdg_partic     = 1
  , krdg_redist     = 1
  , mu_rdg          = 3
  , Cf              = 17.
/

&shortwave_nml
    shortwave       = 'default'
  , albedo_type     = 'default'
  , albicev         = 0.78
  , albicei         = 0.36
  , albsnowv        = 0.98
  , albsnowi        = 0.70 
  , ahmax           = 0.3
  , R_ice           = 0.
  , R_pnd           = 0.
  , R_snw           = 1.5
  , dT_mlt          = 1.5
  , rsnw_mlt        = 1500.
  , kalg            = 0.6
/

&ponds_nml
    hp1             = 0.01
  , hs0             = 0.
  , hs1             = 0.03
  , dpscale         = 1.e-3
  , frzpnd          = 'hlid'
  , rfracmin        = 0.15
  , rfracmax        = 1.
  , pndaspect       = 0.8
/

&zbgc_nml
    tr_brine        = .false.
  , restart_hbrine  = .false.
  , skl_bgc         = .false.
  , bgc_flux_type   = 'Jin2006'
  , restart_bgc     = .false.
  , restore_bgc     = .false.
  , bgc_data_dir    = 'unknown_bgc_data_dir'
  , sil_data_type   = 'default'
  , nit_data_type   = 'default'
  , tr_bgc_C_sk     = .false.
  , tr_bgc_chl_sk   = .false.
  , tr_bgc_Am_sk    = .false.
  , tr_bgc_Sil_sk   = .false.
  , tr_bgc_DMSPp_sk = .false.
  , tr_bgc_DMSPd_sk = .false.
  , tr_bgc_DMS_sk   = .false.
  , phi_snow        = 0.5
/

&forcing_nml
    formdrag        = .false.
  , atmbndy         = 'default'
  , fyear_init      = 1958
  , ycycle          = 52
  , atm_data_format = 'bin'
  , atm_data_type   = 'default'
  , atm_data_dir    = 'unknown'
  , calc_strair     = .true.
  , highfreq        = .false.
  , natmiter        = 5
  , calc_Tsfc       = .true.
  , precip_units    = 'mm_per_sec'
  , ustar_min       = 0.0005
  , fbot_xfer_type  = 'constant'
  , update_ocn_f    = .true.
  , l_mpond_fresh   = .false.
  , tfrz_option     = 'mushy'
  , oceanmixed_ice  = .false.
  , ocn_data_format = 'nc'
  , sss_data_type   = 'default'
  , sst_data_type   = 'default'
  , ocn_data_dir    = 'unknown'
  , oceanmixed_file = 'unknown'
  , restore_sst     = .false.
  , trestore        =  90
  , restore_ice     = .false.
/

&icefields_nml
    f_tmask        = .true.
  , f_blkmask      = .true.
  , f_tarea        = .true.
  , f_uarea        = .true.
  , f_dxt          = .false.
  , f_dyt          = .false.
  , f_dxu          = .false.
  , f_dyu          = .false.
  , f_HTN          = .false.
  , f_HTE          = .false.
  , f_ANGLE        = .true.
  , f_ANGLET       = .true.
  , f_NCAT         = .true.
  , f_VGRDi        = .false.
  , f_VGRDs        = .false.
  , f_VGRDb        = .false.
  , f_bounds       = .false.
  , f_aice         = 'm' 
  , f_hi           = 'm'
  , f_hs           = 'm' 
  , f_Tsfc         = 'm' 
  , f_sice         = 'm' 
  , f_uvel         = 'm' 
  , f_vvel         = 'm' 
  , f_uatm         = 'm' 
  , f_vatm         = 'm' 
  , f_fswdn        = 'm' 
  , f_flwdn        = 'm'
  , f_snow         = 'x' 
  , f_snow_ai      = 'm' 
  , f_rain         = 'x' 
  , f_rain_ai      = 'm' 
  , f_sst          = 'm' 
  , f_sss          = 'm' 
  , f_uocn         = 'm' 
  , f_vocn         = 'm' 
  , f_frzmlt       = 'm'
  , f_fswfac       = 'm'
  , f_fswint_ai    = 'm'
  , f_fswabs       = 'x' 
  , f_fswabs_ai    = 'm' 
  , f_albsni       = 'm' 
  , f_alvdr        = 'x'
  , f_alidr        = 'x'
  , f_alvdf        = 'x'
  , f_alidf        = 'x'
  , f_albice       = 'x'
  , f_albsno       = 'x'
  , f_albpnd       = 'x'
  , f_coszen       = 'x'
  , f_flat         = 'x' 
  , f_flat_ai      = 'm' 
  , f_fsens        = 'x' 
  , f_fsens_ai     = 'm' 
  , f_flwup        = 'x' 
  , f_flwup_ai     = 'm' 
  , f_evap         = 'x' 
  , f_evap_ai      = 'm' 
  , f_Tair         = 'm' 
  , f_Tref         = 'x' 
  , f_Qref         = 'x'
  , f_congel       = 'm' 
  , f_frazil       = 'm' 
  , f_snoice       = 'm' 
  , f_dsnow        = 'x' 
  , f_melts        = 'm'
  , f_meltt        = 'm'
  , f_meltb        = 'm'
  , f_meltl        = 'm'
  , f_fresh        = 'x'
  , f_fresh_ai     = 'm'
  , f_fsalt        = 'x'
  , f_fsalt_ai     = 'm'
  , f_fhocn        = 'x' 
  , f_fhocn_ai     = 'm' 
  , f_fswthru      = 'x' 
  , f_fswthru_ai   = 'm' 
  , f_fsurf_ai     = 'x'
  , f_fcondtop_ai  = 'x'
  , f_fmeltt_ai    = 'x' 
  , f_strairx      = 'm' 
  , f_strairy      = 'm' 
  , f_strtltx      = 'x' 
  , f_strtlty      = 'x' 
  , f_strcorx      = 'x' 
  , f_strcory      = 'x' 
  , f_strocnx      = 'x' 
  , f_strocny      = 'x' 
  , f_strintx      = 'x' 
  , f_strinty      = 'x'
  , f_strength     = 'm'
  , f_divu         = 'm'
  , f_shear        = 'm'
  , f_sig1         = 'm' 
  , f_sig2         = 'm' 
  , f_dvidtt       = 'm' 
  , f_dvidtd       = 'm' 
  , f_daidtt       = 'm'
  , f_daidtd       = 'm' 
  , f_dagedtt      = 'm'
  , f_dagedtd      = 'm' 
  , f_mlt_onset    = 'm'
  , f_frz_onset    = 'm'
  , f_hisnap       = 'x'
  , f_aisnap       = 'x'
  , f_trsig        = 'm'
  , f_icepresent   = 'm'
  , f_iage         = 'm'
  , f_FY           = 'm'
  , f_aicen        = 'x'
  , f_vicen        = 'x'
  , f_vsnon        = 'x'
  , f_keffn_top    = 'x'
  , f_Tinz         = 'x'
  , f_Sinz         = 'x'
  , f_Tsnz         = 'x'
  , f_fsurfn_ai    = 'x'
  , f_fcondtopn_ai = 'x'
  , f_fmelttn_ai   = 'x'
  , f_flatn_ai     = 'x'
  , f_fsensn_ai     = 'x'
/

&icefields_mechred_nml
    f_alvl         = 'm'
  , f_vlvl         = 'm'
  , f_ardg         = 'm'
  , f_vrdg         = 'm'
  , f_dardg1dt     = 'x'
  , f_dardg2dt     = 'x'
  , f_dvirdgdt     = 'x'
  , f_opening      = 'x'
  , f_ardgn        = 'x'
  , f_vrdgn        = 'x'
  , f_dardg1ndt    = 'x'
  , f_dardg2ndt    = 'x'
  , f_dvirdgndt    = 'x'
  , f_krdgn        = 'x'
  , f_aparticn     = 'x'
  , f_aredistn     = 'x'
  , f_vredistn     = 'x'
  , f_araftn       = 'x'
  , f_vraftn       = 'x'
/

&icefields_pond_nml
    f_apondn       = 'x'
  , f_apeffn       = 'x'
  , f_hpondn       = 'x'
  , f_apond        = 'm'
  , f_hpond        = 'm'
  , f_ipond        = 'm'
  , f_apeff        = 'm'
  , f_apond_ai     = 'm'
  , f_hpond_ai     = 'm'
  , f_ipond_ai     = 'm'
  , f_apeff_ai     = 'm'
/

&icefields_bgc_nml
    f_faero_atm    = 'x'
  , f_faero_ocn    = 'x'
  , f_aero         = 'x'
  , f_fNO          = 'x'
  , f_fNO_ai       = 'x'
  , f_fNH          = 'x'
  , f_fNH_ai       = 'x'
  , f_fN           = 'x'
  , f_fN_ai        = 'x'
  , f_fSil         = 'x'
  , f_fSil_ai      = 'x'
  , f_bgc_N_sk     = 'x'
  , f_bgc_C_sk     = 'x'
  , f_bgc_chl_sk   = 'x'
  , f_bgc_Nit_sk   = 'x'
  , f_bgc_Am_sk    = 'x'
  , f_bgc_Sil_sk   = 'x'
  , f_bgc_DMSPp_sk = 'x'
  , f_bgc_DMSPd_sk = 'x'
  , f_bgc_DMS_sk   = 'x'
  , f_bgc_Nit_ml   = 'x'
  , f_bgc_Am_ml    = 'x'
  , f_bgc_Sil_ml   = 'x'  
  , f_bgc_DMSP_ml  = 'x'
  , f_bTin         = 'x'
  , f_bphi         = 'x' 
  , f_fbri         = 'm'    
  , f_hbri         = 'm'
  , f_grownet      = 'x'
  , f_PPnet        = 'x'
/

&icefields_drag_nml
    f_drag         = 'x'
  , f_Cdn_atm      = 'x'
  , f_Cdn_ocn      = 'x'
/

