
program off_main
	
use offline_module
#include "cpp_modules.inc"
implicit none

    class(Offline), pointer :: comp_p
		
	character(NAME_LEN) :: comp_name, nx, ny, nz
	character(1) :: grid_type
	character(3) :: action
    character(NAME_LEN) :: compile_time_name, exp_name
    character(NAME_LEN) :: proc_num
    character(2) :: decomp_type
        
    ! Read help command line args
    call GET_COMMAND_ARGUMENT(1, action)
	call GET_COMMAND_ARGUMENT(2, comp_name)
	call GET_COMMAND_ARGUMENT(3, nx)
	call GET_COMMAND_ARGUMENT(4, ny)
	call GET_COMMAND_ARGUMENT(5, nz)
	call GET_COMMAND_ARGUMENT(6, grid_type)
    call GET_COMMAND_ARGUMENT(7, exp_name)
    
    write(*,*) "Off_main start processing action "//action
    
    if (action == "lnd") then
        call GET_COMMAND_ARGUMENT(8, proc_num)
        call GET_COMMAND_ARGUMENT(9, decomp_type)
    end if
		
	! Get pointer to component
	select case(TRIM(comp_name))
#include "cpp_comp_alloc.inc"
    case default
        write(*,*) "No component <"//TRIM(comp_name)//"> currently compiled."
        call exit(1)
	end select
	
	! Build grid
	comp_p % experiment_name = exp_name
	call comp_p % make_grid(compile_time_name, (/ s2i(nx), s2i(ny), s2i(nz) /), grid_type)

	! Create special netCDF file for CDO
	if(action == "grd") then
        call comp_p % model_grid % dump_to_cdo_format()
	end if
	
	! Add initial data to IC-file	
	if(action == "ics") then
        call comp_p % add_info_to_ic_file()
        call comp_p % make_ic(compile_time_name, (/ s2i(nx), s2i(ny), s2i(nz) /), grid_type)
    end if
    
    ! Analyze land using mask
    if (action == "lnd") then
        call comp_p % analyze_land(s2i(proc_num), decomp_type)
    end if
	
end
	
	