#include "cpp_defs.h"

	program off_main
	
	use off_module
	use off_COMP_module
	
	implicit none

	type(off_COMP), target :: COMP
	
	! Work variables
	character(NAME_LEN) args(5)
	character(2) :: action
		
	! Read grid parameters
	if(COMMAND_ARGUMENT_COUNT() /= 6) then
		write(*,'(A)') 'Usage: bash make grd COMP 360 180 18 T'
		stop
	end if
	
	call GET_COMMAND_ARGUMENT(1, COMP % name)
	call GET_COMMAND_ARGUMENT(2, args(2))
	call GET_COMMAND_ARGUMENT(3, args(3))
	call GET_COMMAND_ARGUMENT(4, args(4))
	call GET_COMMAND_ARGUMENT(5, COMP % gType)
	call GET_COMMAND_ARGUMENT(6, action)
	
	read(args(2), *) COMP % nx
	read(args(3), *) COMP % ny
	read(args(4), *) COMP % nz	
	
	! Allocate grid structure
	call COMP % alloc
	
	! Build grid
	call COMP % make_grid
	
	! Add mask
	call COMP % make_mask

	! Create special netCDF file for CDO

	if(action == "gr") call COMP % make_CDO_file(add_ny=additional_ny)	
	
	! Add initial data to IC-file	
	if(action == "ic") then
		!call COMP % make_ic

		call COMP % put_var(var="center_lat", long_name="lat", units="degrees_north", arr_2D=REAL(COMP % center_lat, kind = 4))
		call COMP % put_var(var="center_lon", long_name="lon", units="degrees_east", arr_2D=REAL(COMP % center_lon, kind = 4))
		call COMP % put_var(var = "mask2D", long_name = "mask", units = "unitless", arr_2D = COMP % mask2D)
		call COMP % put_var(var = "z", long_name = "vertical level", units = "meters", arr_1D = COMP % z)	
		
		call COMP % make_ic
	end if
	
	end
	
	