module m_multa
contains
subroutine multa(A, X, ndim, nrens, iblkmax)
implicit none
integer*8, intent(in) :: ndim
integer*8, intent(in) :: nrens
integer*8, intent(in) :: iblkmax
real*8, intent(in)    :: X(nrens,nrens)
real*8, intent(inout) :: A(ndim,nrens)
real*8 v(iblkmax,nrens)  ! Automatic work array

integer*8 ia,ib
do ia = 1,ndim,iblkmax
  ib = min(ia+iblkmax-1,ndim)
  v(1:ib-ia+1,1:nrens) = A(ia:ib,1:nrens)
  call dgemm('n','n', INT(ib-ia+1,8), nrens, nrens, &
              dble(1.0), v(1,1), iblkmax, &
              X(1,1), nrens, &
              dble(0.0), A(ia,1), ndim)
enddo
end subroutine multa
end module m_multa
