!========================================================================================
!   Class-facade for work with netCDF.
!
!   Simplify interaction with netCDF file for case "open-put/get-close",
!   because store necessary ids in private members.
!
!   Also control last record of time vars using attributes for it (because
!   different length for time vars is not supporrted in netCDF4.0 yet)
!========================================================================================

module oi_module

use const_module
use mpi
use datetime_module
use utils_array_module

implicit none
integer, parameter :: NC_NULL = -1

type :: FileHandler_NC
private
    integer :: file_id_ = NC_NULL
    integer :: var_id_ = NC_NULL
    integer :: time_id_ = NC_NULL
    character(100) :: file_name_ = ""
    character(100) :: var_name_ = ""

    integer(8), allocatable :: time_axis_(:)

 contains

    !=====================
    ! ==== PUBLIC API ====
    procedure, public :: open_file


    ! ==== PUBLIC API ====
    !=====================

    procedure, private :: read_time_axis



end type

 CONTAINS
