#define DEBG
program sst_preproc
    use file_handler_nc_module
    use netcdf
    use data_preproc
    implicit none

    type(FileHandler_NC) :: handler
    type(DateTime) :: dat_st
    character(10) :: yyyymmdd
!for write Data
    real*8 , allocatable:: x1_o(:),x2_o(:)
    real*8 , allocatable:: var_o(:,:), var_b(:,:)
    integer np
!working variables    character(10) :: yyyymmdd
    integer i,n,id
    real*8 x1,x2, mean_o,mean_b, l2
!Input and output files
    character(100)            :: in_fname, out_fname,fname

    call get_args(  in_fname, out_fname,   dat_st)

    call handler % open_file(in_fname)
    np = handler % get_dim_size("np")
    allocate(x1_o(np),x2_o(np),var_o(1,np),var_b(1,np))
    call handler % open_var("x2_o")
    call handler % get (  x2_o,(/1 /) , (/np/)  )
    call handler % open_var("x1_o")
    call handler % get (  x1_o,(/1 /) , (/np/)  )
    call handler % open_var("var_o")
    call handler % get (  var_o,(/1,1/) , (/1,np/)  )
    call handler % open_var("var_b")
    call handler % get (  var_b,(/1,1/) , (/1,np/)  )
    call handler % close_file()

    mean_o = 0
    mean_b = 0
    id = 0
    do i=1,np
        x1 = x1_o(i);  x2 = x2_o(i)
        if( x1 > min_x1 .and. x1 < max_x1 .and. x2 > min_x2 .and. x2 < max_x2 .and. &
            ( x2 > 15 .or. (x1 + x2) > -70 )  & !remove Pacific Ocean
            ) then
            mean_o = mean_o + var_o(1,i)
            mean_b = mean_b + var_b(1,i)
            id = id + 1 
        endif
    enddo
    mean_o =  mean_o / dble(id) 
    mean_b =  mean_b / dble(id) 
    var_o = var_o - mean_o
    var_b = var_b - mean_b
    id = 0
    do i=1,np
        x1 = x1_o(i);  x2 = x2_o(i)
        if( x1 > min_x1 .and. x1 < max_x1 .and. x2 > min_x2 .and. x2 < max_x2 .and. &
            ( x2 > 15 .or. (x1 + x2) > -70 )  & !remove Pacific Ocean
             ) then
            l2 = l2 + ( var_o(1,i) - var_b(1,i) ) ** 2
            id = id + 1 
        endif
    enddo
    l2 = sqrt( l2/ dble(id) )
#ifdef DEBG
    write(*,'(a,f8.2)'),'SSL_ ',l2
#endif

	end program
