#define DEBG
program sst_preproc
	use file_handler_nc_module
    use netcdf
    use data_preproc
    implicit none

    type(FileHandler_NC) :: handler
    type(DateTime) :: dat_st
    character(10) :: yyyymmdd
!for read Data
    real , allocatable:: Lon(:),Lat(:)
    real , allocatable:: SST(:)
    integer dimx
!for delete some data
    integer,parameter:: MAX_PNTS = 20000, PNT_STEP = 8
!for write Data
    real*4 , allocatable:: x1_o(:),x2_o(:)
    real*4 , allocatable:: var_o(:,:)
     integer , allocatable:: sort_indx(:)
    integer np
!working variables    character(10) :: yyyymmdd
    integer i,n,id
    real*4 x1,x2
!Input and output files
    character(100)            :: in_fname, out_fname,fname

    real*4, external :: x1_shift
    call get_args(  dat_st, in_fname, out_fname )

    call handler % open_file(in_fname)
    dimx =handler % get_dim_size("dimx")
    allocate(lat(dimx),lon(dimx),sst(dimx))
    call handler % open_var("latitude")
    call handler % get (  lat,(/1 /) , (/dimx /)  )
    call handler % open_var("longitude")
    call handler % get (  lon,(/1 /) , (/dimx /)  )
    call handler % open_var("temperature")
    call handler % get (  sst,(/1 /) , (/dimx /)  )
    call handler % close_file()
#ifdef DEBG
    write(*,'(a,i9,a,10f8.2)'),'LAT(',dimx,')=',lat(1:10)
    write(*,'(a,i9,a,10f8.2)'),'LON(',dimx,')=',lon(1:10)
    write(*,'(a,i9,a,10f8.2)'),'SSt(',dimx,')=',sst(1:10)
    write(*,*),"[",min_x1,max_x1,"]x[",min_x2,max_x2,"]"
#endif

    id = 0
    do i=1,dimx,PNT_STEP
        x1=lon(i);  x1=x1_shift(x1); x2=lat(i)
        if ( id == MAX_PNTS ) exit
        if( x1 > min_x1 .and. x1 < max_x1 .and. x2 > min_x2 .and. x2 < max_x2 )   id=id+1
        if( sst(i) < MIN_T .or. sst(i) > MAX_T ) then
            write(*,*), 'problems with T ',i, sst(i)
            stop
        endif
    enddo
    np=id
#ifdef DEBG
    write(*,*),"Number points",np,'from',dimx
#endif
    allocate(x1_o(np),x2_o(np),var_o(1,np), sort_indx(np))
    x1_o=0; x2_o=0; var_o=0;
    id=0
    do i=1,dimx,PNT_STEP
        x1=lon(i); x1=x1_shift(x1); x2=lat(i)
        if ( id == MAX_PNTS ) exit
        if( x1 > min_x1 .and. x1 < max_x1  .and. x2 > min_x2 .and. x2 < max_x2 ) then
            id=id+1
            x1_o(id)=x1_shift ( dble(lon(i)))
            x2_o(id)=lat(i)
            var_o(1,id)=SST(i)
        endif
    enddo

    call sort_x12_var( x1_o, x2_o, var_o, 1, np, sort_indx )

#ifdef DEBG
    write(*,'(a,i9,a,10f8.2)'),'x1_o(',np,')=',x1_o(1:10)
    write(*,'(a,i9,a,10f8.2)'),'x2_o(',np,')=',x2_o(1:10)
    write(*,'(a,i9,a,10f8.2)'),'var_o(',np,')=',var_o(1,1:10)
#endif
    yyyymmdd = dat_st % to_string()
    fname='SST_'//yyyymmdd//"_"//out_fname
    call save_obs_data( fname, "sst", dat_st, x1_o(1:np), x2_o(1:np), var_o(1,1:np), 1, np  )

	end program
