#define DEBG
program argo_preproc
    use file_handler_nc_module
    use netcdf
    use data_preproc
    use IFPORT
    implicit none

    type(FileHandler_NC) :: handler
    type(DateTime) :: dat_st
    character(10) :: yyyymmdd
!Z grid array
    real*4 Z(50)

    real*4,parameter :: BAD_P = 99999.

!for write Data
    real*8 , allocatable:: x1_o(:),x2_o(:)
    real*8 , allocatable:: t_o(:,:)
    integer , allocatable:: sort_indx(:)
    integer np
!working variables
    integer i,j,k,n,id

    character(100)            :: in_fname, out_fname,fname
    real*8, external :: x1_shift
    call get_args(  dat_st, in_fname, out_fname )
    read(in_fname,'(i)'), np
    call o_ini_set_grid_z(z)

!allocate test assimilated data arrys
    allocate(x1_o (np),x2_o (np), t_o(nl,np), sort_indx(np))
    do i = 1, np
      x1_o(i) = min ( -120. + real(i) / 2 + real(np) , 0d0 ) 
      x2_o(i) = -45 + 90 * rand()
      t_o(1:nl, i) = 21.
    enddo


!Copy pnts in new arrays and vertical extrapolation
    write(*,'(a,i3,a,2f7.1)'),'x1_o(',NP,')=',      minval(x1_o(1:np)),      maxval(x1_o(1:np))
    write(*,'(a,i4,a,2f7.1)'),'x2_o(',NP,')=',      minval(x2_o(1:np)),      maxval(x2_o(1:np))
    write(*,'(a,2i3,a,2f7.1)'),'T_o(',1,NL,')=',    minval(t_o(1,1:np)),     maxval(t_o(10,1:np))
    call sort_x12_var( x1_o, x2_o, t_o, nl, np, sort_indx )

    yyyymmdd = dat_st % to_string()
    fname='T_'//yyyymmdd//"_"//out_fname
    write(*,*), fname, "tem", dat_st, x1_o(1), x2_o(1), t_o(1,1), nl, np
    call save_obs_data( fname, "tem", dat_st, x1_o(1:np), x2_o(1:np), t_o(1:nl,1:np), nl, np  )
    fname='S_'//yyyymmdd//"_"//out_fname
    t_o=35.
    call save_obs_data( fname, "sal", dat_st, x1_o(1:np), x2_o(1:np), t_o(1:nl,1:np), nl, np  )


    deallocate( t_o, x1_o ,x2_o)
end program
