!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module atm_ncar_cpl_adapter_module

use component_module
implicit none

type, extends(Component) :: atm_ncar_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
end type

 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model()
!----------------------------------------------------------------------------------------

subroutine ini_reg_comp(this)
    class(atm_ncar_cpl_adapter) :: this
    type(Decomposition) :: dec
    
    dec = Decomposition(192, 94, 1, "1D", CompSplitter % comm_local_size(), CompSplitter % rank_local())
    
    ! Call registration routine of CMF (it needs only size of grid and timestep in whole(!) seconds)
    call this % register_model(decomp = dec, timestep_sec = 60*60)     
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data() use adresses of your arrays and 
! they should be allocated at time of registration.
!----------------------------------------------------------------------------------------

subroutine ini_allocate(this)
    class(atm_ncar_cpl_adapter) :: this

end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register all data you want to interact with system.
! There you should call this % register_array() and this % register_events().
!----------------------------------------------------------------------------------------

subroutine ini_reg_data(this)
    class(atm_ncar_cpl_adapter) :: this

    ! call this % register_array(...)

    ! call this % add_precise_event(...)
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main before main time cycle.
! You should do there all preparation actions.
!----------------------------------------------------------------------------------------

subroutine ini_main(this)
    class(atm_ncar_cpl_adapter) :: this

end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program in time cycle. Should represent one time step of
! your model with all physics and internal exhanges (like halo MPI-updates).
!----------------------------------------------------------------------------------------

subroutine make_step(this)
    class(atm_ncar_cpl_adapter) :: this

end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.
!----------------------------------------------------------------------------------------

subroutine finalize(this)        
    class(atm_ncar_cpl_adapter) :: this        

end subroutine

!========================================================================================

end module
    