!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module atm_ncar_cpl_adapter_module

use component_module

implicit none

type, extends(Component) :: atm_ncar_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize
    
    procedure, private :: test_1_one_way_atm2ocn
    procedure, private :: test_2_two_way
    procedure, private :: test_3_two_way_dif_num_fields_and_periods
    procedure, private :: test_4_two_way_full
    
end type

    type(Decomposition) :: dec

    real, allocatable :: ocn2atm(:,:,:) 
    real, allocatable :: atm2ocn(:,:,:)
    integer :: counter = 1
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model()
!----------------------------------------------------------------------------------------

subroutine ini_reg_comp(this)
    class(atm_ncar_cpl_adapter) :: this
        
    dec = Decomposition(192, 94, 1, "2D", CompSplitter % comm_local_size(), CompSplitter % rank_local())
    
    ! Call registration routine of CMF (it needs only size of grid and timestep in whole(!) seconds)
    call this % register_model(decomp = dec, timestep_sec = 60*60)     
   
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data() use adresses of your arrays and 
! they should be allocated at time of registration.
!----------------------------------------------------------------------------------------

subroutine ini_allocate(this)
    class(atm_ncar_cpl_adapter) :: this

    allocate(ocn2atm(dec % west() : dec % east(),dec % south() : dec % north(), dec % k_size())); ocn2atm = 0
    allocate(atm2ocn(dec % west() : dec % east(),dec % south() : dec % north(), dec % k_size())); atm2ocn = 0
        
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register all data you want to interact with system.
! There you should call this % register_array() and this % register_events().
!----------------------------------------------------------------------------------------

subroutine ini_reg_data(this)
    class(atm_ncar_cpl_adapter) :: this

    integer :: i, j, k
    
    counter = 1
    do i = dec % west(), dec % east()
    do j = dec % south(), dec % north()
    do k = 1, dec % k_size()
        atm2ocn(i,j,k) = CompSplitter % i_am_id()*100 + k
    end do
    end do
    end do

    select case (TRIM(ExpInfo % exp_name()))
        case("ao_1")
            call this % test_1_one_way_atm2ocn()
        
        case("ao_2")
            call this % test_2_two_way()
        
        case("ao_3")
            call this % test_3_two_way_dif_num_fields_and_periods()

        case("ao_4")
            call this % test_4_two_way_full()
    end select 

    
    
end subroutine

!========================================================================================

subroutine test_1_one_way_atm2ocn(this)
    class(atm_ncar_cpl_adapter) :: this
       
    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dh = 1)        
    
end subroutine
!========================================================================================

subroutine test_2_two_way(this)
    class(atm_ncar_cpl_adapter) :: this

    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)

    ! O -> A
    call this % register_array(arr_name = "ocn2atm1", arr = ocn2atm(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "RECV_MP", src = "OCN", dh = 6)   
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "SAVE_DG", dh = 12)    

    end subroutine

!========================================================================================

subroutine test_3_two_way_dif_num_fields_and_periods(this)
    class(atm_ncar_cpl_adapter) :: this

    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn2", arr = atm2ocn(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn3", arr = atm2ocn(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn4", arr = atm2ocn(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn5", arr = atm2ocn(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn3", act = "SEND_MP", dst = "OCN", dh = 1)    
    call this % register_periodic_event(arr_name = "atm2ocn4", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn5", act = "SEND_MP", dst = "OCN", dh = 1)

    ! O -> A
    call this % register_array(arr_name = "ocn2atm1", arr = ocn2atm(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm2", arr = ocn2atm(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm3", arr = ocn2atm(:,:,3), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "RECV_MP", src = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "RECV_MP", src = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "RECV_MP", src = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "SAVE_DG", dd = 1)
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "SAVE_DG", dd = 1)
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "SAVE_DG", dd = 1)
    
end subroutine

subroutine test_4_two_way_full(this)
    class(atm_ncar_cpl_adapter) :: this

    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn2", arr = atm2ocn(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn3", arr = atm2ocn(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn4", arr = atm2ocn(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn5", arr = atm2ocn(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SEND_MP", dst = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "atm2ocn3", act = "SEND_MP", dst = "OCN", dh = 3)
    call this % register_periodic_event(arr_name = "atm2ocn4", act = "SEND_MP", dst = "OCN", dh = 4)
    call this % register_periodic_event(arr_name = "atm2ocn5", act = "SEND_MP", dst = "OCN", dh = 4)

    ! O -> A
    call this % register_array(arr_name = "ocn2atm1", arr = ocn2atm(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm2", arr = ocn2atm(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm3", arr = ocn2atm(:,:,3), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "RECV_MP", src = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "RECV_MP", src = "OCN", dh = 6)
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "RECV_MP", src = "OCN", dh = 12)
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "SAVE_DG", dd = 1)
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "SAVE_DG", dd = 2)
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "SAVE_DG", dd = 4)
    
end subroutine
!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main before main time cycle.
! You should do there all preparation actions.
!----------------------------------------------------------------------------------------

subroutine ini_main(this)
    class(atm_ncar_cpl_adapter) :: this

    counter = 1
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program in time cycle. Should represent one time step of
! your model with all physics and internal exhanges (like halo MPI-updates).
!----------------------------------------------------------------------------------------

subroutine make_step(this)
    class(atm_ncar_cpl_adapter) :: this
    integer :: k
    
    do k = 1, dec % k_size()
        atm2ocn(:,:,k) = atm2ocn(:,:,k) + k + REAL(counter)*0.001
    end do    
        
    counter = counter + 1
   
end subroutine


!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.
!----------------------------------------------------------------------------------------

subroutine finalize(this)        
    class(atm_ncar_cpl_adapter) :: this        
    
end subroutine

!========================================================================================

end module
    