!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module ocn_cpl_adapter_module

use component_module
use experiment_info_module
implicit none

type, extends(Component) :: ocn_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
    
    procedure, private :: test_1_one_way_atm2ocn
    procedure, private :: test_2_two_way
    procedure, private :: test_3_two_way_dif_num_fields_and_periods
    procedure, private :: test_4_two_way_full    
end type

    integer :: il, jl, kl, ml, steps_in_day
    logical :: read_cp
    integer :: iwest, ieast, jsouth, jnorth, step

    real, allocatable :: ocn2atm(:,:,:) 
    real, allocatable :: atm2ocn(:,:,:)
    integer :: counter = 1
    
    type(Decomposition) :: dec    
 
 CONTAINS

!========================================================================================
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model

subroutine ini_reg_comp(this)
    class(ocn_cpl_adapter) :: this
    
    dec = Decomposition(360, 180, 49, "2D", CompSplitter % comm_local_size(), CompSplitter % rank_local())
    
    ! Call registration routine of CMF (it needs only size of grid and timestep in whole(!) seconds)
    call this % register_model(decomp = dec, timestep_sec = 60*60) 
                    
    iwest = dec % west() + 1
    ieast = dec % east() + 1
    jsouth = dec % south() + 1
    jnorth = dec % north() + 1 
    step = 1
    
end subroutine

!========================================================================================
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data use adresses of your arrays and 
! they should be allocated at time of registration.

subroutine ini_allocate(this)
    class(ocn_cpl_adapter) :: this

    allocate(ocn2atm(iwest:ieast,jsouth:jnorth, dec % k_size())); ocn2atm = 0
    allocate(atm2ocn(iwest:ieast,jsouth:jnorth, dec % k_size())); atm2ocn = 0
    
end subroutine

!========================================================================================
! Will be called by main to get all data you want to register.
! There you should call this % register_array and this % register_events.

subroutine ini_reg_data(this)
    class(ocn_cpl_adapter) :: this
    
    integer :: i, j, k
    
    counter = 1
    do i = iwest, ieast
    do j = jsouth, jnorth
    do k = 1, dec % k_size()
        ocn2atm(i,j,k) = CompSplitter % i_am_id()*100 + k
    end do
    end do
    end do

    select case (TRIM(ExpInfo % exp_name()))
        case("ao_1")
            call this % test_1_one_way_atm2ocn()
        
        case("ao_2")
            call this % test_2_two_way()
        
        case("ao_3")
            call this % test_3_two_way_dif_num_fields_and_periods()

        case("ao_4")
            call this % test_4_two_way_full()
    end select 
    
end subroutine

!========================================================================================

subroutine test_1_one_way_atm2ocn(this)
    class(ocn_cpl_adapter) :: this
        
    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr =atm2ocn(:,:,1), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dh = 1)        
end subroutine

!========================================================================================

subroutine test_2_two_way(this)
    class(ocn_cpl_adapter) :: this
        
    ! O -> A
    call this % register_array(arr_name = "ocn2atm1", arr =ocn2atm(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "SEND_MP", dst = "ATM", dh = 6)     

    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr =atm2ocn(:,:,1), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 1)  
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dh = 4)    
end subroutine

!========================================================================================

subroutine test_3_two_way_dif_num_fields_and_periods(this)
    class(ocn_cpl_adapter) :: this
    
    ! O -> A
    call this % register_array(arr_name = "ocn2atm1", arr =ocn2atm(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm2", arr =ocn2atm(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm3", arr =ocn2atm(:,:,3), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "SEND_MP", dst = "ATM", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "SEND_MP", dst = "ATM", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "SEND_MP", dst = "ATM", dh = 2)

    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr =atm2ocn(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn2", arr =atm2ocn(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn3", arr =atm2ocn(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn4", arr =atm2ocn(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn5", arr =atm2ocn(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn3", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn4", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn5", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dd = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SAVE_DG", dd = 1)
    call this % register_periodic_event(arr_name = "atm2ocn3", act = "SAVE_DG", dd = 1)
    call this % register_periodic_event(arr_name = "atm2ocn4", act = "SAVE_DG", dd = 1)
    call this % register_periodic_event(arr_name = "atm2ocn5", act = "SAVE_DG", dd = 1)
    
end subroutine

!========================================================================================

subroutine test_4_two_way_full(this)
    class(ocn_cpl_adapter) :: this
    
    ! O -> A
    call this % register_array(arr_name = "ocn2atm1", arr =ocn2atm(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm2", arr =ocn2atm(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm3", arr =ocn2atm(:,:,3), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "SEND_MP", dst = "ATM", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "SEND_MP", dst = "ATM", dh = 6)
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "SEND_MP", dst = "ATM", dh = 12)

    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr =atm2ocn(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn2", arr =atm2ocn(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn3", arr =atm2ocn(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn4", arr =atm2ocn(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn5", arr =atm2ocn(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "RECV_MP", src = "ATM", dh = 2)
    call this % register_periodic_event(arr_name = "atm2ocn3", act = "RECV_MP", src = "ATM", dh = 3)
    call this % register_periodic_event(arr_name = "atm2ocn4", act = "RECV_MP", src = "ATM", dh = 4)
    call this % register_periodic_event(arr_name = "atm2ocn5", act = "RECV_MP", src = "ATM", dh = 4)
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dd = 2)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SAVE_DG", dd = 6)
    call this % register_periodic_event(arr_name = "atm2ocn3", act = "SAVE_DG", dd = 12)
    call this % register_periodic_event(arr_name = "atm2ocn4", act = "SAVE_DG", dd = 24)
    call this % register_periodic_event(arr_name = "atm2ocn5", act = "SAVE_DG", dd = 3)
    
end subroutine
!========================================================================================
! Will be called by main before main time cycle.
! You should do there all preparation actions.

subroutine ini_main(this)
    class(ocn_cpl_adapter) :: this

    counter = 1
    
end subroutine

!========================================================================================
! Will be called by main program in time cycle.
! You can control time by global Timer object.
subroutine make_step(this)
    class(ocn_cpl_adapter) :: this
    integer :: k
    
    do k = 1, dec % k_size()
        ocn2atm(:,:,k) = ocn2atm(:,:,k) + k + REAL(counter)*0.001
    end do    

    counter = counter + 1
        
end subroutine

!========================================================================================
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.

subroutine finalize(this)        
    class(ocn_cpl_adapter) :: this        
    
    
end subroutine

!========================================================================================

end module
    