#!/bin/bash

#
# Test with empty OCN component
#

COMPS_BUILD="ocn atm_ncar"
EXP="ao_1" 

RUN_COMMAND[1]="-np 5 ./cpl.exe DTR 1 ATM 1 OCN 1 IOD 1 CPL 1 $EXP"

rm -f ./data/*$EXP*.nc

# Copy first experiment results to sample files
function assert1 {

    for (( i = 1; i <= 10; i++ )); do
        if [ -f ./data/OCN_${EXP}_DG_atm2ocn$i.nc ]; then 
            cp ./data/OCN_${EXP}_DG_atm2ocn$i.nc test_atm2ocn$i.nc
        fi
        
        if [ -f ./data/ATM_NCAR_${EXP}_DG_ocn2atm$i.nc ]; then
            cp ./data/ATM_NCAR_${EXP}_DG_ocn2atm$i.nc test_ocn2atm$i.nc
        fi
    done
    
    echo "Copy first results"
    result="ok"
}

function compare_fields {

    result="ok"

    for (( i = 1; i <= 10; i++ )); do
        if [ -f ./data/OCN_${EXP}_DG_atm2ocn$i.nc ]; then
            output1="$(cdo diff ./data/OCN_${EXP}_DG_atm2ocn$i.nc ./test_atm2ocn$i.nc)"
            echo $output1
        fi
        
        if [ -f ./data/ATM_NCAR_${EXP}_DG_ocn2atm$i.nc ]; then
            output2="$(cdo diff ./data/ATM_NCAR_${EXP}_DG_ocn2atm$i.nc ./test_ocn2atm$i.nc)"
        fi
    
        if [[ $output1 == *"records differ"* || $output2 == *"records differ"* ]]; then
            echo "Error in comparison"
            result="err"
        fi
    done
}
    
RUN_COMMAND[2]="-np 6 ./cpl.exe DTR 1 ATM 1 OCN 2 IOD 1 CPL 1 $EXP"
function assert2 { 
    compare_fields 
}

RUN_COMMAND[3]="-np 6 ./cpl.exe DTR 1 ATM 1 OCN 1 IOD 1 CPL 2 $EXP "

function assert3 { 
    compare_fields 
}

RUN_COMMAND[4]="-np 7 ./cpl.exe DTR 1 ATM 2 OCN 2 IOD 1 CPL 1 $EXP "

function assert4 { 
    compare_fields 
}

RUN_COMMAND[5]="-np 8 ./cpl.exe DTR 1 ATM 2 OCN 2 IOD 1 CPL 2 $EXP "

function assert5 { 
    compare_fields 
}

RUN_COMMAND[6]="-np 9 ./cpl.exe DTR 1 ATM 2 OCN 4 IOD 1 CPL 1 $EXP "

function assert6 { 
    compare_fields 
}
























