!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module atm_inm_cpl_adapter_module

use component_module

implicit none

type, extends(Component) :: atm_inm_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize
    
end type

    type(Decomposition) :: dec

    real, allocatable :: ocn2atm(:,:,:) 
    real, allocatable :: atm2ocn(:,:,:)
    integer :: counter = 1
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model()
!----------------------------------------------------------------------------------------

subroutine ini_reg_comp(this)
    class(atm_inm_cpl_adapter) :: this
    
    call this % register_model(i_size = 1600, j_size = 864, k_size = 10, decomp_type = "2D", timestep_sec = 60*60)
    dec = ModelsInfo(CompSplitter % i_am_id()) % decomp()
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data() use adresses of your arrays and 
! they should be allocated at time of registration.
!----------------------------------------------------------------------------------------

subroutine ini_allocate(this)
    class(atm_inm_cpl_adapter) :: this

    allocate(ocn2atm(dec % west() : dec % east(),dec % south() : dec % north(), dec % k_size())); ocn2atm = 0
    allocate(atm2ocn(dec % west() : dec % east(),dec % south() : dec % north(), dec % k_size())); atm2ocn = 0
        
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register all data you want to interact with system.
! There you should call this % register_array() and this % register_events().
!----------------------------------------------------------------------------------------

subroutine ini_reg_data(this)
    class(atm_inm_cpl_adapter) :: this

    integer :: i, j, k
    
    counter = 1
    do i = dec % west(), dec % east()
    do j = dec % south(), dec % north()
    do k = 1, dec % k_size()
        atm2ocn(i,j,k) = CompSplitter % i_am_id()*100 + k
    end do
    end do
    end do

    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn2", arr = atm2ocn(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn3", arr = atm2ocn(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn4", arr = atm2ocn(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn5", arr = atm2ocn(:,:,5), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn6", arr = atm2ocn(:,:,6), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn7", arr = atm2ocn(:,:,7), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn8", arr = atm2ocn(:,:,8), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn9", arr = atm2ocn(:,:,9), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn3", act = "SEND_MP", dst = "OCN", dh = 1)    
    call this % register_periodic_event(arr_name = "atm2ocn4", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn5", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn6", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn7", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn8", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn9", act = "SEND_MP", dst = "OCN", dh = 1)

    ! O -> A
    call this % register_array(arr_name = "ocn2atm1", arr = ocn2atm(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm2", arr = ocn2atm(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm3", arr = ocn2atm(:,:,3), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "RECV_MP", src = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "RECV_MP", src = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "RECV_MP", src = "OCN", dh = 2)
!     call this % register_periodic_event(arr_name = "ocn2atm1", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "ocn2atm2", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "ocn2atm3", act = "SAVE_DG", dd = 1)
!     
    
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main before main time cycle.
! You should do there all preparation actions.
!----------------------------------------------------------------------------------------

subroutine ini_main(this)
    class(atm_inm_cpl_adapter) :: this

    counter = 1
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program in time cycle. Should represent one time step of
! your model with all physics and internal exhanges (like halo MPI-updates).
!----------------------------------------------------------------------------------------

subroutine make_step(this)
    class(atm_inm_cpl_adapter) :: this
    integer :: k
    
    do k = 1, dec % k_size()
        atm2ocn(:,:,k) = atm2ocn(:,:,k) + k + REAL(counter)*0.001
    end do    
        
    counter = counter + 1
   
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.
!----------------------------------------------------------------------------------------

subroutine finalize(this)        
    class(atm_inm_cpl_adapter) :: this        
    
end subroutine

!========================================================================================

end module
    