!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module ocn_cpl_adapter_module

use component_module
use experiment_info_module
implicit none

type, extends(Component) :: ocn_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
end type

    integer :: il, jl, kl, ml, steps_in_day
    logical :: read_cp
    integer :: iwest, ieast, jsouth, jnorth, step

    real, allocatable :: ocn2atm(:,:,:) 
    real, allocatable :: atm2ocn(:,:,:)
    integer :: counter = 1
    
    type(Decomposition) :: dec    
    
 CONTAINS

!========================================================================================
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model

subroutine ini_reg_comp(this)
    class(ocn_cpl_adapter) :: this

    character(100) :: input_namelist
    logical :: file_exists
    namelist /MAIN/ il, jl, kl, ml, steps_in_day, read_cp
    
    input_namelist = "./comp_ocn/"//TRIM(ExpInfo % exp_name())//".in"
    INQUIRE(file = input_namelist, exist = file_exists)
    if(file_exists) then
        open(9, file= input_namelist)
        read(9, nml = MAIN)
        close(9)
    else    
        call this % fatal_error("cant find input namelist: "//TRIM(input_namelist))
    end if
    
    ! Registration
    call this % register_model(i_size = il-2, j_size = jl-2, k_size = 10, decomp_type = "2D", timestep_sec = 60*60)
                
    dec = ModelsInfo(CompSplitter % i_am_id()) % decomp()
    iwest = dec % west() + 1
    ieast = dec % east() + 1
    jsouth = dec % south() + 1
    jnorth = dec % north() + 1 
    step = 1
    
end subroutine

!========================================================================================
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data use adresses of your arrays and 
! they should be allocated at time of registration.

subroutine ini_allocate(this)
    class(ocn_cpl_adapter) :: this

    allocate(ocn2atm(iwest:ieast,jsouth:jnorth, dec % k_size())); ocn2atm = 0
    allocate(atm2ocn(iwest:ieast,jsouth:jnorth, dec % k_size())); atm2ocn = 0
    
end subroutine

!========================================================================================
! Will be called by main to get all data you want to register.
! There you should call this % register_array and this % register_events.

subroutine ini_reg_data(this)
    class(ocn_cpl_adapter) :: this
    
    integer :: i, j, k
    
    counter = 1
    do i = iwest, ieast
    do j = jsouth, jnorth
    do k = 1, dec % k_size()
        ocn2atm(i,j,k) = CompSplitter % i_am_id()*100 + k
    end do
    end do
    end do

    ! O -> A
    call this % register_array(arr_name = "ocn2atm1", arr = ocn2atm(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm2", arr = ocn2atm(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm3", arr = ocn2atm(:,:,3), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "SEND_MP", dst = "ATM", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "SEND_MP", dst = "ATM", dh = 2)
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "SEND_MP", dst = "ATM", dh = 2)

    ! A -> O
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn2", arr = atm2ocn(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn3", arr = atm2ocn(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn4", arr = atm2ocn(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn5", arr = atm2ocn(:,:,5), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn6", arr = atm2ocn(:,:,5), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn7", arr = atm2ocn(:,:,5), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn8", arr = atm2ocn(:,:,5), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn9", arr = atm2ocn(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn3", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn4", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn5", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn6", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn7", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn8", act = "RECV_MP", src = "ATM", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn9", act = "RECV_MP", src = "ATM", dh = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn2", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn3", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn4", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn5", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn6", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn7", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn8", act = "SAVE_DG", dd = 1)
!     call this % register_periodic_event(arr_name = "atm2ocn9", act = "SAVE_DG", dd = 1)

end subroutine

!========================================================================================
! Will be called by main before main time cycle.
! You should do there all preparation actions.

subroutine ini_main(this)
    class(ocn_cpl_adapter) :: this

    counter = 1
    
end subroutine

!========================================================================================
! Will be called by main program in time cycle.
! You can control time by global Timer object.

subroutine make_step(this)
    class(ocn_cpl_adapter) :: this
    type(DateTime) :: dt
    integer :: k
    
    do k = 1, dec % k_size()
        ocn2atm(:,:,k) = ocn2atm(:,:,k) + k + REAL(counter)*0.001
    end do    

    counter = counter + 1
        
end subroutine

!========================================================================================
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.

subroutine finalize(this)        
    class(ocn_cpl_adapter) :: this        
    
    
end subroutine

!========================================================================================

end module
    