#!/bin/bash


function launch_model() {
    local DTR=1
    local IOD=1
    local ATM=16
    local OCN=16
    local CPL=$1
    local PART=regular4

    local SUM=$(($DTR + $IOD + $ATM + $OCN + $CPL)) 
    
    bash job_launcher.sh --machine $MACHINE --np $SUM --ppn 16 --partition $PART --exe ./cpl.exe --args "DTR $DTR IOD $IOD ATM $ATM OCN $OCN CPL $CPL bnh"
}

set -e

if [[ $# != 1 ]]; then
    echo "Usage: bash go.sh <machine>"
    exit 0
fi

MACHINE=$1

ln -sf ../../cpl_main.f90
ln -sf ../../coupler
ln -sf ../../data

A2O="ATM_INM_1600x864_to_OCN_3600x1728_bil.nc"
O2A="OCN_3600x1728_to_ATM_INM_1600x864_nn.nc"

# Get files and rename them
echo -n "Check for mapping files..."
if [[ ! -f ./data/${A2O} ]]; then
    echo -n "Downloading benchmark data..."
    scp lomo:/mnt/data/users/dm4/vol9/vovo/data/weight_files/${A2O} ./data
    scp lomo:/mnt/data/users/dm4/vol9/vovo/data/weight_files/${O2A} ./datafi
fi
cd ./data
ln -s $A2O ATM_INM_1600x864_to_OCN_3600x1728.nc
ln -s $O2A OCN_3600x1728_to_ATM_INM_1600x864.nc
cd -
echo "success."



# Compile
echo "Compile benchmark..."
bash ../../make --exe cpl ocn atm_inm --clean

# # Run jobs
ulimit -s unlimited

# echo "Running jobs..."
# bash job_launcher.sh --machine $MACHINE --np 5   --exe ./cpl.exe --args "DTR 1 ATM 1 OCN 1 IOD 1 CPL 1 tst"
# bash job_launcher.sh --machine $MACHINE --np 6   --exe ./cpl.exe --args "DTR 1 ATM 1 OCN 1 IOD 1 CPL 2 tst"
# bash job_launcher.sh --machine $MACHINE --np 8   --exe ./cpl.exe --args "DTR 1 ATM 1 OCN 1 IOD 1 CPL 4 tst"
# bash job_launcher.sh --machine $MACHINE --np 12  --exe ./cpl.exe --args "DTR 1 ATM 1 OCN 1 IOD 1 CPL 8 tst"
# bash job_launcher.sh --machine $MACHINE --np 20  --exe ./cpl.exe --args "DTR 1 ATM 1 OCN 1 IOD 1 CPL 16 tst"
# bash job_launcher.sh --machine $MACHINE --np 36  --exe ./cpl.exe --args "DTR 1 ATM 1 OCN 1 IOD 1 CPL 32 tst"

launch_model 1
launch_model 2
launch_model 4
launch_model 8
launch_model 16
launch_model 32
