!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module atm_ncar_cpl_adapter_module

use component_module

implicit none

type, extends(Component) :: atm_ncar_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize
    
    procedure, private :: test_1_3way_aoi_atm_file
    procedure, private :: test_2_3way_aoi_atm_file_dif_periods
    procedure, private :: test_3_3way_aoi_atm_file_big
    procedure, private :: test_4_3way_aoi_full
end type

    type(Decomposition) :: dec

    real, allocatable :: atm2ice(:,:,:), atm2ocn(:,:,:), ice2atm(:,:,:), ocn2atm(:,:,:) 
    integer :: counter = 1
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model()
!----------------------------------------------------------------------------------------

subroutine ini_reg_comp(this)
    class(atm_ncar_cpl_adapter) :: this
    
    call this % register_model(i_size = 192, j_size = 94, k_size = 10, decomp_type = "2D", timestep_sec = 60*60)
    dec = ModelsInfo(CompSplitter % i_am_id()) % decomp()
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data() use adresses of your arrays and 
! they should be allocated at time of registration.
!----------------------------------------------------------------------------------------

subroutine ini_allocate(this)
    class(atm_ncar_cpl_adapter) :: this

    allocate(atm2ice(dec % west() : dec % east(),dec % south() : dec % north(), dec % k_size())); atm2ice = 0
    allocate(atm2ocn, source = atm2ice)
    allocate(ocn2atm, source = atm2ice)
    allocate(ice2atm, source = atm2ice)
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register all data you want to interact with system.
! There you should call this % register_array() and this % register_events().
!----------------------------------------------------------------------------------------

subroutine ini_reg_data(this)
    class(atm_ncar_cpl_adapter) :: this

    integer :: i, j, k
    
    counter = 1
    do i = dec % west(), dec % east()
    do j = dec % south(), dec % north()
    do k = 1, dec % k_size()
        atm2ice(i,j,k) = CompSplitter % i_am_id()*100 + k
        atm2ocn(i,j,k) = CompSplitter % i_am_id()*200 + k
    end do
    end do
    end do

    select case (TRIM(ExpInfo % exp_name()))
        case("aoi_1")
        call this % test_1_3way_aoi_atm_file()
        
        case("aoi_2")
        call this % test_2_3way_aoi_atm_file_dif_periods()
        
        case("aoi_3")
        call this % test_3_3way_aoi_atm_file_big()
    
        case("aoi_4")
        call this % test_4_3way_aoi_full()
    end select
        
end subroutine

!========================================================================================

subroutine test_1_3way_aoi_atm_file(this)
    class(atm_ncar_cpl_adapter) :: this

    ! A -> I : 1
    call this % register_array(arr_name = "atm2ice1", arr = atm2ice(:,:,1), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ice1", act = "SEND_MP", dst = "ICE", dh = 1)

    ! A -> O : 1
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)   
    
end subroutine

subroutine test_2_3way_aoi_atm_file_dif_periods(this)
    class(atm_ncar_cpl_adapter) :: this

    ! A -> I : 1
    call this % register_array(arr_name = "atm2ice1", arr = atm2ice(:,:,1), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ice1", act = "SEND_MP", dst = "ICE", dh = 1)

    ! A -> O : 1
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 3)   
    
end subroutine

!========================================================================================

subroutine test_3_3way_aoi_atm_file_big(this)
    class(atm_ncar_cpl_adapter) :: this

    ! A -> I : 3
    call this % register_array(arr_name = "atm2ice1", arr = atm2ice(:,:,1), indexing = "ij")        
    call this % register_array(arr_name = "atm2ice2", arr = atm2ice(:,:,2), indexing = "ij")        
    call this % register_array(arr_name = "atm2ice3", arr = atm2ice(:,:,3), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ice1", act = "SEND_MP", dst = "ICE", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ice2", act = "SEND_MP", dst = "ICE", dh = 2)
    call this % register_periodic_event(arr_name = "atm2ice3", act = "SEND_MP", dst = "ICE", dh = 2)
    
    ! A -> O : 2
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn2", arr = atm2ocn(:,:,2), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)   
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SEND_MP", dst = "OCN", dh = 2)   

end subroutine


subroutine test_4_3way_aoi_full(this)
    class(atm_ncar_cpl_adapter) :: this

    ! A -> I : 3
    call this % register_array(arr_name = "atm2ice1", arr = atm2ice(:,:,1), indexing = "ij")        
    call this % register_array(arr_name = "atm2ice2", arr = atm2ice(:,:,2), indexing = "ij")        
    call this % register_array(arr_name = "atm2ice3", arr = atm2ice(:,:,3), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ice1", act = "SEND_MP", dst = "ICE", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ice2", act = "SEND_MP", dst = "ICE", dh = 2)
    call this % register_periodic_event(arr_name = "atm2ice3", act = "SEND_MP", dst = "ICE", dh = 2)
    
    ! A -> O : 2
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ocn2", arr = atm2ocn(:,:,2), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)   
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SEND_MP", dst = "OCN", dh = 2)   

    ! O -> A : 4
    call this % register_array(arr_name = "ocn2atm1", arr = ocn2atm(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm2", arr = ocn2atm(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm3", arr = ocn2atm(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm4", arr = ocn2atm(:,:,4), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "RECV_MP", src = "OCN", dh = 4)   
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "RECV_MP", src = "OCN", dh = 4)   
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "RECV_MP", src = "OCN", dh = 8)   
    call this % register_periodic_event(arr_name = "ocn2atm4", act = "RECV_MP", src = "OCN", dh = 8)   
    
    ! I -> A : 1
    call this % register_array(arr_name = "ice2atm1", arr = ice2atm(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ice2atm1", act = "RECV_MP", src = "ICE", dh = 6)   

    
    
end subroutine



!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main before main time cycle.
! You should do there all preparation actions.
!----------------------------------------------------------------------------------------

subroutine ini_main(this)
    class(atm_ncar_cpl_adapter) :: this

    counter = 1
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program in time cycle. Should represent one time step of
! your model with all physics and internal exhanges (like halo MPI-updates).
!----------------------------------------------------------------------------------------

subroutine make_step(this)
    class(atm_ncar_cpl_adapter) :: this
    integer :: k
    
    do k = 1, dec % k_size()
        atm2ocn(:,:,k) = atm2ocn(:,:,k) + k + REAL(counter)*0.001
        atm2ice(:,:,k) = atm2ice(:,:,k) + k + REAL(counter)*0.001
    end do    
        
    counter = counter + 1
   
end subroutine


!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.
!----------------------------------------------------------------------------------------

subroutine finalize(this)        
    class(atm_ncar_cpl_adapter) :: this        
    
end subroutine

!========================================================================================

end module
    