!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module ice_test_cpl_adapter_module

use component_module

implicit none

type, extends(Component) :: ice_test_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize
    
    procedure, private :: test_1_3way_aoi_atm_file
    procedure, private :: test_2_3way_aoi_atm_file_dif_periods
    procedure, private :: test_3_3way_aoi_atm_file_big
    procedure, private :: test_4_3way_aoi_full
    
end type

    type(Decomposition) :: dec

    real, allocatable, dimension(:,:,:) :: atm2ice, ocn2ice, ice2atm, ice2ocn
    integer :: counter = 1
    
 CONTAINS

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model()
!----------------------------------------------------------------------------------------

subroutine ini_reg_comp(this)
    class(ice_test_cpl_adapter) :: this
    
    call this % register_model(i_size = 192, j_size = 94, k_size = 10, decomp_type = "2D", timestep_sec = 60*60)
    dec = ModelsInfo(CompSplitter % i_am_id()) % decomp()
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data() use adresses of your arrays and 
! they should be allocated at time of registration.
!----------------------------------------------------------------------------------------

subroutine ini_allocate(this)
    class(ice_test_cpl_adapter) :: this

    allocate(atm2ice(dec % west() : dec % east(),dec % south() : dec % north(), dec % k_size())); atm2ice = 0
    allocate(ice2ocn, source = atm2ice)
    allocate(ice2atm, source = atm2ice)
    allocate(ocn2ice, source = atm2ice)
        
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main to register all data you want to interact with system.
! There you should call this % register_array() and this % register_events().
!----------------------------------------------------------------------------------------

subroutine ini_reg_data(this)
    class(ice_test_cpl_adapter) :: this

    integer :: i, j, k
    
    counter = 1
    do i = dec % west(), dec % east()
    do j = dec % south(), dec % north()
    do k = 1, dec % k_size()
        ice2ocn(i,j,k) = CompSplitter % i_am_id()*100 + k
        ice2atm(i,j,k) = CompSplitter % i_am_id()*200 + k
    end do
    end do
    end do

    select case (TRIM(ExpInfo % exp_name()))
        case("aoi_1")
        call this % test_1_3way_aoi_atm_file()
        
        case("aoi_2")
        call this % test_2_3way_aoi_atm_file_dif_periods()
        
        case("aoi_3")
        call this % test_3_3way_aoi_atm_file_big()
    
        case("aoi_4")
        call this % test_4_3way_aoi_full()
    end select

    
    
end subroutine

!========================================================================================

subroutine test_1_3way_aoi_atm_file(this)
    class(ice_test_cpl_adapter) :: this
    
    ! I -> O : 1
    call this % register_array(arr_name = "ice2ocn1", arr = ice2ocn(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "SEND_MP", dst = "OCN", dh = 2)

    ! O -> I : 1
    call this % register_array(arr_name = "ocn2ice1", arr = ocn2ice(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "RECV_MP", src = "OCN", dh = 4)   

    ! A -> I : 1
    call this % register_array(arr_name = "atm2ice1", arr = atm2ice(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ice1", act = "RECV_MP", src = "ATM", dh = 1)   
!     
!     call this % register_periodic_event(arr_name = "ocn2ice1", act = "SAVE_DG", dh = 1)    
!     call this % register_periodic_event(arr_name = "atm2ice1", act = "SAVE_DG", dh = 1)    
    
end subroutine

subroutine test_2_3way_aoi_atm_file_dif_periods(this)
    class(ice_test_cpl_adapter) :: this
    
    ! I -> O : 1
    call this % register_array(arr_name = "ice2ocn1", arr = ice2ocn(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "SEND_MP", dst = "OCN", dh = 2)

    ! O -> I : 1
    call this % register_array(arr_name = "ocn2ice1", arr = ocn2ice(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "RECV_MP", src = "OCN", dh = 4)   

    ! A -> I : 1
    call this % register_array(arr_name = "atm2ice1", arr = atm2ice(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ice1", act = "RECV_MP", src = "ATM", dh = 1)   
    
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "SAVE_DG", dh = 4)    
    call this % register_periodic_event(arr_name = "atm2ice1", act = "SAVE_DG", dh = 1)    
    
end subroutine

!========================================================================================

subroutine test_3_3way_aoi_atm_file_big(this)
    class(ice_test_cpl_adapter) :: this
! 
    ! I -> O : 4
    call this % register_array(arr_name = "ice2ocn1", arr = ice2ocn(:,:,1), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn2", arr = ice2ocn(:,:,2), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn3", arr = ice2ocn(:,:,3), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn4", arr = ice2ocn(:,:,4), indexing = "ij")        
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "ice2ocn2", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "ice2ocn3", act = "SEND_MP", dst = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "ice2ocn4", act = "SEND_MP", dst = "OCN", dh = 2)

    ! I <- O : 5
    call this % register_array(arr_name = "ocn2ice1", arr = ocn2ice(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice2", arr = ocn2ice(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice3", arr = ocn2ice(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice4", arr = ocn2ice(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice5", arr = ocn2ice(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "RECV_MP", src = "OCN", dh = 1)   
    call this % register_periodic_event(arr_name = "ocn2ice2", act = "RECV_MP", src = "OCN", dh = 1)   
    call this % register_periodic_event(arr_name = "ocn2ice3", act = "RECV_MP", src = "OCN", dh = 3)   
    call this % register_periodic_event(arr_name = "ocn2ice4", act = "RECV_MP", src = "OCN", dh = 3)   
    call this % register_periodic_event(arr_name = "ocn2ice5", act = "RECV_MP", src = "OCN", dh = 4)   
  
    ! A -> I : 3
    call this % register_array(arr_name = "atm2ice1", arr = atm2ice(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ice2", arr = atm2ice(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "atm2ice3", arr = atm2ice(:,:,3), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ice1", act = "RECV_MP", src = "ATM", dh = 1)   
    call this % register_periodic_event(arr_name = "atm2ice2", act = "RECV_MP", src = "ATM", dh = 2)   
    call this % register_periodic_event(arr_name = "atm2ice3", act = "RECV_MP", src = "ATM", dh = 2)   
    call this % register_periodic_event(arr_name = "atm2ice1", act = "SAVE_DG", dh = 1) 
    call this % register_periodic_event(arr_name = "atm2ice2", act = "SAVE_DG", dh = 2) 
    call this % register_periodic_event(arr_name = "atm2ice3", act = "SAVE_DG", dh = 2) 

    
end subroutine

subroutine test_4_3way_aoi_full(this)
    class(ice_test_cpl_adapter) :: this
! 
    ! I -> O : 4
    call this % register_array(arr_name = "ice2ocn1", arr = ice2ocn(:,:,1), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn2", arr = ice2ocn(:,:,2), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn3", arr = ice2ocn(:,:,3), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn4", arr = ice2ocn(:,:,4), indexing = "ij")        
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "ice2ocn2", act = "SEND_MP", dst = "OCN", dh = 1)
    call this % register_periodic_event(arr_name = "ice2ocn3", act = "SEND_MP", dst = "OCN", dh = 2)
    call this % register_periodic_event(arr_name = "ice2ocn4", act = "SEND_MP", dst = "OCN", dh = 2)

    ! I -> A : 1
    call this % register_array(arr_name = "ice2atm1", arr = ice2atm(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ice2atm1", act = "SEND_MP", dst = "ATM", dh = 6)   
    
    ! O -> I : 5
    call this % register_array(arr_name = "ocn2ice1", arr = ocn2ice(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice2", arr = ocn2ice(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice3", arr = ocn2ice(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice4", arr = ocn2ice(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice5", arr = ocn2ice(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "RECV_MP", src = "OCN", dh = 1)   
    call this % register_periodic_event(arr_name = "ocn2ice2", act = "RECV_MP", src = "OCN", dh = 1)   
    call this % register_periodic_event(arr_name = "ocn2ice3", act = "RECV_MP", src = "OCN", dh = 3)   
    call this % register_periodic_event(arr_name = "ocn2ice4", act = "RECV_MP", src = "OCN", dh = 3)   
    call this % register_periodic_event(arr_name = "ocn2ice5", act = "RECV_MP", src = "OCN", dh = 4)   
  
    ! A -> I : 3
    call this % register_array(arr_name = "atm2ice1", arr = atm2ice(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "atm2ice2", arr = atm2ice(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "atm2ice3", arr = atm2ice(:,:,3), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ice1", act = "RECV_MP", src = "ATM", dh = 1)   
    call this % register_periodic_event(arr_name = "atm2ice2", act = "RECV_MP", src = "ATM", dh = 2)   
    call this % register_periodic_event(arr_name = "atm2ice3", act = "RECV_MP", src = "ATM", dh = 2)   
    call this % register_periodic_event(arr_name = "atm2ice1", act = "SAVE_DG", dh = 1) 
    call this % register_periodic_event(arr_name = "atm2ice2", act = "SAVE_DG", dh = 2) 
    call this % register_periodic_event(arr_name = "atm2ice3", act = "SAVE_DG", dh = 2) 

    
end subroutine
!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main before main time cycle.
! You should do there all preparation actions.
!----------------------------------------------------------------------------------------

subroutine ini_main(this)
    class(ice_test_cpl_adapter) :: this

    counter = 1
    
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program in time cycle. Should represent one time step of
! your model with all physics and internal exhanges (like halo MPI-updates).
!----------------------------------------------------------------------------------------

subroutine make_step(this)
    class(ice_test_cpl_adapter) :: this
    integer :: k
    
    do k = 1, dec % k_size()
        ice2ocn(:,:,k) = ice2ocn(:,:,k) + k + REAL(counter)*0.001
        ice2atm(:,:,k) = ice2atm(:,:,k) + k + REAL(counter)*0.001
    end do    
        
    counter = counter + 1
   
end subroutine

!========================================================================================
!----------------------------------------------------------------------------------------
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.
!----------------------------------------------------------------------------------------

subroutine finalize(this)        
    class(ice_test_cpl_adapter) :: this        
    
end subroutine

!========================================================================================

end module
    