!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module ocn_test_cpl_adapter_module

use component_module
use experiment_info_module
implicit none

type, extends(Component) :: ocn_test_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
    
    procedure, private :: test_1_3way_aoi_atm_file
    procedure, private :: test_2_3way_aoi_atm_file_dif_periods
    procedure, private :: test_3_3way_aoi_atm_file_big
    procedure, private :: test_4_3way_aoi_full
end type

    integer :: il, jl, kl, ml, steps_in_day
    logical :: read_cp
    integer :: iwest, ieast, jsouth, jnorth, step

    real, allocatable, dimension(:,:,:) :: ocn2ice, ice2ocn, atm2ocn, ocn2atm
    integer :: counter = 1
    
    type(Decomposition) :: dec
    
 CONTAINS

!========================================================================================
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model

subroutine ini_reg_comp(this)
    class(ocn_test_cpl_adapter) :: this
    
    character(100) :: input_namelist
    logical :: file_exists
    namelist /MAIN/ il, jl, kl, ml, steps_in_day, read_cp
    
    input_namelist = "./comp_ocn_test/"//TRIM(ExpInfo % exp_name())//".in"
    INQUIRE(file = input_namelist, exist = file_exists)
    if(file_exists) then
        open(9, file= input_namelist)
        read(9, nml = MAIN)
        close(9)
    else    
        call this % fatal_error("cant find input namelist: "//TRIM(input_namelist))
    end if
    
    ! Registration
    call this % register_model(i_size = il-2, j_size = jl-2, k_size = kl, decomp_type = "2D", timestep_sec = 60*60)
                
    dec = ModelsInfo(CompSplitter % i_am_id()) % decomp()
    iwest = dec % west() + 1
    ieast = dec % east() + 1
    jsouth = dec % south() + 1
    jnorth = dec % north() + 1 
    step = 1
    
end subroutine

!========================================================================================
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data use adresses of your arrays and 
! they should be allocated at time of registration.

subroutine ini_allocate(this)
    class(ocn_test_cpl_adapter) :: this

    allocate(ocn2ice(iwest:ieast,jsouth:jnorth, dec % k_size())); ocn2ice = 0
    allocate(ocn2atm, source = ocn2ice)
    allocate(ice2ocn, source = ocn2ice)
    allocate(atm2ocn, source = ocn2ice)
    
end subroutine

!========================================================================================
! Will be called by main to get all data you want to register.
! There you should call this % register_array and this % register_events.

subroutine ini_reg_data(this)
    class(ocn_test_cpl_adapter) :: this
    
    integer :: i, j, k
    
    counter = 1
    do i = iwest, ieast
    do j = jsouth, jnorth
    do k = 1, dec % k_size()
        ocn2ice(i,j,k) = CompSplitter % i_am_id()*100 + k
    end do
    end do
    end do
    
    select case (TRIM(ExpInfo % exp_name()))
        case("aoi_1")
        call this % test_1_3way_aoi_atm_file()
        
        case("aoi_2")
        call this % test_2_3way_aoi_atm_file_dif_periods()
        
        case("aoi_3")
        call this % test_3_3way_aoi_atm_file_big()
    
        case("aoi_4")
        call this % test_4_3way_aoi_full()
    end select

end subroutine

!========================================================================================

subroutine test_1_3way_aoi_atm_file(this)
    class(ocn_test_cpl_adapter) :: this

    ! O -> I : 1
    call this % register_array(arr_name = "ocn2ice1", arr = ocn2ice(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "SEND_MP", dst = "ICE", dh = 4)     
      
    ! I -> O : 1
    call this % register_array(arr_name = "ice2ocn1", arr = ice2ocn(:,:,1), indexing = "ij")        
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "RECV_MP", src = "ICE", dh = 2)  
   
    ! A -> O : 1
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 1)  
   
!     call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dh = 1)
!     call this % register_periodic_event(arr_name = "ice2ocn1", act = "SAVE_DG", dh = 1)
    
end subroutine

subroutine test_2_3way_aoi_atm_file_dif_periods(this)
    class(ocn_test_cpl_adapter) :: this

    ! O -> I : 1
    call this % register_array(arr_name = "ocn2ice1", arr = ocn2ice(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "SEND_MP", dst = "ICE", dh = 4)     
      
    ! I -> O : 1
    call this % register_array(arr_name = "ice2ocn1", arr = ice2ocn(:,:,1), indexing = "ij")        
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "RECV_MP", src = "ICE", dh = 2)  
   
    ! A -> O : 1
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 3)  
   
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dh = 3)
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "SAVE_DG", dh = 2)
    
end subroutine

!========================================================================================

subroutine test_3_3way_aoi_atm_file_big(this)
    class(ocn_test_cpl_adapter) :: this

    ! O -> I : 5
    call this % register_array(arr_name = "ocn2ice1", arr = ocn2ice(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice2", arr = ocn2ice(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice3", arr = ocn2ice(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice4", arr = ocn2ice(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice5", arr = ocn2ice(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "SEND_MP", dst = "ICE", dh = 1)     
    call this % register_periodic_event(arr_name = "ocn2ice2", act = "SEND_MP", dst = "ICE", dh = 1)     
    call this % register_periodic_event(arr_name = "ocn2ice3", act = "SEND_MP", dst = "ICE", dh = 3)     
    call this % register_periodic_event(arr_name = "ocn2ice4", act = "SEND_MP", dst = "ICE", dh = 3)     
    call this % register_periodic_event(arr_name = "ocn2ice5", act = "SEND_MP", dst = "ICE", dh = 4)     

    ! O <- I : 4
    call this % register_array(arr_name = "ice2ocn1", arr = ice2ocn(:,:,1), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn2", arr = ice2ocn(:,:,2), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn3", arr = ice2ocn(:,:,3), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn4", arr = ice2ocn(:,:,4), indexing = "ij")        
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "RECV_MP", src = "ICE", dh = 1)  
    call this % register_periodic_event(arr_name = "ice2ocn2", act = "RECV_MP", src = "ICE", dh = 1)  
    call this % register_periodic_event(arr_name = "ice2ocn3", act = "RECV_MP", src = "ICE", dh = 2)  
    call this % register_periodic_event(arr_name = "ice2ocn4", act = "RECV_MP", src = "ICE", dh = 2)  
    
    ! A -> O : 2
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")        
    call this % register_array(arr_name = "atm2ocn2", arr = atm2ocn(:,:,2), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 1)  
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "RECV_MP", src = "ATM", dh = 2)  
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SAVE_DG", dh = 2)
    
    
end subroutine


subroutine test_4_3way_aoi_full(this)
    class(ocn_test_cpl_adapter) :: this

    ! O -> I : 5
    call this % register_array(arr_name = "ocn2ice1", arr = ocn2ice(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice2", arr = ocn2ice(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice3", arr = ocn2ice(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice4", arr = ocn2ice(:,:,4), indexing = "ij")
    call this % register_array(arr_name = "ocn2ice5", arr = ocn2ice(:,:,5), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2ice1", act = "SEND_MP", dst = "ICE", dh = 1)     
    call this % register_periodic_event(arr_name = "ocn2ice2", act = "SEND_MP", dst = "ICE", dh = 1)     
    call this % register_periodic_event(arr_name = "ocn2ice3", act = "SEND_MP", dst = "ICE", dh = 3)     
    call this % register_periodic_event(arr_name = "ocn2ice4", act = "SEND_MP", dst = "ICE", dh = 3)     
    call this % register_periodic_event(arr_name = "ocn2ice5", act = "SEND_MP", dst = "ICE", dh = 4)     

    ! O -> A : 4
    call this % register_array(arr_name = "ocn2atm1", arr = ocn2atm(:,:,1), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm2", arr = ocn2atm(:,:,2), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm3", arr = ocn2atm(:,:,3), indexing = "ij")
    call this % register_array(arr_name = "ocn2atm4", arr = ocn2atm(:,:,4), indexing = "ij")
    call this % register_periodic_event(arr_name = "ocn2atm1", act = "SEND_MP", dst = "ATM", dh = 4)   
    call this % register_periodic_event(arr_name = "ocn2atm2", act = "SEND_MP", dst = "ATM", dh = 4)   
    call this % register_periodic_event(arr_name = "ocn2atm3", act = "SEND_MP", dst = "ATM", dh = 8)   
    call this % register_periodic_event(arr_name = "ocn2atm4", act = "SEND_MP", dst = "ATM", dh = 8)       
    
    ! O <- I : 4
    call this % register_array(arr_name = "ice2ocn1", arr = ice2ocn(:,:,1), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn2", arr = ice2ocn(:,:,2), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn3", arr = ice2ocn(:,:,3), indexing = "ij")        
    call this % register_array(arr_name = "ice2ocn4", arr = ice2ocn(:,:,4), indexing = "ij")        
    call this % register_periodic_event(arr_name = "ice2ocn1", act = "RECV_MP", src = "ICE", dh = 1)  
    call this % register_periodic_event(arr_name = "ice2ocn2", act = "RECV_MP", src = "ICE", dh = 1)  
    call this % register_periodic_event(arr_name = "ice2ocn3", act = "RECV_MP", src = "ICE", dh = 2)  
    call this % register_periodic_event(arr_name = "ice2ocn4", act = "RECV_MP", src = "ICE", dh = 2)  
    
    ! A -> O : 2
    call this % register_array(arr_name = "atm2ocn1", arr = atm2ocn(:,:,1), indexing = "ij")        
    call this % register_array(arr_name = "atm2ocn2", arr = atm2ocn(:,:,2), indexing = "ij")        
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "RECV_MP", src = "ATM", dh = 1)  
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "RECV_MP", src = "ATM", dh = 2)  
    call this % register_periodic_event(arr_name = "atm2ocn1", act = "SAVE_DG", dh = 1)
    call this % register_periodic_event(arr_name = "atm2ocn2", act = "SAVE_DG", dh = 2)
    
    
end subroutine
!========================================================================================
! Will be called by main before main time cycle.
! You should do there all preparation actions.

subroutine ini_main(this)
    class(ocn_test_cpl_adapter) :: this

    counter = 1
    
end subroutine

!========================================================================================
! Will be called by main program in time cycle.
! You can control time by global Timer object.

subroutine make_step(this)
    class(ocn_test_cpl_adapter) :: this
    integer :: k
    
    do k = 1, dec % k_size()
        ocn2atm(:,:,k) = ocn2atm(:,:,k) + k + REAL(counter)*0.001
        ocn2ice(:,:,k) = ocn2atm(:,:,k) + k + REAL(counter)*0.001
    end do    

    counter = counter + 1
        
end subroutine

!========================================================================================
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.

subroutine finalize(this)        
    class(ocn_test_cpl_adapter) :: this        
    
    
end subroutine

!========================================================================================

end module
    