!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================

module ocn_test_cpl_adapter_module

use component_module
use experiment_info_module
implicit none

type, extends(Component) :: ocn_test_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
end type

    real, allocatable :: save_dg_2D(:,:), save_dg_3D(:,:,:)
    integer :: iwest, ieast, jsouth, jnorth, step
    integer :: counter
    
 CONTAINS

!========================================================================================
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model

subroutine ini_reg_comp(this)
    class(ocn_test_cpl_adapter) :: this
    type(Decomposition) :: dec
    
    dec = Decomposition(180, 90, 49, "2D", CompSplitter % comm_local_size(), CompSplitter % rank_local())
    
    ! Call registration routine of CMF (it needs only size of grid and timestep in whole(!) seconds)
    call this % register_model(decomp = dec, timestep_sec = 60*60)     
    
    iwest = dec % west() + 1
    ieast = dec % east() + 1
    jsouth = dec % south() + 1
    jnorth = dec % north() + 1 
    step = 1
    
end subroutine

!========================================================================================
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data use adresses of your arrays and 
! they should be allocated at time of registration.

subroutine ini_allocate(this)
    class(ocn_test_cpl_adapter) :: this

    allocate(save_dg_2D(    iwest-1:ieast+1, jsouth-1:jnorth+1)); save_dg_2D = 0
    allocate(save_dg_3D(49, iwest-1:ieast+1, jsouth-1:jnorth+1)); save_dg_3D = 0

end subroutine

!========================================================================================
! Will be called by main to get all data you want to register.
! There you should call this % register_array and this % register_events.

subroutine ini_reg_data(this)
    class(ocn_test_cpl_adapter) :: this

    call this % register_array(arr_name = "test_dg_2D", indexing = "ij", arr = save_dg_2D(iwest:ieast, jsouth:jnorth))
    call this % register_array(arr_name = "test_dg_3D", indexing = "kij", arr = save_dg_3D(:, iwest:ieast, jsouth:jnorth))
    call this % register_periodic_event(arr_name = "test_dg_2D", act = "SAVE_DG", dh = 1)
    call this % register_periodic_event(arr_name = "test_dg_3D", act = "SAVE_DG", dh = 1)

    
end subroutine

!========================================================================================
! Will be called by main before main time cycle.
! You should do there all preparation actions.

subroutine ini_main(this)
    class(ocn_test_cpl_adapter) :: this

end subroutine

!========================================================================================
! Will be called by main program in time cycle.
! You can control time by global Timer object.

subroutine make_step(this)
    class(ocn_test_cpl_adapter) :: this

    counter = counter + 1
    save_dg_2D = counter
    save_dg_3D = counter
    
end subroutine

!========================================================================================
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.

subroutine finalize(this)        
    class(ocn_test_cpl_adapter) :: this        

end subroutine

!========================================================================================

end module
    