#!/bin/bash

#
# Test with empty OCN component
#

COMPS_BUILD="ocn_test"
EXP="dg"

RUN_COMMAND[1]="-np 4 ./cpl.exe DTR 1 OCN 1 IOD 1 CPL 1 $EXP"

function prepare_run1 {
    rm -f ./data/OCN_TEST_${EXP}_DG_test_dg_2D.nc
    rm -f ./data/OCN_TEST_${EXP}_DG_test_dg_3D.nc
}

function assert1 {
    cp ./data/OCN_TEST_${EXP}_DG_test_dg_2D.nc test_dg_2D_sample.nc
    cp ./data/OCN_TEST_${EXP}_DG_test_dg_3D.nc test_dg_3D_sample.nc
    
    result="ok"
}

function compare_fields {

    output="$(cdo diff ./data/OCN_TEST_${EXP}_DG_test_dg_2D.nc ./test_dg_2D_sample.nc)"
    output="$(cdo diff ./data/OCN_TEST_${EXP}_DG_test_dg_3D.nc ./test_dg_3D_sample.nc)"
    
    if [[ $output == *"records differ"* ]]; then
        result="err"
    else
        result="ok"
    fi
}
    
RUN_COMMAND[2]="-np 5 ./cpl.exe DTR 1 OCN 2 IOD 1 CPL 1 ${EXP}"
function assert2 { 
    compare_fields 
}
 
RUN_COMMAND[3]="-np 5 ./cpl.exe DTR 1 OCN 1 IOD 1 CPL 2 ${EXP}"

function assert3 { 
    compare_fields 
}

RUN_COMMAND[4]="-np 5 ./cpl.exe DTR 1 OCN 2 IOD 1 CPL 1 ${EXP}"

function assert4 { 
    compare_fields 
}

RUN_COMMAND[5]="-np 6 ./cpl.exe DTR 1 OCN 2 IOD 1 CPL 2 ${EXP}"

function assert5 { 
    compare_fields 
    rm -f ./data/OCN_TEST_${EXP}_DG_test_dg_2D.nc
    rm -f ./data/OCN_TEST_${EXP}_DG_test_dg_3D.nc    
}
 










