!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence. 
! Fill them with appropriate actions, suitable for your model.
!========================================================================================
#define main_kind 4


module ocn_test_cpl_adapter_module

use component_module
use experiment_info_module
implicit none


type, extends(Component) :: ocn_test_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data    
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize 
end type
    real*8, allocatable ::  x1_t(:,:), x2_t(:,:)
    real (kind=main_kind), allocatable :: t_f(:,:,:,:)
    real (kind=8), allocatable :: ssl_f(:,:)
    integer :: iwest, ieast, jsouth, jnorth, step
    integer :: kl=49, il=360 , jl=180, i,j,k

 CONTAINS

!========================================================================================
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and 
! must call this % register_model

subroutine ini_reg_comp(this)
    class(ocn_test_cpl_adapter) :: this
    type(Decomposition) :: dec
    
    ! Registration
    dec = Decomposition(il, jl, kl , "2D", CompSplitter % comm_local_size(CompSplitter % i_am()), CompSplitter % rank_local() )
    call this % register_model(dec, timestep_sec = 6*60*60)
    dec = ModelsInfo(CompSplitter % i_am_id()) % decomp()
    iwest = dec % west() + 1
    ieast = dec % east() + 1
    jsouth = dec % south() + 1
    jnorth = dec % north() + 1
    step = 1
end subroutine

!========================================================================================
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data use adresses of your arrays and 
! they should be allocated at time of registration.

subroutine ini_allocate(this)
    implicit none
    class(ocn_test_cpl_adapter) :: this
    allocate(t_f  ( 1:kl,   iwest:ieast, jsouth:jnorth, 1:2)); t_f(:,:,:,1) = 20.;      t_f(:,:,:,2) = 35.
    allocate(ssl_f  (iwest:ieast, jsouth:jnorth ) ); ssl_f(:,:) = 0.0;
    allocate(x1_t(    il, jl) ); x1_t = 0.
    allocate(x2_t(    il, jl) ); x2_t = 0.

    call this % register_array(arr_name = "x1_t", indexing = "ij", arr = x1_t( iwest:ieast, jsouth:jnorth))
    call this % register_array(arr_name = "x2_t", indexing = "ij", arr = x2_t( iwest:ieast, jsouth:jnorth))

    call this % register_array(arr_name = "t_f", indexing = "kij", arr = t_f(1:kl, iwest:ieast, jsouth:jnorth, 1))
    call this % register_array(arr_name = "s_f", indexing = "kij", arr = t_f(1:kl, iwest:ieast, jsouth:jnorth, 2))
    call this % register_array(arr_name = "ssl_f", indexing = "ij", arr = ssl_f  ( iwest:ieast, jsouth:jnorth))



end subroutine

!========================================================================================
! Will be called by main to get all data you want to register.
! There you should call this % register_array and this % register_events.

subroutine ini_reg_data(this)
    class(ocn_test_cpl_adapter) :: this


    call  ini_reg_data_ic(this, iwest, ieast, jsouth, jnorth)

    write(*,*), "before_send_enkf"
    call this % register_periodic_event(arr_name = "x1_t",  act = "SEND_DAS", dh = 24)
    call this % register_periodic_event(arr_name = "x2_t",  act = "SEND_DAS", dh = 24)

    call this % register_periodic_event(arr_name = "t_f",   act = "SEND_DAS", dh = 24)
    call this % register_periodic_event(arr_name = "ssl_f", act = "SEND_DAS", dh = 24)
    call this % register_periodic_event(arr_name = "s_f",   act = "SEND_DAS", dh = 24)

    !call this % register_periodic_event(arr_name = "t_f", act = "RECV_AOI", dh = 24)
    !call this % register_periodic_event(arr_name = "s_f", act = "RECV_AOI", dh = 24)

    call this % register_periodic_event(arr_name = "s_f",   act = "RECV_ENKF", dh = 24)
    call this % register_periodic_event(arr_name = "t_f",   act = "RECV_ENKF", dh = 24)
    call this % register_periodic_event(arr_name = "ssl_f", act = "RECV_ENKF", dh = 24)


    call this % register_periodic_event(arr_name = "t_f", act = "SAVE_DG", dh = 24)
    call this % register_periodic_event(arr_name = "s_f", act = "SAVE_DG", dh = 24)
    call this % register_periodic_event(arr_name = "ssl_f", act = "SAVE_DG", dh = 24)

end subroutine

!========================================================================================
! Will be called by main before main time cycle.
! You should do there all preparation actions.

subroutine ini_main(this)
    class(ocn_test_cpl_adapter) :: this

    do i=1, il
        do j=1,jl
            x1_t(i,j) = real(i) - 115.
            x2_t(i,j) = real(j) - 80.
        enddo
    enddo


    do k = 1, kl
      do i=iwest, ieast
        do j=jsouth,jnorth
            !gt_f(k,i,j,1:2) = t_f(k,i,j,1:2) + 0.1 * mod( k, 10) + 0.1 * mod( j, 10 )
            !if ( i >= 99 .and. i <= 108 .and. j >=75 .and.j <= 82 ) t_f(1:kl, i,j, 1:2) = 0d0 !small island for testing
        enddo
      enddo
    enddo

end subroutine

!========================================================================================
! Will be called by main program in time cycle.
! You can control time by global Timer object.

subroutine make_step(this)
    class(ocn_test_cpl_adapter) :: this
    write(*,*),"OCN t_f",maxval(t_f),minval(t_f)
    write(*,*),"OCN t_f",maxval(ssl_f),minval(ssl_f)

end subroutine

!========================================================================================
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.

subroutine finalize(this)        
    class(ocn_test_cpl_adapter) :: this        

end subroutine

!========================================================================================
! Some ocean specific helpers
!========================================================================================

subroutine ini_reg_data_ic(this, w, e, s, n)
    class(Component), intent(in) :: this
    integer, intent(in) :: w, e, s, n

    call this % register_array(arr_name = "t_cp", arr = t_f(:, w:e, s:n, 1), indexing = "kij")
    call this % register_array(arr_name = "s_cp", arr = t_f(:, w:e, s:n, 2), indexing = "kij")
    call this % register_array(arr_name = "ssl_cp", arr = ssl_f( w:e, s:n), indexing = "ij")

    call this % register_periodic_event(arr_name = "t_cp",         act = "READ_CP")
    call this % register_periodic_event(arr_name = "s_cp",         act = "READ_CP")
    call this % register_periodic_event(arr_name = "ssl_cp",       act = "READ_CP")

end subroutine

!========================================================================================

end module

