!========================================================================================
! This is automatically generated adapter for CMF-system.
! WARNING: for correct work don't change any names generated by generate_comp.sh script.
!
! Subroutines will be called by main program in listed sequence.
! Fill them with appropriate actions, suitable for your model.
!========================================================================================
#define main_kind 4


module sea_test_cpl_adapter_module

use component_module
use experiment_info_module
implicit none


type, extends(Component) :: sea_test_cpl_adapter
 contains
    procedure :: ini_reg_comp
    procedure :: ini_allocate
    procedure :: ini_reg_data
    procedure :: ini_main
    procedure :: make_step
    procedure :: finalize
    procedure :: border_updater
end type
    real*8, allocatable ::  x1_t(:,:), x2_t(:,:)
    real (kind=main_kind), allocatable :: t_f(:,:,:,:)
    real (kind=main_kind), allocatable :: t_f_nst(:,:,:)
    integer :: iwest, ieast, jsouth, jnorth, step
    integer :: kl=1, il=100 , jl=100, i,j,k

 CONTAINS

!========================================================================================
! Will be called by main to register your model in the system.
! There you should (probably) read or define necessary information and
! must call this % register_model

subroutine ini_reg_comp(this)
    class(sea_test_cpl_adapter) :: this
    type(Decomposition) :: dec, dec_2

    ! Registration
    dec = Decomposition(il, jl, kl , "2D", CompSplitter % comm_local_size(CompSplitter % i_am()), CompSplitter % rank_local() )
    call this % register_model(dec, timestep_sec = 6*60*60)
    dec = ModelsInfo(CompSplitter % i_am_id()) % decomp()
    iwest = dec % west() + 1
    ieast = dec % east() + 1
    jsouth = dec % south() + 1
    jnorth = dec % north() + 1
    step = 1


end subroutine

!========================================================================================
! Will be called by main to allocate all your data, which will interact with system.
! This is necessary, because you ini_reg_data use adresses of your arrays and
! they should be allocated at time of registration.

subroutine ini_allocate(this)
    implicit none
    class(sea_test_cpl_adapter) :: this
    allocate(t_f  ( 1:kl,   iwest:ieast, jsouth:jnorth, 1:2)); t_f(:,:,:,1) = 17.;      t_f(:,:,:,2) = 30.
    allocate(x1_t(    il, jl) ); x1_t = 0.
    allocate(x2_t(    il, jl) ); x2_t = 0.
    allocate(t_f_nst  ( 1:kl,   iwest:ieast, jsouth:jnorth)); t_f_nst(:,:,:) = 17.


    call this % register_array(arr_name = "x1_t", indexing = "ij", arr = x1_t( iwest:ieast, jsouth:jnorth))
    call this % register_array(arr_name = "x2_t", indexing = "ij", arr = x2_t( iwest:ieast, jsouth:jnorth))

    call this % register_array(arr_name = "t_f", indexing = "kij", arr = t_f(1:kl, iwest:ieast, jsouth:jnorth, 1))
    call this % register_array(arr_name = "t_f_nst", indexing = "kij", arr = t_f_nst(1:kl, iwest:ieast, jsouth:jnorth))

end subroutine

!========================================================================================
! Will be called by main to get all data you want to register.
! There you should call this % register_array and this % register_events.

subroutine ini_reg_data(this)
    class(sea_test_cpl_adapter) :: this



    write(*,*), "SEA before_send_nst"
    call this % register_periodic_event(arr_name = "x1_t",  act = "SEND_NST", delay = 6*60*60)
    call this % register_periodic_event(arr_name = "x2_t",  act = "SEND_NST", delay = 6*60*60)
    call this % register_periodic_event(arr_name = "t_f_nst",act = "RECV_NST", dh=24, delay=12*60*60)
    call this % register_periodic_event(arr_name = "t_f",   act = "SAVE_DG", dh=24, delay = 18*60*60)



end subroutine

!========================================================================================
! Will be called by main before main time cycle.
! You should do there all preparation actions.

subroutine ini_main(this)
    class(sea_test_cpl_adapter) :: this

    do i=1, il
        do j=1,jl
            x1_t(i,j) = i * 0.1 - 100.
            x2_t(i,j) = j * 0.1 - 50.
        enddo
    enddo


    do k = 1, kl
        do i=iwest, ieast
            do j=jsouth,jnorth
                t_f(k,i,j,1) = 17.
                t_f(k,i,j,2) = 30.

                if (i == 2) t_f_nst(k,i,j)=t_f(k,i,j,1)
                if (i == il+1) t_f_nst(k,i,j)=t_f(k,i,j,1)
                if (j == 2) t_f_nst(k,i,j)=t_f(k,i,j,1)
                if (j == jl+1) t_f_nst(k,i,j)=t_f(k,i,j,1)

        enddo
      enddo
    enddo

end subroutine

subroutine border_updater(this)
    class(sea_test_cpl_adapter) :: this

    do k = 1, kl
        do j=jsouth,jnorth
            if (iwest == 2) t_f(k,2,j,1) = t_f_nst(k,2,j)
            if (ieast == il+1) t_f(k,ieast,j,1) = t_f_nst(k,ieast,j)
        enddo
        do i=iwest, ieast
            if (jsouth == 2) t_f(k,i,2,1) = t_f_nst(k,i,2)
            if (jnorth == jl+1) t_f(k,i,jnorth,1) = t_f_nst(k,i,jnorth)
        enddo
    enddo

end subroutine

!========================================================================================
! Will be called by main program in time cycle.
! You can control time by global Timer object.

subroutine make_step(this)
    class(sea_test_cpl_adapter) :: this

    call this % border_updater()

    write(*,*), step," sea t_f"!, t_f_nst!, CompSplitter %  rank_local(), t_f_nst

    t_f = t_f - 0.1
    step = step + 1
end subroutine

!========================================================================================
! Will be called by main program at the end.
! You can do there all postprocesing actions and memory deallocations.

subroutine finalize(this)
    class(sea_test_cpl_adapter) :: this

end subroutine

!========================================================================================
! Some ocean specific helpers
!========================================================================================

subroutine ini_reg_data_ic(this, w, e, s, n)
    class(Component), intent(in) :: this
    integer, intent(in) :: w, e, s, n
    call this % register_periodic_event(arr_name = "t_f", act = "SAVE_DG", dh = 24)

end subroutine

!========================================================================================

end module
