#!/bin/bash

#
# Test with empty OCN component
#

EXP_NAME=tst_sync
COMPS_BUILD="ocn_test"

RUN_COMMAND[1]="-np 4 ./cpl.exe DTR 1 OCN 1 IOD 1 CPL 1 $EXP_NAME"

function assert1 {
    cp ./data/OCN_TEST_${EXP_NAME}_DG_SNOW.nc test_snow_sample.nc
    
    result="ok"
}

function compare_fields {

    output="$(cdo diff ./data/OCN_TEST_${EXP_NAME}_DG_SNOW.nc ./test_snow_sample.nc)"
    
    if [[ $output == *"records differ"* ]]; then
        result="err"
    else
        result="ok"
    fi
}
    
RUN_COMMAND[2]="-np 5 ./cpl.exe DTR 1 OCN 2 IOD 1 CPL 1 $EXP_NAME"
function assert2 { 
    compare_fields 
}
#  
RUN_COMMAND[3]="-np 5 ./cpl.exe DTR 1 OCN 1 IOD 1 CPL 2 $EXP_NAME "

function assert3 { 
    compare_fields 
}
RUN_COMMAND[4]="-np 5 ./cpl.exe DTR 1 OCN 2 IOD 1 CPL 1 $EXP_NAME "

function assert4 { 
    compare_fields 
}

RUN_COMMAND[5]="-np 6 ./cpl.exe DTR 1 OCN 2 IOD 1 CPL 2 $EXP_NAME "

function assert5 { 
    compare_fields
    rm -f ./data/OCN_TEST_tst_sync_DG_SNOW.nc
}
 




















